<%@ Page Language="C#" MasterPageFile="~/WorkingArea.master" AutoEventWireup="true" CodeBehind="Networks_Physical.aspx.cs" Inherits="Eliwell.Go.Presentation.Web.Settings.Networks_Physical" %>

<%@ Register Src="~/UC/SubtabMenuNetworks.ascx" TagName="SubtabMenuNetworks" TagPrefix="uc1" %>
<%@ Register Src="~/UC/PageTitle.ascx" TagName="PageTitle" TagPrefix="ucPageTitle" %>
<%@ Register Src="~/UC/GeneralMessage.ascx" TagName="GeneralMessage" TagPrefix="ucGeneralMessage" %>
<%@ Register Src="~/UC/NetworkGridControl.ascx" TagName="NetworksGrid" TagPrefix="uc2" %>
<%@ Register Src="~/UC/NetworkFilter.ascx" TagName="NetworkFilter" TagPrefix="ucNetworkFilter" %>
<%@ Register Src="~/Settings/Networks_Physical_UcToolbar.ascx" TagName="ToolBar" TagPrefix="ucToolBar" %>
<%@ Register Src="~/UC/PopupStartStop.ascx" TagName="PopupStartStop" TagPrefix="ucPopupStartStop" %>
<%@ Register Src="~/UC/PopupGenericFrame.ascx" TagName="PopupGenericFrame" TagPrefix="ucPopupGenericFrame" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ToolbarArea" runat="Server">

    <style type="text/css">
        
            table.sgnDevicesTable tr.row-selected th, 
            table.sgnDevicesTable tr.row-selected td {
                background-color:#FFFF99 /* #f7f75a; */
            }

         a.button-with-image {
            height: 18px;
            margin: 8px 10px 0px 10px;
            padding: 6px 15px 6px 28px;
            display: -moz-inline-stack;
            display: inline-block;
            font-size: 10px;
            line-height: 10px;
            font-weight: bold;
            color: #333333;
            background-color: transparent;
            background-repeat: no-repeat;
            background-position: 6px 4px;
        }
          
        #ButtonTemplateImportExport {
                background-image: url('/media/img/Networks/Devices/EditDevice.png');
            }
        </style>

    <ucToolBar:ToolBar ID="ToolBar1" runat="server" />

</asp:Content>

<asp:Content ID="Css1" ContentPlaceHolderID="CssArea" runat="Server">
    <asp:Literal ID="modalPopupCSSLink" runat="server"></asp:Literal>
    <link rel="stylesheet" href="/media/css/styleScrollableGrid.css" type="text/css" media="screen" />
</asp:Content>
<asp:Content runat="server" ID="topForm" ContentPlaceHolderID="TopForm">
    <ucPopupStartStop:PopupStartStop runat="server" ID="popupStartStop" />
    <ucPopupGenericFrame:PopupGenericFrame runat="server" ID="popupGenericFrame" />
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="FilterArea" runat="server">

     <h6><asp:Label ID="LabelApplicationTemplateHeader" runat="server"></asp:Label></h6>
        <table class="selectors">
            <tr>
                <td>
                    <select id="selectTemplate" name="selectTemplate">

                    </select>
                </td>
            </tr>
            <tr>
                <td>
                  <!-- watTemplateImportExport is required for wiring click event -->
                  <asp:LinkButton ID="ButtonTemplateImportExport" runat="server" Visible="True" CssClass="button-with-image watTemplateImportExport" />
                </td>
            </tr>
        </table>


    <ucNetworkFilter:NetworkFilter ID="NetworkFilter1" runat="server" />

</asp:Content>
<asp:Content ID="Content3" ContentPlaceHolderID="ContentArea" runat="Server">

    <asp:Literal runat="server" ID="LiteralJsStartupData"></asp:Literal>

    <script language="JavaScript" type="text/JavaScript">
            ////<![CDATA[

           window.addEvent('domready', function () {

               networkExt.gridExt.initialize();

           });

           var networkExt = networkExt || {};

           networkExt.gridExt = (function () {  // networkExt.gridExt BEGIN

               // PRIVATE FIELDS
               var _selectTemplates = null;
               var _linkButtonGridExpandAll = null;
               var _linkButtonGridCollapseAll = null; 
               var _linkButtonGridClearFilter = null;
               var _linkButtonContextActionApplyTemplateToDevices = null;
               var _linkButtonContextActionSaveDevicesDescription = null;
               var _linkButtonContextActionCopyDevice = null;
               var _linkButtonContextActionCancel = null;
               var _linkButtonEditDevicesDescription = null;
               var _linkButtonImportExportTemplate = null;
               var _linkButtonImportExportSnapshot = null;

               // acquisition running is a special state wich disables 
               var STATE_ACQUISITION_RUNNING = "state_acquisition_running";
               // the initial state when acquisition is not running
               var STATE_INITIAL = "state_initial";
               // the combo templete has a selection
               var STATE_TEMPLATE_SELECTED = "state_template_selected";
               // the used clicked edit on the toolbar
               var STATE_EDIT = "state_edit";
               // the user clicked on a row copy icon
               var STATE_COPYING = "state_copying";

               var _state = STATE_ACQUISITION_RUNNING; // initial default state, is suddenly modified in initialize

               return {
                   initialize: initialize,
               }

               function initialize() {

                   _selectTemplates = document.getElement('#selectTemplate');
                   _linkButtonGridExpandAll = $$('.watGridExpandAll')[0];
                   _linkButtonGridCollapseAll = $$('.watGridCollapseAll')[0];
                   _linkButtonGridClearFilter = document.getElement('td.dosome a.watGridClearFilter');

                   _linkButtonContextActionApplyTemplateToDevices = $$('a.watContextActionApplyTemplateToDevices')[0];
                   _linkButtonContextActionSaveDevicesDescription = $$('a.watContextActionSaveDevicesDescription')[0];
                   _linkButtonContextActionCopyDevice             = $$('a.watContextActionCopyDevice')[0];
                   _linkButtonContextActionCancel                 = $$('a.watContextActionCancel')[0];

                   _linkButtonEditDevicesDescription = $$('a.watEditDevicesDescription')[0];
                   _linkButtonImportExportTemplate = $$('a.watTemplateImportExport')[0];
                   _linkButtonImportExportSnapshot = $$('a.watTakeSnapshot')[0];

                   wireToolbarEvent();
                   wireEditAndCopyDeviceInGridRowButtonClickedEvent();
                   wireDeviceCheckboxCheckedCahngedEvent();

                   fillTemplateDropDownAndWireEvents();

                   setStateByUserInput();
                   setVisibilityByState();
               }

               // EVENT WIRING     

               function fillTemplateDropDownAndWireEvents() {
                   // first row "initialEmptyTemplate" is always present
                   var optionEl = new Element('option', {
                       html: startUpData.initialEmptyTemplate.TemplateName,
                       value: -1 // a value to detect the initialEmptyTemplate
                   });
                   optionEl.inject(_selectTemplates);

                   var index = 0; // correspond to the zero based position on array of templates

                   startUpData.templates.each(function (template) {
                       var optionEl = new Element('option', {
                           html: template.TemplateName,
                           value: index
                       });

                       optionEl.inject(_selectTemplates);

                       index++;
                   });

                   // wire the event after the select was popupulated by data
                   _selectTemplates.addEvent('change', function (event) {
                       setStateByUserInput();
                       setVisibilityByState();
                   });

               } // fillTemplateDropDownAndWireEvents

               function wireToolbarEvent() {
                   if (_linkButtonContextActionCancel) {
                       _linkButtonContextActionCancel.addEvent('click', onContextActionCancel);
                       _linkButtonContextActionCancel.onclick = function () { return false; };
                   }

                   if (_linkButtonContextActionApplyTemplateToDevices) {
                       _linkButtonContextActionApplyTemplateToDevices.addEvent('click', onContextActionApplyTemplateToDevices);
                       _linkButtonContextActionApplyTemplateToDevices.onclick = function () { return false; };
                   }

                   if (_linkButtonContextActionSaveDevicesDescription) {
                       _linkButtonContextActionSaveDevicesDescription.addEvent('click', onContextActionSaveDevicesDescription);
                       _linkButtonContextActionSaveDevicesDescription.onclick = function () { return false; };
                   }

                   if (_linkButtonContextActionCopyDevice) {
                       _linkButtonContextActionCopyDevice.addEvent('click', onContextActionCopyDevice);
                       _linkButtonContextActionCopyDevice.onclick = function () { return false; };
                   }
                   
                   if (_linkButtonEditDevicesDescription) {
                       _linkButtonEditDevicesDescription.addEvent('click', onEditDevicesDescription);
                       _linkButtonEditDevicesDescription.onclick = function () { return false; };
                   }

                   if (_linkButtonImportExportTemplate) {
                       _linkButtonImportExportTemplate.addEvent('click', onImportExportTemplate);
                       _linkButtonImportExportTemplate.onclick = function () { return false; };
                   }

                   if (_linkButtonImportExportSnapshot) {
                       _linkButtonImportExportSnapshot.addEvent('click', onImportExportSnapshot);
                       _linkButtonImportExportSnapshot.onclick = function () { return false; };
                   }
               }

               function wireEditAndCopyDeviceInGridRowButtonClickedEvent()
               {
                   $$('.edit-device').addEvent('click', onEditDeviceInGridRowButtonClicked);
                   $$('.copy-device').addEvent('click', onCopyDeviceInGridRowButtonClicked);
               }

               function wireDeviceCheckboxCheckedCahngedEvent() {
                   $$('.sgnSelector').addEvent('click', function (e) {
                       onDeviceCheckboxChechedChanged(e.target);
                   });
               }

               // FUNCTION THAT RESPONDS TO WIRED EVENTS


               function onContextActionCancel()
               {
                   _selectTemplates.set('value', -1);
                   setStateByUserInput();
                   setVisibilityByState();
               }

               function onEditDevicesDescription()
               {
                   _state = STATE_EDIT;
                   setVisibilityByState();
               }

               function onImportExportTemplate()
               {
                   networkExt.genericPopup.openPopup("Networks_Physical_PopupImportExportTemplate.aspx", 700, 500, false, true);
               }

               function onImportExportSnapshot()
               {
                   networkExt.genericPopup.openPopup("Networks_Physical_PopupImportExportSnapshot.aspx", 700, 300, true);
               }

               function onEditDeviceInGridRowButtonClicked(item) {
                   var deviceId = item.target.id.replace("editdev", ""); // item.target.id = editdev0.00_01
                   networkExt.genericPopup.openPopup("Networks_Physical_PopupEditDevice.aspx?deviceIdForEdit=" + deviceId, 860, 500, false, true);
               }

               function onCopyDeviceInGridRowButtonClicked(item) {

                   var inputItem = item.target;
                   var rowItem = inputItem.parent;
                   var tdItem = inputItem.parentElement;
                   rowItem.addClass("row-highlighted-for-copy");

                   _state = STATE_COPYING;
                   setVisibilityByState();
               }

               function onDeviceCheckboxChechedChanged(itemInput) {
                    
                   var itemTd = itemInput.parentElement;

                   var parentRow = itemInput.parent;
                   if (itemInput.checked) {
                       if (_state == STATE_COPYING)
                           parentRow.addClass('row-selected-for-paste');
                       else
                           parentRow.addClass('row-selected');
                   }
                   else {
                       parentRow.removeClass('row-selected');
                       parentRow.removeClass('row-selected-for-paste');
                   }
               }

               // FUNCTION THAT RESPONDS TO WIRED EVENTS (WRAPPING A POSTBACK)
                
               function onContextActionSaveDevicesDescription()
               {
                   networkExt.genericPopup.openPopup("../UC/PopupGenericFrameWait.aspx", 350, 300, true);
                   
                   __doPostBack(_linkButtonContextActionSaveDevicesDescription.id, '');
               }

               function onContextActionCopyDevice() {

                   // deviceIdComplete is ifc0:dev0.00_01
                   var deviceIdComplete = $$('.row-highlighted-for-copy')[0].id;
                   // deviceId is 0.00_01
                   var deviceId = deviceIdComplete.split(':')[1].replace('dev', '');

                   
                   networkExt.genericPopup.openPopup("../UC/PopupGenericFrameWait.aspx", 350, 300, true);
                   

                   __doPostBack(_linkButtonContextActionCopyDevice.id, 'deviceId:' + deviceId);


               }

               function onContextActionApplyTemplateToDevices()
               { 
                   var index = _selectTemplates.value;
                   if (index < 0) {
                       console.log('not valid template index');
                       return;
                   }

                   networkExt.genericPopup.openPopup("../UC/PopupGenericFrameWait.aspx", 350, 300, true);

                   var template = startUpData.templates[index];
                   __doPostBack(_linkButtonContextActionApplyTemplateToDevices.id, 'templateId:' + template.TemplateIndex);
               }

               // UI STATE MACHINE CONTROLLER

               function setStateByUserInput() {

                   if (startUpData.acquisitionRunning) {
                       _state = STATE_ACQUISITION_RUNNING; 
                   }
                   else {
                       // get the dropdown state and the textbox state
                       var selectedValue = _selectTemplates.value;

                       if (selectedValue == -1) {
                           _state = STATE_INITIAL;
                       }
                       else {
                           _state = STATE_TEMPLATE_SELECTED;
                       }
                   } 
               }

               function setVisibilityByState() {
                   switch (_state) {
                       case STATE_ACQUISITION_RUNNING:
                           _linkButtonGridExpandAll.setStyle('display', '');
                           _linkButtonGridCollapseAll.setStyle('display', '');
                           _linkButtonGridClearFilter.setStyle('display', 'none');
                           _linkButtonContextActionApplyTemplateToDevices.setStyle('display', 'none'); 
                           _linkButtonContextActionSaveDevicesDescription.setStyle('display', 'none');
                           _linkButtonContextActionCopyDevice.setStyle('display', 'none');
                           _linkButtonContextActionCancel.setStyle('display', 'none');
                           _linkButtonEditDevicesDescription.setStyle('display', 'none');
                           _linkButtonImportExportTemplate.setStyle('display', '');
                           _linkButtonImportExportSnapshot.setStyle('display', 'none');

                           _selectTemplates.set('disabled', 'disabled');
                           setGridCheckVisibilityAndRowSelectionForCopy(false, false);
                           setGridTextEditMode(false);
                           setCopyEditButtonVisibility(false);
                           break;
                       case STATE_INITIAL:
                           _linkButtonGridExpandAll.setStyle('display', '');
                           _linkButtonGridCollapseAll.setStyle('display', '');
                           _linkButtonGridClearFilter.setStyle('display', 'none');
                           _linkButtonContextActionApplyTemplateToDevices.setStyle('display', 'none'); 
                           _linkButtonContextActionSaveDevicesDescription.setStyle('display', 'none');
                           _linkButtonContextActionCopyDevice.setStyle('display', 'none');
                           _linkButtonContextActionCancel.setStyle('display', 'none');
                           _linkButtonEditDevicesDescription.setStyle('display', '');
                           _linkButtonImportExportTemplate.setStyle('display', '');
                           _linkButtonImportExportSnapshot.setStyle('display', '');

                           _selectTemplates.erase('disabled', '');
                           setGridCheckVisibilityAndRowSelectionForCopy(false, false);
                           setGridTextEditMode(false);
                           setCopyEditButtonVisibility(true);
                           break;
                       case STATE_TEMPLATE_SELECTED:
                           _linkButtonGridExpandAll.setStyle('display', 'none');
                           _linkButtonGridCollapseAll.setStyle('display', 'none');
                           _linkButtonGridClearFilter.setStyle('display', 'none');
                           _linkButtonContextActionApplyTemplateToDevices.setStyle('display', ''); 
                           _linkButtonContextActionSaveDevicesDescription.setStyle('display', 'none');
                           _linkButtonContextActionCopyDevice.setStyle('display', 'none');
                           _linkButtonContextActionCancel.setStyle('display', '');
                           _linkButtonEditDevicesDescription.setStyle('display', 'none');
                           _linkButtonImportExportTemplate.setStyle('display', '');
                           _linkButtonImportExportSnapshot.setStyle('display', 'none');

                           _selectTemplates.erase('disabled', '');
                           setGridCheckVisibilityAndRowSelectionForCopy(true, false);
                           setGridTextEditMode(false);
                           setCopyEditButtonVisibility(false);
                           break;
                       case STATE_EDIT:
                           _linkButtonGridExpandAll.setStyle('display', 'none');
                           _linkButtonGridCollapseAll.setStyle('display', 'none');
                           _linkButtonGridClearFilter.setStyle('display', 'none');
                           _linkButtonContextActionApplyTemplateToDevices.setStyle('display', 'none'); 
                           _linkButtonContextActionSaveDevicesDescription.setStyle('display', '');
                           _linkButtonContextActionCopyDevice.setStyle('display', 'none');
                           _linkButtonContextActionCancel.setStyle('display', '');
                           _linkButtonEditDevicesDescription.setStyle('display', 'none');
                           _linkButtonImportExportTemplate.setStyle('display', '');
                           _linkButtonImportExportSnapshot.setStyle('display', 'none');

                           _selectTemplates.set('disabled', 'disabled');
                           setGridCheckVisibilityAndRowSelectionForCopy(false, false);
                           setGridTextEditMode(true);
                           setCopyEditButtonVisibility(false);
                           break;
                       case STATE_COPYING:
                           _linkButtonGridExpandAll.setStyle('display', 'none');
                           _linkButtonGridCollapseAll.setStyle('display', 'none');
                           _linkButtonGridClearFilter.setStyle('display', 'none');
                           _linkButtonContextActionApplyTemplateToDevices.setStyle('display', 'none'); 
                           _linkButtonContextActionSaveDevicesDescription.setStyle('display', 'none');
                           _linkButtonContextActionCopyDevice.setStyle('display', '');
                           _linkButtonContextActionCancel.setStyle('display', '');
                           _linkButtonEditDevicesDescription.setStyle('display', 'none');
                           _linkButtonImportExportTemplate.setStyle('display', '');
                           _linkButtonImportExportSnapshot.setStyle('display', 'none');

                           _selectTemplates.set('disabled', 'disabled');
                           setGridCheckVisibilityAndRowSelectionForCopy(true, true);
                           setGridTextEditMode(false);
                           setCopyEditButtonVisibility(false);
                           break;
                   }
               }

               // UI WIDGET VISIBILITY OR ATTRIBUTES MODIFIERS

               function setGridCheckVisibilityAndRowSelectionForCopy(checkVisibile, keepRowSelectionForCopy) {

                   var items = $$('.sgnSelector');

                   items.each(function (item) {

                       item.parent.removeClass('row-selected');
                       item.parent.removeClass('row-selected-for-paste');

                       if (!keepRowSelectionForCopy)
                           item.parent.removeClass('row-highlighted-for-copy');
                            

                       if (checkVisibile) {
                           item.setStyle('visibility', 'visible');
                           item.removeAttribute('disabled');
                           item.checked = false;
                       }
                       else {
                           item.setStyle('visibility', 'collapse');
                       }
                   });
               }

               function setGridTextEditMode(enable) {

                   var grid = $$('.sgnInterfacesTable')[0];

                   if (grid) {
                       var elements = grid.getElements('input[type=text]');
                       if (enable) {
                           elements.each(function (item) {
                               item.removeAttribute('disabled');
                           });
                       }
                       else {
                           elements.each(function (item) {
                               item.set('disabled', 'disabled');
                               item.setStyle('color', 'black'); // disabled makes text gray, we want black
                               item.set('value', item.get('data-original'));
                           });
                       }
                   } // if grid
               }

               function setCopyEditButtonVisibility(enable)
               {
                   //copy-edit-button
                   var newValue = (enable) ? '' : 'collapse';
                   $$('.sgnDevicesTable input.copy-edit-button').setStyle('visibility', newValue);
               }

           })(); // networkExt.gridExt END

            //]]>
        </script>

    <ucGeneralMessage:GeneralMessage ID="GeneralMessage1" Type="Info" runat="server" />

    <uc2:NetworksGrid ID="NetworksGrid1" runat="server" />

</asp:Content>

<asp:Content ID="Content4" runat="server" ContentPlaceHolderID="SubtabsArea">
    <uc1:SubtabMenuNetworks ID="SubtabMenuNetworks1" runat="server" />
</asp:Content>
<asp:Content ID="Content5" runat="server" ContentPlaceHolderID="PageTitleArea">
    <ucPageTitle:PageTitle ID="PageTitle1" runat="server"></ucPageTitle:PageTitle>
</asp:Content>