USE master
ALTER DATABASE Televis SET RECOVERY SIMPLE

USE Televis
SET NOCOUNT ON
    
DECLARE @cleave DATETIME
DECLARE @deletedRows INT;
SET @deletedRows = 1;
SELECT @cleave = DATEADD(WEEK, -$(WEEKS), GETDATE()) 

-- Removing from HistoricalData
WHILE (@deletedRows > 0)
BEGIN		
    BEGIN TRANSACTION
        DELETE TOP (10000) FROM dbo.[HistoricalData] WHERE Timestamp < @cleave
        SET @deletedRows = @@ROWCOUNT;
    COMMIT TRANSACTION
    CHECKPOINT        
END

-- Removing from HistoricalDataEnergy
SET @deletedRows = 1;
WHILE (@deletedRows > 0)
BEGIN		
    BEGIN TRANSACTION
        DELETE TOP (10000) FROM dbo.[HistoricalDataEnergy] WHERE Timestamp < @cleave
        SET @deletedRows = @@ROWCOUNT;
    COMMIT TRANSACTION
    CHECKPOINT        
END

-- Removing from HistoricalDataQuick
IF (EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME = 'HistoricalDataQuick'))
BEGIN
	SET @deletedRows = 1;
	WHILE (@deletedRows > 0)
	BEGIN		
		BEGIN TRANSACTION
			DELETE TOP (10000) FROM dbo.[HistoricalDataQuick] WHERE Timestamp < @cleave
			SET @deletedRows = @@ROWCOUNT;
		COMMIT TRANSACTION
		CHECKPOINT        
	END
END

-- Removing from SequentialData
IF (EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME = 'SequentialData'))
BEGIN
    SET @deletedRows = 1;
    WHILE (@deletedRows > 0)
    BEGIN		
        BEGIN TRANSACTION
            DELETE TOP (10000) FROM dbo.SequentialData WHERE Timestamp < @cleave
            SET @deletedRows = @@ROWCOUNT;
        COMMIT TRANSACTION
        CHECKPOINT        
    END
END

-- Removing alarm instances
SET @deletedRows = 1;
WHILE (@deletedRows > 0)
BEGIN		
    BEGIN TRANSACTION
        DELETE TOP (10000) FROM dbo.[AlarmInstances] WHERE ([InstanceCreated] IS NULL OR [InstanceCreated] < @cleave)
        SET @deletedRows = @@ROWCOUNT;
    COMMIT TRANSACTION
    CHECKPOINT        
END

-- Removing site configurations
DELETE FROM dbo.[Sites] WHERE [ValidEndTime] < @cleave

-- Removing unaccessible data from HistoricalData (goes forward to the first full record).
DECLARE @newDataCleaveId INT;
DECLARE @oldestSiteId INT;
SET @oldestSiteId = (SELECT MIN(ID) FROM dbo.Sites)
SET @newDataCleaveId = (SELECT TOP(1) ID from dbo.HistoricalData WHERE ([Type]=1 AND IDRef=@oldestSiteId))
SET @deletedRows = 1;
WHILE (@deletedRows > 0)
BEGIN		
    BEGIN TRANSACTION
        DELETE TOP (10000) FROM dbo.[HistoricalData] WHERE ID < @newDataCleaveId
        SET @deletedRows = @@ROWCOUNT;
    COMMIT TRANSACTION
    CHECKPOINT        
END

SET NOCOUNT OFF

USE master
ALTER DATABASE Televis SET RECOVERY FULL
GOFFFFD95B