 USE master
ALTER DATABASE Televis SET RECOVERY SIMPLE

USE Televis
SET NOCOUNT ON
    
-- '20161023' is 2016 October the 23.  
-- 112 is the ISO yyyyMMdd
DECLARE @oldestDateToKeep DATETIME
SET @oldestDateToKeep = convert(datetime, '$(OLDESTDATETOKEEP)', 112);
   
DECLARE @deletedRows INT;
SET @deletedRows = 1;

-- Removing asynchronous from HistoricalData
WHILE (@deletedRows > 0)
BEGIN		
    BEGIN TRANSACTION
        DELETE TOP (10000) FROM dbo.[HistoricalData] WHERE ([Type]=3 OR [Type]=4) AND Timestamp < @oldestDateToKeep
        SET @deletedRows = @@ROWCOUNT;
    COMMIT TRANSACTION
    CHECKPOINT        
END

-- Removing asynchronous from HistoricalDataEnergy
SET @deletedRows = 1;
WHILE (@deletedRows > 0)
BEGIN		
    BEGIN TRANSACTION
        DELETE TOP (10000) FROM dbo.[HistoricalDataEnergy] WHERE ([Type]=3 OR [Type]=4) AND Timestamp < @oldestDateToKeep
        SET @deletedRows = @@ROWCOUNT;
    COMMIT TRANSACTION
    CHECKPOINT        
END

-- Removing alarm instances
SET @deletedRows = 1;
WHILE (@deletedRows > 0)
BEGIN		
    BEGIN TRANSACTION
        DELETE TOP (10000) FROM dbo.[AlarmInstances] WHERE [InstanceCreated] < @oldestDateToKeep
        SET @deletedRows = @@ROWCOUNT;
    COMMIT TRANSACTION
    CHECKPOINT        
END

SET NOCOUNT OFF

USE master
ALTER DATABASE Televis SET RECOVERY FULL
GOFFFF0CB3