USE Televis

DECLARE @sqlCmd nvarchar (4000)

-- Creates a view for data in the HistoricalData table that is older than 3 YEARS.
IF NOT EXISTS(SELECT [name] FROM sys.views WHERE [name] = 'ViewOldHistoricalData')
BEGIN   
    -- The following expression (included in view), is the minimum date between "3 years ago" and "the first week still present in the DB".
    SELECT @sqlCmd = 'CREATE VIEW [dbo].[ViewOldHistoricalData] AS
      (SELECT ID FROM [Televis].[dbo].[HistoricalData] WITH (NOLOCK)
      WHERE Timestamp <
            (SELECT CASE WHEN DATEADD(DAY, -1096, GETDATE()) > DATEADD(DAY, +7, (SELECT MIN([Timestamp]) FROM [dbo].[HistoricalData]))
                  THEN DATEADD(DAY, +7, (SELECT MIN([Timestamp]) FROM [dbo].[HistoricalData]))
                  ELSE DATEADD(DAY, -1096, GETDATE()) END AS MinDate))
'
    -- Must use "execute SQL command " because otherwise a "IF NOT EXISTS(...) CREATE VIEW" fails as the CREATE VIEW must be the first instruction of a block.
    EXEC sp_executesql @sqlCmd   
END

-- Removes oldest data from the HistoricalData table.
DELETE FROM [dbo].[ViewOldHistoricalData]
FFFF79A2