USE master
ALTER DATABASE Televis SET RECOVERY SIMPLE

USE Televis
SET NOCOUNT ON
    
DECLARE @twoWeeksAgo DATETIME
DECLARE @deletedRows INT;
SET @deletedRows = 1;
SELECT @twoWeeksAgo = DATEADD(WEEK, -2, GETDATE())

-- Removing asynchronous from HistoricalData
WHILE (@deletedRows > 0)
BEGIN		
    BEGIN TRANSACTION
        DELETE TOP (10000) FROM dbo.[HistoricalData] WHERE ([Type]=3 OR [Type]=4) AND Timestamp < @twoWeeksAgo
        SET @deletedRows = @@ROWCOUNT;
    COMMIT TRANSACTION
    CHECKPOINT        
END

-- Removing asynchronous from HistoricalDataEnergy
SET @deletedRows = 1;
WHILE (@deletedRows > 0)
BEGIN		
    BEGIN TRANSACTION
        DELETE TOP (10000) FROM dbo.[HistoricalDataEnergy] WHERE ([Type]=3 OR [Type]=4) AND Timestamp < @twoWeeksAgo
        SET @deletedRows = @@ROWCOUNT;
    COMMIT TRANSACTION
    CHECKPOINT        
END

-- Removing alarm instances
SET @deletedRows = 1;
WHILE (@deletedRows > 0)
BEGIN		
    BEGIN TRANSACTION
        DELETE TOP (10000) FROM dbo.[AlarmInstances] WHERE [InstanceCreated] < @twoWeeksAgo
        SET @deletedRows = @@ROWCOUNT;
    COMMIT TRANSACTION
    CHECKPOINT        
END

SET NOCOUNT OFF

USE master
ALTER DATABASE Televis SET RECOVERY FULL
GOFFFFCE76