/* Attaches to existing mdf/ldf files creating a new database */
USE [master]
GO
IF NOT EXISTS(SELECT [name] FROM sys.databases WHERE [name] = 'stiDB')
CREATE DATABASE [stiDB] ON 
( FILENAME = N'C:\HORUS CPIC\stiDB.mdf' ),
( FILENAME = N'C:\HORUS CPIC\stiDB_log.LDF' )
 FOR ATTACH
GO

/* Creates the Login */
IF NOT EXISTS(SELECT [name] FROM sys.sql_logins WHERE [name] = 'sothis')
	CREATE LOGIN [sothis] WITH PASSWORD=N'9d0V7F4p', DEFAULT_DATABASE=[stiDB], CHECK_EXPIRATION=OFF, CHECK_POLICY=OFF
GO

/* Creates the user within the Sothis DB and makes him db_owner */
USE [stiDB]
IF NOT EXISTS (SELECT [name] FROM sys.database_principals WHERE [name] = 'Sothis')
	CREATE USER [Sothis] FOR LOGIN [sothis] WITH DEFAULT_SCHEMA=[dbo]
ELSE
	EXEC sp_change_users_login 'Update_One', 'Sothis', 'sothis';

EXEC sp_addrolemember N'db_owner', N'Sothis'
ALTER AUTHORIZATION ON SCHEMA::[db_owner] TO [Sothis]
GO

/* Creates role and user for the Sothis login into the Televis database */
USE [Televis]
IF (SELECT DATABASE_PRINCIPAL_ID('SothisViewer')) IS NULL
	CREATE ROLE SothisViewer

GRANT SELECT ON dbo.SequentialData TO SothisViewer
GRANT SELECT ON dbo.HistoricalData TO SothisViewer
GRANT SELECT ON dbo.Sites TO SothisViewer
GRANT SELECT ON dbo.Devices TO SothisViewer

IF EXISTS(SELECT [name] FROM sys.views WHERE [name] = 'ViewOldSequentialData')
	GRANT SELECT ON [dbo].[ViewOldSequentialData] TO SothisViewer

IF NOT EXISTS (SELECT [name] FROM sys.database_principals WHERE [name] = 'Sothis')
	CREATE USER [Sothis] FOR LOGIN [sothis] WITH DEFAULT_SCHEMA=[dbo]

EXEC sp_addrolemember N'SothisViewer', N'Sothis'
FFFF84F0