﻿function startInvocation() {
    if ($('toolHistoricalFiller0')) {
        this.myHistoricalTable = new historicalTable();
    }
}

function nextInvocation(upTo) {
    if ($('toolHistoricalFiller' + this.myHistoricalTable.nextId)) {
        this.myHistoricalTable.next(upTo);
    }
}

function cancelInvocation() {
    this.myHistoricalTable.cancel();
}

var historicalTable = new Class
    (
    {
        initialize: function () {
            this.nextId = 0;

            var hiddenStartingRowCount = $('hiddenStartingRowCount');
            var startingRowCount = hiddenStartingRowCount.get('value');
            this.next(startingRowCount);
        },

        next: function (upTo) {
            // Hides previous links immediately (to prevent double-clicking).
            if ($defined($('cursorCommands' + (this.nextId)))) {
                $('cursorCommands' + (this.nextId)).setStyle('display', 'none');
            }

            // Shows loading message
            if ($defined($('loadingMessage' + (this.nextId)))) {
                $('loadingMessage' + (this.nextId)).setStyle('display', 'block');
            }

            var action = this.nextId == 0 ? "start" : "continue";
            var postBody = "modality=ajax"
                + "&exec=" + action
                + "&count=" + upTo
                + "&nextId=" + (this.nextId + 1);
            new Request({ url: '/HistoricalTableInvocation.rix', onComplete: this.injectNext.bindWithEvent(this) }).send(postBody);
        },

        cancel: function () {
            var postBody = "modality=ajax"
                + "&exec=cancel"
                + "&count=1"
                + "&nextId=" + (this.nextId + 1);

            new Request({ url: '/HistoricalTableInvocation.rix', onComplete: this.hideLoader.bindWithEvent(this) }).send(postBody);
        },

        injectNext: function (request) {
            this.hideLoader();

            var currentFiller = $('toolHistoricalFiller' + this.nextId);
            currentFiller.innerHTML = request;

            this.nextId++;

            var clearer = new Element('div', { 'class': 'clearer' });
            clearer.inject(currentFiller, 'after');

            var nextFiller = new Element('div', { 'id': 'toolHistoricalFiller' + this.nextId });
            nextFiller.inject(clearer, 'after');
        },

        hideLoader: function () {
            // Hides loading message
            if ($defined($('loadingMessage' + (this.nextId)))) {
                $('loadingMessage' + (this.nextId)).setStyle('display', 'none');
            }

            if (typeof (window.hideWaitModal !== "undefined"))
                window.hideWaitModal();
        }
    }
    )

function TglRows(ctl, rowNumber) {
    var row = ctl.parentNode.parentNode;
    var tbl = row.parentNode.parentNode;
    var expandClass = tbl.attributes.getNamedItem('expandClass').value;
    var collapseClass = tbl.attributes.getNamedItem('collapseClass').value;
    var expandText = tbl.attributes.getNamedItem('expandText').value;
    var collapseText = tbl.attributes.getNamedItem('collapseText').value;
    for (i = 1; i <= rowNumber; i++) {
        var crow = tbl.rows[row.rowIndex + i];
        if (crow.style.display == 'none') {
            crow.style.display = '';
            ctl.innerHTML = collapseText;
            ctl.className = collapseClass;
        }
        else {
            crow.style.display = 'none';
            ctl.innerHTML = expandText;
            ctl.className = expandClass;
        }
    }
}