function checkOrShow(value, cssType) {
    var resourceRows = document.getElements('.' + cssType);
    resourceRows.each(function(row) {
        if (checkboxesSelect) {
            var check = row.getElement('.sgnSelector');
            check.checked = value;
        }
        else {
            if (value)
                row.removeClass('suppressed');
            else
                row.addClass('suppressed');
        }
    });
}

function checkOrShowResources(cssType) {
    var value = this.checked;
    checkOrShow(value, cssType);
};

function updateResourcesUponFilter() {
    var resources = document.getElements('.hdwResource');
    resources.each(function(r) {
        var show = true;
        resourceTypeCheckboxes.each(function(item) {
            if (!item.box.checked && r.hasClass(item.cssClass)) show = show & false;
        });
        if (show) r.removeClass('suppressed'); else r.addClass('suppressed');
    });
};

var resourceParentCheckbox;
var resourceTypeCheckboxes;
var checkboxesSelect;

function updateCheckboxesParentChanged() {
    if (resourceParentCheckbox == null) return;
    var value = resourceParentCheckbox.checked;
    resourceTypeCheckboxes.each(function(checkbox) { checkbox.box.checked = value; });
};

function updateCheckboxesChildChanged() {
    if (resourceParentCheckbox == null) return;
    var checked = true;
    resourceTypeCheckboxes.each(function(checkbox) { checked = checked && checkbox.box.checked; });
    resourceParentCheckbox.checked = checked;
};

function toggleRow(foldingButton) {
    // http://www.mooforum.net/help12/possible-bug-event-target-with-t1566.html:
    // "..IE does not automatically extend the native Element object with mootools functions.
    // the $() function transforms the browser native element to a mootools element.
    foldingButton = $(foldingButton);

    var row = foldingButton.parentNode.parentNode;
    var child = row.nextSibling;
    var hidden = foldingButton.parentNode.getElementsByTagName('input').item(0);

    if (foldingButton.hasClass('grtExpandButton')) {
        // Under IE .removeClass seems not to be defined for the child object (but it is for foldingButton)
        //child.removeClass('suppressed');
        child.className = child.className.replace(new RegExp('(^|\\s)' + 'suppressed' + '(?:\\s|$)'), '$1');

        foldingButton.removeClass('grtExpandButton');
        foldingButton.addClass('grtCollapseButton');
        foldingButton.innerText = '-';

        if (hidden != null) hidden.value = '1';
    }
    else {
        // Under IE .addClass seems not to be defined for the child object (but it is for foldingButton)
        //child.addClass('suppressed');
        if (!child.className.clean().contains('suppressed')) child.className = (child.className + ' ' + 'suppressed').clean();

        foldingButton.removeClass('grtCollapseButton');
        foldingButton.addClass('grtExpandButton');
        foldingButton.innerText = '+';

        if (hidden != null) hidden.value = '';
    }
};

function liteGridCollapseAll(event) {
    var mooEvent = null;
    if (event != null) mooEvent = new Event(event);

    var foldingButtons = document.getElements('.grtCollapseButton');
    foldingButtons.each(function(foldingButton) { toggleRow(foldingButton); });

    // prevent default action
    if (mooEvent != null) mooEvent.preventDefault();
}

function liteGridExpandAll(event) {
    var mooEvent = null;
    if (event != null) mooEvent = new Event(event);

    var foldingButtons = document.getElements('.grtExpandButton');
    foldingButtons.each(function(foldingButton) { toggleRow(foldingButton); });

    // prevent default action
    if (mooEvent != null) mooEvent.preventDefault();
}

function liteGridSelectAll(event) {
    var mooEvent = null;
    if (event != null) mooEvent = new Event(event);

    var deviceSelectors = document.getElements('tr.hdwDevice td input.sgnSelector');
    deviceSelectors.each(function(selector) {
        selector.checked = true;
    });

    var rows = document.getElements('.hdwResource');
    rows.each(function(row) {
        if (!row.hasClass('suppressed')) {
            var checkbox = row.getElement('.sgnSelector');
            checkbox.checked = true;
        }
    });

    // prevent default action
    if (mooEvent != null) mooEvent.preventDefault();
}

function liteGridUnselectAll(event) {
    var mooEvent = null;
    if (event != null) mooEvent = new Event(event);

    var deviceSelectors = document.getElements('tr.hdwDevice td input.sgnSelector');
    deviceSelectors.each(function(selector) {
        selector.checked = false;
    });

    var rows = document.getElements('.hdwResource');
    rows.each(function(row) {
        var checkbox = row.getElement('.sgnSelector');
        checkbox.checked = false;
    });

    // prevent default action
    if (mooEvent != null) mooEvent.preventDefault();
}

function liteGridClearFilter(event) {
    var mooEvent = null;
    if (event != null) mooEvent = new Event(event);

    if (!checkboxesSelect) {
        if (resourceParentCheckbox != null) resourceParentCheckbox.checked = true;
        resourceTypeCheckboxes.each(function(checkbox) {
            checkbox.box.checked = true;
        });
    }

    updateResourcesUponFilter();

    // prevent default action
    if (mooEvent != null) mooEvent.preventDefault();
}

function checkOnDeviceRow(item) {
    item.resources.forEach(function(resource) {
        if (!resource.parentNode.parentNode.hasClass('suppressed')) {
            resource.checked = item.device.checked;
        }
    });
}

function checkOnResourceRow(item) {
    var atLeastOne = false;
    item.resources.forEach(function(resource) {
        atLeastOne |= resource.checked;
    });
    item.device.checked = atLeastOne;
}

window.addEvent('domready',
    function() {
        if (document.getElement('.wkaToolbarArea a.watGridExpandAll')) {
            document.getElement('.wkaToolbarArea a.watGridExpandAll').addEvent('click', liteGridExpandAll.bindWithEvent(this));
        }
        if (document.getElement('.wkaToolbarArea a.watGridCollapseAll')) {
            document.getElement('.wkaToolbarArea a.watGridCollapseAll').addEvent('click', liteGridCollapseAll.bindWithEvent(this));
        }
        if (document.getElement('.wkaToolbarArea a.watSelectall')) {
            document.getElement('.wkaToolbarArea a.watSelectall').addEvent('click', liteGridSelectAll.bindWithEvent(this));
        }
        if (document.getElement('.wkaToolbarArea a.watUnselectall')) {
            document.getElement('.wkaToolbarArea a.watUnselectall').addEvent('click', liteGridUnselectAll.bindWithEvent(this));
        }
        if (document.getElement('.wkaToolbarArea a.watGridClearFilter')) {
            document.getElement('.wkaToolbarArea a.watGridClearFilter').addEvent('click', liteGridClearFilter.bindWithEvent(this));
        }

        resourceParentCheckbox = document.getElement('#chkResources');

        var temp =
            [
                { box: document.getElement('#chkAnalogInputs'), cssClass: 'hdwResAnalog' },
                { box: document.getElement('#chkDigitalInputs'), cssClass: 'hdwResDigital' },
                { box: document.getElement('#chkStates'), cssClass: 'hdwResState' },
                { box: document.getElement('#chkAlarms'), cssClass: 'hdwResAlarm' }
            ];
        resourceTypeCheckboxes = new Array();
        temp.each(function(item) {
            if (item.box != null) resourceTypeCheckboxes.push(item);
        });

        if (resourceParentCheckbox != null) {
            resourceParentCheckbox.addEvent('click', checkOrShowResources.pass('hdwResource', resourceParentCheckbox));
            resourceParentCheckbox.addEvent('click', updateCheckboxesParentChanged.pass(resourceParentCheckbox));
        }

        resourceTypeCheckboxes.each(function(checkbox) {
            checkbox.box.addEvent('click', checkOrShowResources.pass(checkbox.cssClass, checkbox.box));
            checkbox.box.addEvent('click', updateCheckboxesChildChanged.pass(checkbox.box));
        });

        var deviceHeaders = document.getElements('.hdwDevice');
        deviceHeaders.forEach(function(deviceHeader) {
            var deviceCheckbox = deviceHeader.getElement('input');
            var resourceCheckboxes = deviceHeader.getNext().getElements('input');
            deviceCheckbox.addEvent('click', checkOnDeviceRow.pass({ device: deviceCheckbox, resources: resourceCheckboxes }, deviceCheckbox));
            resourceCheckboxes.forEach(function(resourceCheckbox) {
                resourceCheckbox.addEvent('click', checkOnResourceRow.pass({ device: deviceCheckbox, resources: resourceCheckboxes }, resourceCheckbox));
            });
        });

        // Uncomment this one to solve the inconsistency on real time reload
        //updateResourcesUponFilter();
    });