/*//////////////////////////// DOMREADY ////////////////////////////
_______________________________________________________________________________________________________ */

window.addEvent('domready', function() {
    Element.implement({
        show: function() { return this.setStyle('display', ''); },
        hide: function() { return this.setStyle('display', 'none'); }
    });

    // super-parameters-table handler
    if (document.getElement('div.wrpSuperParameterTable')) {
        this.parameters = new SuperParameterTable();
    }
});

/*//////////////////////////// CLASSES ////////////////////////////
_______________________________________________________________________________________________________ */

var SuperParameterTable = new Class({
    /* ________ TABLE NESTED STRUCTURE - START______________________________________

	<div id="" class="wrpSuperParameterTable">

		<table>

		  <tr id="rowParX" class="odd|even readonly error">
    <th>
    <input type="checkbox" id="chkParX" value="" />
    <input type="hidden"   id="recParX" value="{recid+group[]+isreadonly+isaddress}" />
    </th>
    <td>...</td>
    <td class="valmin">AAA</td>
    <td class="valmax">BBB ()</td>
    <td class="valpre">CCC</td>
    <td class="valdev">DDD</td>
    <td class="valusr">
    <input type="text" id="valParX" value=""/> or
    <select id="valParX"><option value="True|False">T|F</option></select>
    </td>
    </tr>

	___________________________________________________________________________END__ */

    initialize: function() {
        // store behaviour objects
        this.boxWrapper = document.getElement('div.wrpSuperParameterTable');

        // store parameters and their relationships
        this.addparameters();

        // init user preferences cookies
        this.adduserpreferences();

        // handle filters & visual helpers
        this.addcontrollers();

        // redraw preferences listing based on cookie-stored or default filter values
        this.redraw_updateListing();

        // stop "wait-loading" procedure
        this.boxWrapper.removeClass('sptWaitLoading');
    },

    addparameters: function() {
        // init handlers
        this.chkSelectors = [];
        this.fldInputs = [];
        this.areAddress = [];
        this.rowsParameters = document.getElements('div.wrpSuperParameterTable table tbody tr', this.boxWrapper);

        // store rows relationships (selector, readonly, etc. )
        Array.each(this.rowsParameters, function(crw) {
            // get row storage data
            crw.datastore = eval('(' + crw.getElement('th input[type=hidden]').value + ')'); 	// store data for current row

            // store row id
            crw.recid = crw.datastore['recid'];

            // store row checkbox (when exists)
            var crwchk = crw.getElement('th input[type=checkbox]');
            if (crwchk) {
                crw.selector = crwchk; 						// store a reference to the current row's selector
                crwchk.parent = crw; 						// store a reference to the selector's parent row
                this.chkSelectors.push(crwchk); 			// add selector to selectors list
                crwchk.addEvent('click', 				// handle checkbox change event as row update
					this.onselect_updateRow.bindWithEvent(this, crw)
				);

                // store row input element (when exist)
                var crwinp = crw.getElement('td #valPar' + crw.recid);
                if (crwinp) {
                    crw.userinput = crwinp; 					// store a reference to the current row's user input
                    crwinp.parent = crw; 					// store a reference to the input's parent row
                    crwinp.setProperty('disabled', '');
                    this.select_row(crw, crwchk.checked);
                    this.fldInputs.push(crwinp); 			// add control to inputs list
                }
            }

            // is parameter readonly ?
            if (crw.datastore['isreadonly'] == 1) {
                crw.isreadonly = true;
                crw.addClass('readonly');
            }

            // is parameter network address ?
            if (crw.datastore['isaddress'] == 1) {
                crw.isaddress = true;
                this.areAddress.push(crw); 				// add selector to isaddress list
            }
        }, this);
    },

    adduserpreferences: function() {
        var cookid = getFolding().join('-') + '_usrFilterPrefs';
        this.userprefs = new Hash.Cookie(cookid, { duration: 365 });
    },

    addcontrollers: function() {
        // add listing filters (if they exist)
        if (document.getElement('.wkaFilterArea #sptFilterEnable_Network')) { this.addcontrol('filter_enable_networkaddress'); }
        if (document.getElement('.wkaFilterArea #sptFilterShow_selParGroup')) { this.addcontrol('filter_by_group'); }
        if (document.getElement('.wkaFilterArea #sptFilterShow_inpParLabel')) { this.addcontrol('filter_by_label'); }
        if (document.getElement('.wkaFilterArea #sptFilterShow_inpParDescription')) { this.addcontrol('filter_by_description'); }
        if (document.getElement('.wkaFilterArea #sptFilterShow_chkParStates')) { this.addcontrol('filter_by_states'); }

        // add global filter clearer (if exists)
        if (document.getElement('.wkaToolbarArea a.watGridClearFilter')) { document.getElement('.wkaToolbarArea a.watGridClearFilter').addEvent('click', this.toolbar_exeClearFilter.bindWithEvent(this)); }

        // add global togglers/checkers (if they exist)
        if (document.getElement('.wkaToolbarArea a.watSelectall')) { document.getElement('.wkaToolbarArea a.watSelectall').addEvent('click', this.toolbar_exeSelectAll.bindWithEvent(this)); }
        if (document.getElement('.wkaToolbarArea a.watUnselectall')) { document.getElement('.wkaToolbarArea a.watUnselectall').addEvent('click', this.toolbar_exeUnselectAll.bindWithEvent(this)); }

        // add global copy shortcuts (if they exist)
        if (document.getElement('.wkaToolbarArea a.watCopyfromdefault')) { document.getElement('.wkaToolbarArea a.watCopyfromdefault').addEvent('click', this.toolbar_exeCopyfrom.bindWithEvent(this, 'pre')); }
        if (document.getElement('.wkaToolbarArea a.watCopyfromdevice')) { document.getElement('.wkaToolbarArea a.watCopyfromdevice').addEvent('click', this.toolbar_exeCopyfrom.bindWithEvent(this, 'dev')); }
    },

    addcontrol: function(knd) {
        switch (knd) {
            case 'filter_enable_networkaddress':
                // handle device description input field
                this.chkenable_network = $('sptFilterEnable_Network');
                // load saved state
                if (this.userprefs.get('sptFilterEnable_Network') != null) { $('sptFilterEnable_Network').value = this.userprefs.get('sptFilterEnable_Network'); }
                // handle checkbox click
                this.chkenable_network.addEvent('click', function() {
                    if (!this.chkenable_network.checked) {
                        this.areAddress.each(function(row) {
                            row.removeClass('selected');
                            row.selector.checked = false;
                            if (row.userinput) {
                                row.userinput.setFormElementValue('');
                                row.userinput.setProperty('disabled', 'disabled');
                            }
                        });
                    }
                } .bind(this), this);
                break;

            case 'filter_by_group':
                // handle parameter group selector
                $('sptFilterShow_selParGroup').addEvent('change', this.redraw_delayedListing.pass(500, this));
                // load saved state
                if (this.userprefs.get('sptFilterShow_selParGroup') != null) {
                    try {
                        $('sptFilterShow_selParGroup').selectedIndex = this.userprefs.get('sptFilterShow_selParGroup');
                    } catch (exc) { /* E_BURIGO: Saved group belonged to a different device. */ }
                }
                // conditional reference to be used later
                this.filter_by_group = true;
                break;

            case 'filter_by_label':
                // handle parameter label input field
                $('sptFilterShow_inpParLabel').addEvent('keyup', this.redraw_delayedListing.pass(500, this));
                $('sptFilterShow_inpParLabel').addEvent('change', this.redraw_delayedListing.pass(500, this));
                // load saved state
                if (this.userprefs.get('sptFilterShow_inpParLabel') != null) { $('sptFilterShow_inpParLabel').value = this.userprefs.get('sptFilterShow_inpParLabel'); }
                // conditional reference to be used later
                this.filter_by_label = true;
                break;

            case 'filter_by_description':
                // handle parameter label input field
                $('sptFilterShow_inpParDescription').addEvent('keyup', this.redraw_delayedListing.pass(500, this));
                $('sptFilterShow_inpParDescription').addEvent('change', this.redraw_delayedListing.pass(500, this));
                // load saved state
                if (this.userprefs.get('sptFilterShow_inpParDescription') != null) { $('sptFilterShow_inpParDescription').value = this.userprefs.get('sptFilterShow_inpParDescription'); }
                // conditional reference to be used later
                this.filter_by_description = true;
                break;

            case 'filter_by_states':
                // handle parameter state checkboxes
                $('sptFilterShow_chkParChecked').addEvent('click', this.redraw_delayedListing.pass(500, this));
                $('sptFilterShow_chkParUnchecked').addEvent('click', this.redraw_delayedListing.pass(500, this));
                $('sptFilterShow_chkParEmpty').addEvent('click', this.redraw_delayedListing.pass(500, this));
                $('sptFilterShow_chkParFilled').addEvent('click', this.redraw_delayedListing.pass(500, this));
                $('sptFilterShow_chkParValid').addEvent('click', this.redraw_delayedListing.pass(500, this));
                $('sptFilterShow_chkParError').addEvent('click', this.redraw_delayedListing.pass(500, this));

                // load saved state
                if (this.userprefs.get('sptFilterShow_chkParChecked') != null) { $('sptFilterShow_chkParChecked').checked = this.userprefs.get('sptFilterShow_chkParChecked'); }
                if (this.userprefs.get('sptFilterShow_chkParUnchecked') != null) { $('sptFilterShow_chkParUnchecked').checked = this.userprefs.get('sptFilterShow_chkParUnchecked'); }
                if (this.userprefs.get('sptFilterShow_chkParEmpty') != null) { $('sptFilterShow_chkParEmpty').checked = this.userprefs.get('sptFilterShow_chkParEmpty'); }
                if (this.userprefs.get('sptFilterShow_chkParFilled') != null) { $('sptFilterShow_chkParFilled').checked = this.userprefs.get('sptFilterShow_chkParFilled'); }
                if (this.userprefs.get('sptFilterShow_chkParValid') != null) { $('sptFilterShow_chkParValid').checked = this.userprefs.get('sptFilterShow_chkParValid'); }
                if (this.userprefs.get('sptFilterShow_chkParError') != null) { $('sptFilterShow_chkParError').checked = this.userprefs.get('sptFilterShow_chkParError'); }
                // conditional reference to be used later
                this.filter_by_states = true;
                break;
        }
    },

    toolbar_exeCopyfrom: function(event, col) {
        var event = new Event(event);

        // copy values from passed column
        Array.each(this.rowsParameters, function(row) {
            if (row.selector.checked && !row.isreadonly && row.userinput) {
                var columns = row.getElements('td.val' + col);
                if (columns[0].childNodes.length >= 2) {
                    // parameter filter row
                    row.userinput.setFormElementValue(columns[0].childNodes[1].value);
                    this.updateLink(row.recid);
                } else if (columns.length >= 1) {
                    row.userinput.setFormElementValue(columns[0].get('text'));
                }
            }
        }, this);

        // prevent default action
        event.preventDefault();
    },

    toolbar_exeClearFilter: function(event) {
        var event = new Event(event);

        // reset form controls values on filter area
        document.getElement('.wkaFilterArea').resetFormElements('restore');

        // redraw network listing
        this.redraw_updateListing();

        // clear & re-initialize cookie
        this.userprefs.empty();
        this.adduserpreferences();

        // prevent default action
        event.preventDefault();
    },

    toolbar_exeSelectAll: function(event) {
        var event = new Event(event);

        // init moo event handling
        //var event = new Event(event);

        // select only visible
        Array.each(this.rowsParameters, function(row) { if (!row.suppressed) { this.select_row(row, true); } }, this);

        // prevent default action
        event.preventDefault();
    },

    toolbar_exeUnselectAll: function(event) {
        var event = new Event(event);

        // init moo event handling
        //var event = new Event(event);

        // unselect only visible
        Array.each(this.rowsParameters, function(row) { if (!row.suppressed) { this.select_row(row, false); } }, this);

        // prevent default action
        event.preventDefault();
    },

    select_row: function(row, bol) {
        // test if parameter's row is an address
        if (row.isaddress && $chk(this.chkenable_network) && !this.chkenable_network.checked) {
            return false;
        }

        // update appearence
        $(row).conditionalClass('selected', bol);
        // check/uncheck selector
        row.selector.checked = bol;
        if (!row.isreadonly && row.userinput) {
            var columns = row.getElements('td.valusr');
            if (columns[0].childNodes.length >= 2) {
                // parameter filter row
                // show/hide link
                if (bol) columns[0].childNodes[0].show(); else columns[0].childNodes[0].hide();
                this.updateLink(row.recid);
            } else {
                // enable/disable user input
                $(row).userinput.setProperty('disabled', bol ? '' : 'disabled');
            }
            // reset input value
            if (!bol) $(row).userinput.setFormElementValue('');
        }
        return true;
    },

    onselect_updateRow: function(event, row) {
        var event = new Event(event);

        /* NEW ROUTINE */
        // if parameter's row is an address and address change is not enabled, "select_row" fails
        if (!this.select_row(row, event.target.checked)) {
            event.stop();
            return;
        }
    },

    redraw_updateListing: function() {
        // reset row suppression
        this.boxWrapper.getElements('tr.suppressed').each(function(crw) { crw.removeClass('suppressed'); crw.suppressed = false; });

        // filter on parameter group
        if (this.filter_by_group) {
            var cgrp = $('sptFilterShow_selParGroup').get('value');
            var igrp = $('sptFilterShow_selParGroup').selectedIndex;

            // store user preferences in a cookie
            this.userprefs.extend({ 'sptFilterShow_selParGroup': igrp });
        }

        // filter on parameter label
        if (this.filter_by_label) {
            var clbl = $('sptFilterShow_inpParLabel').get('value').toLowerCase();
            var crfl = $('sptFilterShow_refParLabel').get('value').toInt();

            // store user preferences in a cookie
            this.userprefs.extend({ 'sptFilterShow_inpParLabel': clbl });
        }

        // filter on parameter description
        if (this.filter_by_description) {
            var cdes = $('sptFilterShow_inpParDescription').get('value').toLowerCase();
            var crfd = $('sptFilterShow_refParDescription').get('value').toInt();

            // store user preferences in a cookie
            this.userprefs.extend({ 'sptFilterShow_inpParDescription': cdes });
        }

        // filter on parameter states
        if (this.filter_by_states) {
            var cckd = $('sptFilterShow_chkParChecked').checked;
            var cukd = $('sptFilterShow_chkParUnchecked').checked;
            var cety = $('sptFilterShow_chkParEmpty').checked;
            var cfld = $('sptFilterShow_chkParFilled').checked;
            var cvlf = $('sptFilterShow_chkParValid').checked;
            var cerr = $('sptFilterShow_chkParError').checked;

            // store user preferences in a cookie
            this.userprefs.extend({ 'sptFilterShow_chkParChecked': cckd, 'sptFilterShow_chkParUnchecked': cukd, 'sptFilterShow_chkParEmpty': cety, 'sptFilterShow_chkParFilled': cfld, 'sptFilterShow_chkParValid': cvlf, 'sptFilterShow_chkParError': cerr });
        }

        // multiple boolean <&&> filter on rows
        Array.each(this.rowsParameters, function(crw) {
            if (this.filter_by_group && cgrp != '' && !crw.datastore['group'].contains(cgrp)) {
                crw.addClass('suppressed'); crw.suppressed = true;
            }

            // Filter by Label and Measurement Unit (MU column has index crfl +2 )
            if (this.filter_by_label && (clbl != '' && !($(crw.cells[crfl - 1]).get('text').toLowerCase().test(clbl) || $(crw.cells[crfl + 2 - 1]).get('text').toLowerCase().test(clbl)))) {
                crw.addClass('suppressed'); crw.suppressed = true;
            }

            if (this.filter_by_description && (cdes != '' && !$(crw.cells[crfd - 1]).get('text').toLowerCase().test(cdes))) {
                crw.addClass('suppressed'); crw.suppressed = true;
            }

            if (this.filter_by_states && ((crw.selector.checked && !cckd) || (!crw.selector.checked && !cukd) || (crw.userinput && crw.userinput.get('value').trim() == '' && !cety) || (crw.userinput && crw.userinput.get('value').trim() != '' && !cfld) || (!crw.hasClass('error') && !cvlf) || (crw.hasClass('error') && !cerr))) {
                crw.addClass('suppressed'); crw.suppressed = true;
            }
        }, this);
    },

    redraw_delayedListing: function(delay) {
        // better use a timeout to handle multiple update sequences
        timedelay = delay || 0;

        // traditional code
        // if($chk(this.redraw_ticket)) { window.clearTimeout(this.redraw_ticket) };
        // this.redraw_ticket = window.setTimeout(function(){ this.redraw_updateListing(); }.bindAsEventListener(this), timedelay);

        // mootools code
        if ($chk(this.redraw_ticket)) { $clear(this.redraw_ticket) };
        this.redraw_ticket = this.redraw_updateListing.delay(timedelay, this);
    },

    updateLink: function(id) {
        var text = $('valPar' + id).value.trim();
        $('editLinkPar' + id).set('text', text != "" ? $('labelEdit').get('text') : $('labelSet').get('text'));
    },

    getSelectedLabelUserValues: function () {
        var results = [];
        Array.each(this.rowsParameters, function (row) {
            if (row.selector.checked && !row.isreadonly && row.userinput) {
                results.push({ label: row.childNodes[1].innerText, userInput: row.userinput.value });
            }
        }, this);
        return results;
    },

    // #####  DONT'T REMOVE  #####
    safari2hatesmissingcommas: function() { }
})