﻿var networkExt = networkExt || {
};

networkExt.gridExtEditDevice = (function () {  // networkExt.gridExtEditDevice BEGIN

	// Private Fields
	var _chkTemplateSaveMode = null;
	var _divInputAreaTemplateSelection = null;
	var _divInputAreaNewTemplateToSaveName = null;
	var _divScrollableContentGrid = null;
	var _divScrollableContentTemplateToModifySelection = null;

	var _panelWaitMessage = null;
	var _linkButtonApplyValuesToDevice = null;
	var _linkButtonGotoSaveTemplateMode = null;
	var _linkButtonSaveTemplate = null;
	var _linkButtonSaveNewTemplate = null;
	var _linkButtonDeleteTemplate = null;
	var _linkButtonCancel = null;
	var _linkButtonClose = null;
	var _selectTemplates = null;
	var _tableTemplateToUpdateSelectionBody = null;
	var _textBoxTemplateName = null;
	var _inputClearTemplateName = null;
	var _colorPickerMappedByColorInputId = new Array(); // associative array of type _colorPickerMappedByColorInputId['colorres0.00_01.INP40000-1'] = '#AAFF80'

	// the combo template has no selection, we can apply to device
	var STATE_INITIAL = "initial";

	// combo template has a selection
	var STATE_TEMPLATE_SELECTED = "template_selected";

	// we are in tempalte save mode and no text entered, but no template is selected from list, so we can't procede to save
	var STATE_TEMPLATE_SAVING_MISSING_SELECTION = "template_saving_missing_selection";

	// we are in tempalte save mode and no text entered, but a template is selected from list
	var STATE_TEMPLATE_SAVING_UPDATE = "template_saving_update";

	// we are in tempalte save mode and text for new template was entered
	var STATE_TEMPLATE_SAVING_NEW = "template_saving_new";

	// when operation in progress
	var STATE_OPERATION_IN_PROGRESS = "operation_in_progress";

	var _state = STATE_INITIAL; // initial state

	return {
		initialize: initialize,
	}

	function initialize() {

		_chkTemplateSaveMode = document.getElement('#chkTemplateSaveMode');
		_divInputAreaTemplateSelection = document.getElement('#inputAreaTemplateSelection');
		_divInputAreaNewTemplateToSaveName = document.getElement('#inputAreaNewTemplateToSaveName');
		_divScrollableContentGrid = document.getElement('#scrollableContentGrid');
		_divScrollableContentTemplateToModifySelection = document.getElement('#scrollableContentTemplateToModifySelection');

		_panelWaitMessage = document.getElement('td.dosome table#PanelWaitMessage');
		_linkButtonApplyValuesToDevice = document.getElement('td.dosome a#LinkButtonApplyValuesToDevice');
		_linkButtonGotoSaveTemplateMode = document.getElement('td.dosome a#LinkButtonGotoSaveTemplateMode');
		_linkButtonSaveTemplate = document.getElement('td.dosome a#LinkButtonSaveTemplate');
		_linkButtonSaveNewTemplate = document.getElement('td.dosome a#LinkButtonSaveNewTemplate');
		_linkButtonDeleteTemplate = document.getElement('td.dosome a#LinkButtonDeleteTemplate');
		_linkButtonCancel = document.getElement('td.dosome a#LinkButtonCancel');
		_linkButtonClose = document.getElement('td.dosome a.watPopupClose');
		_selectTemplates = document.getElement('#selectTemplate');
		_tableTemplateToUpdateSelectionBody = document.getElement('#tableTemplateToUpdateSelectionBody');
		_textBoxTemplateName = document.getElement('#TextboxTemplateName');
		_inputClearTemplateName = document.getElement('#InputClearTemplateName');

		// hide the folding button (+) in interface rond device row
		$$('.sgnFoldingButton').setStyle('display', 'none');

		wireToolbarEvent();
		wireDeviceCheckboxChangedEvent();
        wireDelayTextChangingEvent();
        wireUserDefinedThresholdTextChangingEvent();
		wireAliasAndDelayTextChangedEvent();
		wireDelayFocusedEvent();
		wireTemplateNameTextChangingAndChangedEvent();
		wireInputClearTemplateNameEvent();

		fillTemplateDropDownAndWireEvents();
		fillTableTemplateToUpdateSelectionAndWireEvents();

		initAllColorPickers();
		refreshAllColorPickers();

		_selectTemplates.set('value', startUpData.templateToPreselectPositionInArray);

		fillValuesUsingSelectedTemplate();
		setStateByUserInput();
		setVisibilityByState();
	}

	function initAllColorPickers() {
		$$('.sgnResourcesTable input[id^="colorres"]').each(function (item) {
			var colorPicker = new ColorPicker(item);
			_colorPickerMappedByColorInputId[item.id] = colorPicker;
		});

		// fix to avoid multiple picker opened! we wire on clicking to hide all boxes
		// the after the onclickeing the box-opening code goes straight on.
		$$('.sgnResourcesTable input[id^="colorres"]').addEvent('onClicking', function (item) {

			for (key in _colorPickerMappedByColorInputId) {
				var picker = _colorPickerMappedByColorInputId[key];
				if (picker && picker.box)
					picker.box.setStyle('display', 'none');
			}

		});

		$$('.sgnResourcesTable input[id^="colorres"]').addEvent('onSelectColor', function (item) {

		});
	}

	function refreshAllColorPickers() {
		$$('.sgnResourcesTable input[id^="colorres"]').each(function (item) {
			var colorPicker = _colorPickerMappedByColorInputId[item.id];
			colorPicker.selectColor(item.value);
		});
    }

    function refreshSingleColorPicker(item)
    {
        var colorPicker = _colorPickerMappedByColorInputId[item.id];
        colorPicker.selectColor(item.value);
    }

	// EVENT WIRING 

	function wireToolbarEvent() {
		if (_linkButtonClose) {
			_linkButtonClose.addEvent('click', onClosePopup);
			_linkButtonClose.onclick = function () { return false; };
		}

		if (_linkButtonCancel) {
			_linkButtonCancel.addEvent('click', onCancel);
			_linkButtonCancel.onclick = function () { return false; };
		}

		if (_linkButtonApplyValuesToDevice) {
			_linkButtonApplyValuesToDevice.addEvent('click', onApplyValuesToDevice);
			_linkButtonApplyValuesToDevice.onclick = function () { return false; };
		}

		if (_linkButtonGotoSaveTemplateMode) {
			_linkButtonGotoSaveTemplateMode.addEvent('click', onGotoSaveTemplateMode);
			_linkButtonGotoSaveTemplateMode.onclick = function () { return false; };
		}

		if (_linkButtonSaveTemplate) {
			_linkButtonSaveTemplate.addEvent('click', onSaveTemplate);
			_linkButtonSaveTemplate.onclick = function () { return false; };
		}

		if (_linkButtonSaveNewTemplate) {
			_linkButtonSaveNewTemplate.addEvent('click', onSaveNewTemplate);
			_linkButtonSaveNewTemplate.onclick = function () { return false; };
		}

		if (_linkButtonDeleteTemplate) {
			_linkButtonDeleteTemplate.addEvent('click', onDeleteTemplate);
			_linkButtonDeleteTemplate.onclick = function () { return false; };
		}
	}

	function wireInputClearTemplateNameEvent() {
		if (_inputClearTemplateName) {
			_inputClearTemplateName.addEvent('click', onInputClearTemplateNameClicked);
			_inputClearTemplateName.onclick = function () { return false; };
		}
	}

	function wireDeviceCheckboxChangedEvent() {
		$$('.sgnResourcesTable .sgnSelector').addEvent('click', onDeviceCheckboxChanged);
	}

	function wireAliasAndDelayTextChangedEvent() {
		$$('.sgnResourcesTable input[id^="delayres"]').addEvent('keyup', onAliasAndDelayTextChanged);
		$$('.sgnResourcesTable input[id^="descriptionres"]').addEvent('keyup', onAliasAndDelayTextChanged);
	}

	function wireDelayTextChangingEvent() {
		$$('.sgnResourcesTable input[id^="delayres"]').addEvent('keydown', onDelayTextChanging);
    }

    function wireUserDefinedThresholdTextChangingEvent() {
        $$('.sgnResourcesTable input[id^="userdefinedalarmthreshold"]').addEvent('keydown', onUserDefinedThresholdTextChanging);
    }

	function wireDelayFocusedEvent() {
		$$('.sgnResourcesTable input[id^="delayres"]').addEvent('focus', onDelayFocused);
	}

	function wireTemplateNameTextChangingAndChangedEvent() {
		$$('input#TextboxTemplateName').addEvent('keydown', onTemplateNameTextChanging);
		$$('input#TextboxTemplateName').addEvent('keyup', onTemplateNameTextChanged);
	}

	// FUNCTION THAT RESPONDS TO WIRED EVENTS

	function onApplyValuesToDevice() {
		// alert('onApplyValuesToDevice');

		disableAllBeforePostback();

		__doPostBack(_linkButtonApplyValuesToDevice.id, '');
	}

	function onGotoSaveTemplateMode() {
		_chkTemplateSaveMode.checked = true;
		setStateByUserInput();
		setVisibilityByState();
	}

	function onSaveTemplate() {
		if ($$('.template-to-update-selected').length > 0) {

			// fill value in textbox before submitting, in this way 
			var serverSideTemplateIndexToSave = $$('.template-to-update-selected')[0].get('data-value');

			// alert('onSaveTemplate'); // debug
			disableAllBeforePostback();

			__doPostBack(_linkButtonSaveTemplate.id, 'templateId:' + serverSideTemplateIndexToSave);
		}
	}

	function onSaveNewTemplate() {
		// alert('onSaveTemplate'); // debug
		disableAllBeforePostback();

		__doPostBack(_linkButtonSaveNewTemplate.id, '');
	}

	function onDeleteTemplate() {

	    if ($$('.template-to-update-selected').length > 0) {

	        // fill value in textbox before submitting, in this way 
	        var serverSideTemplateIndexToSave = $$('.template-to-update-selected')[0].get('data-value');

	        // alert('onSaveTemplate'); // debug
	        disableAllBeforePostback();

	        __doPostBack(_linkButtonDeleteTemplate.id, 'templateId:' + serverSideTemplateIndexToSave);
	    } 
	}

	function onClosePopup(item) {
		// the same command (explained) is injected via server side in generic popup control
		// this approach is the best because we skip one postback but we reload interely the parent page
		// so the parent page is anyway refreshed!!!
		window.parent.location = window.parent.location;
	}

	function onCancel() {
		_textBoxTemplateName.set('value', '');
		// _selectTemplates.set('value', -1);
		_chkTemplateSaveMode.checked = false;

		fillValuesUsingSelectedTemplate();
		setStateByUserInput();
		setVisibilityByState();
	}

	function onDeviceCheckboxChanged() {
		var checked = this.checked; // the new checked state
		var tdElem = this.parentElement;
		var trElem = tdElem.parentElement;

        var descriptionInput = trElem.getElement('input[id^="descriptionres"]');
        var colorInput = trElem.getElement('input[id^="colorres"]'); 
        var alarmInput = trElem.getElement('input[id^="delayres"]');   


		if (!checked) {
			/*  uncommment this if we want auto clean of all fields on uncheck

			descriptionInput.set('value', '');
			if (colorInput)
				colorInput.set('value', '');

			if (alarmInput)
				alarmInput.set('value', '');

			refreshAllColorPickers();

			*/
		}
		else {
			descriptionInput.focus();
			if (alarmInput && !alarmInput.get('value'))
				alarmInput.set('value', '0'); // set zero on alarm
		}

	}

	function onDelayTextChanging(e) {

		// http://stackoverflow.com/questions/1583074
		var isNumber = true;
		var isBackSpace = false;
		var isArrow = false;
		var isCopyPaste = false;

		if (e.code >= 96 && e.code <= 105)
			return; // allow keypad

		if (e.code > 31 && (e.code < 48 || e.code > 57))
			isNumber = false;
        if (e.code == 8 || e.code == 46)
			isBackSpace = true;
		if (e.code >= 37 && e.code <= 40)
			isArrow = true;
		if (e.code == 67 || e.code == 86)
			isCopyPaste = true;

		if (!isNumber && !isBackSpace && !isArrow && !isCopyPaste)
			e.stop();
	}
     
    function onUserDefinedThresholdTextChanging(e) {

        // http://stackoverflow.com/questions/1583074
        var isNumber = true;
        var isBackSpace = false;
        var isArrow = false;
        var isCopyPaste = false;
        var isDecimalSep = false;
        var isMinusSign = false;
         
        if (e.code >= 96 && e.code <= 105)
            return; // allow keypad

        if (e.code > 31 && (e.code < 48 || e.code > 57))
            isNumber = false;
        if (e.code == 8 || e.code == 46)
            isBackSpace = true;
        if (e.code >= 37 && e.code <= 40)
            isArrow = true;
        if (e.code == 67 || e.code == 86)
            isCopyPaste = true;
        if (e.code == 110 || e.code == 188 || e.code == 190)
            isDecimalSep = true; // allow decimal separators (',' or '.' or '.' in numpad)
        if (e.code == 109 || e.code == 189)
            isMinusSign = true;

        if (!isNumber && !isBackSpace && !isArrow
            && !isCopyPaste && !isDecimalSep && !isMinusSign)
            e.stop();
    }


	function onAliasAndDelayTextChanged(e) {

		if (e.target.value && e.target.value.length > 0 && e.target.value != "0") {
			var tdElem = e.target.parentElement;
			var trElem = tdElem.parentElement;

			var checkboxInputArray = trElem.getElements('input[type=checkbox]');

			// uncommment this if we want auto-check on edit.
			// checkboxInputArray[0].checked = true;
		}
	}

	function onDelayFocused(e) {
		if (e.target)
			e.target.select(); // slect all text in input
	}

	function onTemplateNameTextChanging(e) {

		return;

		// http://stackoverflow.com/questions/1583074
		var isNumber = true;
		var isBackSpace = false;
		var isArrow = false;
		var isCopyPaste = false;

		if (e.code > 31 && (e.code < 48 || e.code > 57))
			isNumber = false;
		if (e.code == 8)
			isBackSpace = true;
		if (e.code >= 37 && e.code <= 40)
			isArrow = true;
		if (e.code == 67 || e.code == 86)
			isCopyPaste = true;

		if (!isNumber && !isBackSpace && !isArrow && !isCopyPaste)
			e.stop();
	}

	function onTemplateNameTextChanged() {
		if (_state == STATE_OPERATION_IN_PROGRESS)
			return;

		// remove selection if something written
		var templateNameFragment = _textBoxTemplateName.get('value');
		if (templateNameFragment) {
			selectRowOnTableTemplateToUpdateSelection(-1);
		}

		setStateByUserInput();
		setVisibilityByState();
	}

	function onInputClearTemplateNameClicked() {
		// fillValuesUsingSelectedTemplate();
		_textBoxTemplateName.set('value', '');
		onTemplateNameTextChanged();

		setStateByUserInput();
		setVisibilityByState();
	}

	// UI STATE MACHINE CONTROLLER

	function setStateByUserInput() {

		// get the dropdown state and the textbox state
		var selectedValue = _selectTemplates.value;
		var templateName = _textBoxTemplateName.get('value');
		var templateToUpdateSelected = $$('.template-to-update-selected').length > 0;

		if (_chkTemplateSaveMode.checked) {
			if (templateName) {
				_state = STATE_TEMPLATE_SAVING_NEW;
			}
			else {
				if (templateToUpdateSelected)
					_state = STATE_TEMPLATE_SAVING_UPDATE;
				else
					_state = STATE_TEMPLATE_SAVING_MISSING_SELECTION;
			}
		}
		else {
			if (selectedValue != -1)
				_state = STATE_TEMPLATE_SELECTED;
			else
				_state = STATE_INITIAL;
		}
	}

	function setVisibilityByState() {
		switch (_state) {
			case STATE_INITIAL:
				_divInputAreaTemplateSelection.setStyle('display', '');
				_divInputAreaNewTemplateToSaveName.setStyle('display', 'none');
				_divScrollableContentGrid.setStyle('display', '');
				_divScrollableContentTemplateToModifySelection.setStyle('display', 'none');

				_panelWaitMessage.setStyle('display', 'none');
				_linkButtonClose.setStyle('display', '');
				_linkButtonApplyValuesToDevice.setStyle('display', '');
				_linkButtonGotoSaveTemplateMode.setStyle('display', '');
				_linkButtonSaveTemplate.setStyle('display', 'none');
				_linkButtonSaveNewTemplate.setStyle('display', 'none');
				_linkButtonDeleteTemplate.setStyle('display', 'none');
				_linkButtonCancel.setStyle('display', 'none');
				break;
			case STATE_TEMPLATE_SELECTED:
				_divInputAreaTemplateSelection.setStyle('display', '');
				_divInputAreaNewTemplateToSaveName.setStyle('display', 'none');
				_divScrollableContentGrid.setStyle('display', '');
				_divScrollableContentTemplateToModifySelection.setStyle('display', 'none');

				_panelWaitMessage.setStyle('display', 'none');
				_linkButtonClose.setStyle('display', '');
				_linkButtonApplyValuesToDevice.setStyle('display', '');
				_linkButtonGotoSaveTemplateMode.setStyle('display', '');
				_linkButtonSaveTemplate.setStyle('display', 'none');
				_linkButtonSaveNewTemplate.setStyle('display', 'none');
				_linkButtonDeleteTemplate.setStyle('display', 'none');
				_linkButtonCancel.setStyle('display', 'none');
				break;
			case STATE_TEMPLATE_SAVING_NEW:
				_divInputAreaTemplateSelection.setStyle('display', 'none');
				_divInputAreaNewTemplateToSaveName.setStyle('display', '');
				_divScrollableContentGrid.setStyle('display', 'none');
				_divScrollableContentTemplateToModifySelection.setStyle('display', '');

				_panelWaitMessage.setStyle('display', 'none');
				_linkButtonClose.setStyle('display', '');
				_linkButtonApplyValuesToDevice.setStyle('display', 'none');
				_linkButtonGotoSaveTemplateMode.setStyle('display', 'none');
				_linkButtonSaveTemplate.setStyle('display', 'none');
				_linkButtonSaveNewTemplate.setStyle('display', ''); // visible
				_linkButtonDeleteTemplate.setStyle('display', 'none');
				_linkButtonCancel.setStyle('display', '');

				_inputClearTemplateName.setStyle('display', '');
				break;
			case STATE_TEMPLATE_SAVING_MISSING_SELECTION:
				_divInputAreaTemplateSelection.setStyle('display', 'none');
				_divInputAreaNewTemplateToSaveName.setStyle('display', '');
				_divScrollableContentGrid.setStyle('display', 'none');
				_divScrollableContentTemplateToModifySelection.setStyle('display', '');

				_panelWaitMessage.setStyle('display', 'none');
				_linkButtonClose.setStyle('display', '');
				_linkButtonApplyValuesToDevice.setStyle('display', 'none');
				_linkButtonGotoSaveTemplateMode.setStyle('display', 'none');
				_linkButtonSaveTemplate.setStyle('display', 'none');
				_linkButtonSaveNewTemplate.setStyle('display', 'none');
				_linkButtonDeleteTemplate.setStyle('display', 'none');
				_linkButtonCancel.setStyle('display', '');

				_inputClearTemplateName.setStyle('display', 'none');
				break;
			case STATE_TEMPLATE_SAVING_UPDATE:
				_divInputAreaTemplateSelection.setStyle('display', 'none');
				_divInputAreaNewTemplateToSaveName.setStyle('display', '');
				_divScrollableContentGrid.setStyle('display', 'none');
				_divScrollableContentTemplateToModifySelection.setStyle('display', '');

				_panelWaitMessage.setStyle('display', 'none');
				_linkButtonClose.setStyle('display', '');
				_linkButtonApplyValuesToDevice.setStyle('display', 'none');
				_linkButtonGotoSaveTemplateMode.setStyle('display', 'none');
				_linkButtonSaveTemplate.setStyle('display', ''); // visible!
				_linkButtonSaveNewTemplate.setStyle('display', 'none'); // visible
				_linkButtonDeleteTemplate.setStyle('display', 'none');
				_linkButtonCancel.setStyle('display', '');

				_inputClearTemplateName.setStyle('display', 'none');
				break;
			case STATE_OPERATION_IN_PROGRESS:
				_divInputAreaTemplateSelection.setStyle('display', '');
				_divInputAreaNewTemplateToSaveName.setStyle('display', 'none');
				_divScrollableContentGrid.setStyle('display', '');
				_divScrollableContentTemplateToModifySelection.setStyle('display', 'none');

				_panelWaitMessage.setStyle('display', '');
				_linkButtonClose.setStyle('display', 'none');
				_linkButtonApplyValuesToDevice.setStyle('display', 'none');
				_linkButtonGotoSaveTemplateMode.setStyle('display', 'none');
				_linkButtonSaveTemplate.setStyle('display', 'none');
				_linkButtonSaveNewTemplate.setStyle('display', 'none');
				_linkButtonDeleteTemplate.setStyle('display', 'none');
				_linkButtonCancel.setStyle('display', 'none');
		}
	}

	// UI WIDGET VISIBILITY OR ATTRIBUTES MODIFIERS

    function fillTemplateDropDownAndWireEvents() {
		// first row "initialDeviceAsTemplate" is always present
		var optionEl = new Element('option', {
            html: escapeHtml(startUpData.initialDeviceAsTemplate.TemplateName),
			value: -1 // a value to detect the initialDeviceAsTemplate
		});
		optionEl.inject(_selectTemplates);

		var index = 0; // correspond to the zero based position on array of templates

		startUpData.templates.each(function (template) {
			var optionEl = new Element('option', {
                html: escapeHtml(template.TemplateName),
				value: index
			});

			optionEl.inject(_selectTemplates);

			index++;
		});

		// wire the event after the select was popupulated by data
		_selectTemplates.addEvent('change', function (event) {

			if (_state == STATE_OPERATION_IN_PROGRESS)
				return;

			fillValuesUsingSelectedTemplate();
			setStateByUserInput();
			setVisibilityByState();
		});
	}

	function fillTableTemplateToUpdateSelectionAndWireEvents() {
		var index = 0; // correspond to the zero based position on array of templates

		startUpData.templates.each(function (template) {
			var rowEl = new Element('tr');

			var tdEl = new Element('td', {
				html: escapeHtml(template.TemplateName),
				'class': 'template-to-update-row-td',
				'data-id': index,
				'data-value': template.TemplateIndex, // server side index used for postback
				events: {
					click: function () {
						var selectedIndex = $(this).get('data-id');
						// alert('debug clicked: ' + selectedIndex);
						selectRowOnTableTemplateToUpdateSelection(selectedIndex);
						_textBoxTemplateName.set('value', '');

						setStateByUserInput();
						setVisibilityByState();
					}
				},
			});

			tdEl.inject(rowEl);

			rowEl.inject(_tableTemplateToUpdateSelectionBody);

			index++;
		});


		/*
		// wire the event after the select was popupulated by data
		_selectTemplates.addEvent('change', function (event) {

			if (_state == STATE_OPERATION_IN_PROGRESS)
				return;

			fillValuesUsingSelectedTemplate();
			setStateByUserInput();
			setVisibilityByState();
		});
		*/
	}

	function fillValuesUsingSelectedTemplate() {
		_textBoxTemplateName.set('value', '');

		var index = _selectTemplates.value;
		if (index == -1) {
			// set values using the initial device as template
			fillValuesUsingTemplate(startUpData.initialDeviceAsTemplate, true);

			selectRowOnTableTemplateToUpdateSelection(-1);
		}
		else {
			var template = startUpData.templates[index];

			// set values using the template at the index
			fillValuesUsingTemplate(template, false);

			selectRowOnTableTemplateToUpdateSelection(index);
		}
	}

	function fillValuesUsingTemplate(template, cleanupBeforeFill) {
		/* 
		 ResourceList
				 ResourceAlarmDelay
				 ResourceDescription
				 ResourceId "INP40000-2"
				 */

		if (cleanupBeforeFill) {
			// clean up all textbox and checkbox, then we will fill the data
			$$('.sgnResourcesTable input[type=checkbox]').set('checked', false);
			$$('.sgnResourcesTable input[type=text]').set('value', '');
		}

		template.ResourceList.each(function (resource) {

			var resourceId = resource.ResourceId;
			var resourceDescription = resource.ResourceDescription;
			var resourceAlarmDelay = resource.ResourceAlarmDelay;
			var resourceColor = resource.ResourceColor;
            var resourceOnLine = resource.ResourceOnLine;
            var resourceThresholdLow = resource.ResourceUserDefinedAlarmThresholdLow;
            var resourceThresholdHigh = resource.ResourceUserDefinedAlarmThresholdHigh;

			var singleTrSelector = '.sgnResourcesTable tr[id$="' + resourceId + '"]'; // ie: INP40000-2, $ is and end with

			if ($$(singleTrSelector).length > 0) {
				var trElement = $$(singleTrSelector)[0];
				var inputDescriptionElement = trElement.getElement('input[id^="descriptionres"]');
				var inputAlarmDelayElement = trElement.getElement('input[id^="delayres"]');
				var inputCheckBoxElement = trElement.getElement('input[id^="chkres"]');
                var inputColorElement = trElement.getElement('input[id^="colorres"]');
                var inputThresholdLowElement = trElement.getElement('input[id^="userdefinedalarmthresholdlow"]');
                var inputThresholdHighElement = trElement.getElement('input[id^="userdefinedalarmthresholdhigh"]');

				if (inputDescriptionElement)
					inputDescriptionElement.set('value', resourceDescription);

				if (inputAlarmDelayElement)
					inputAlarmDelayElement.set('value', resourceAlarmDelay);

				if (inputCheckBoxElement)
					inputCheckBoxElement.checked = resourceOnLine;

				if (inputColorElement) {
                    inputColorElement.set('value', resourceColor);
                    refreshSingleColorPicker(inputColorElement);
                }

                if (inputThresholdLowElement)  
                    inputThresholdLowElement.set('value', resourceThresholdLow);
                  
                if (inputThresholdHighElement)  
                    inputThresholdHighElement.set('value', resourceThresholdHigh);
			}
		});

		// see if some resource is checked and aligh the device check in accordance
		var arrayResourcesChecked = $$('.sgnResourcesTable input[type=checkbox]:checked');
		var deviceCheckbox = $$('tr.hdwDevice input[type=checkbox]')[0]; // only one, must be always present

		if (arrayResourcesChecked && arrayResourcesChecked.length > 0) {
			deviceCheckbox.checked = true;
		}
		else {
			deviceCheckbox.checked = false;
		}
	}

	function disableAllBeforePostback() {
		// readonly all! no care of rollback tfrom his action because of the following postback
		// we use readonly instead of disabled because disabled input are not posted back
		$$('input').set('readonly', 'readonly');

		_state = STATE_OPERATION_IN_PROGRESS;
		setVisibilityByState();
	}

	function selectRowOnTableTemplateToUpdateSelection(zeroBasedIndex) {
		$$('.template-to-update-row-td').each(function (item) {

			var itemElement = $(item);

			itemElement.removeClass('template-to-update-selected');

			var itemId = itemElement.get('data-id');

			if (zeroBasedIndex == itemId) {
				itemElement.addClass('template-to-update-selected');
			}
		});
	}

})(); // networkExt.gridExt END
