/*//////////////////////////// DOMREADY ////////////////////////////
_______________________________________________________________________________________________________ */

window.addEvent('domready',function() {
    // rvd interactive widget
    if ($('boxToolsWidgetRVD')) { this.myRemoteVirtualDevice = new rvdWidget();    }
});

/*//////////////////////////// CLASSES ////////////////////////////
_______________________________________________________________________________________________________ */

var rvdWidget = new Class({
    initialize: function() {
        // store behaviour objects
        this.boxWidget             = $('boxToolsWidgetRVD');
        this.boxStage             = document.getElement('#boxStage',this.boxWidget);
        this.boxDevice             = document.getElement('#boxDevice',this.boxWidget);
        this.boxDeviceSkin         = document.getElement('#boxDevSkin',this.boxWidget);
        this.boxDeviceDisplay     = document.getElement('#boxDevDisplay',this.boxWidget);
        this.boxDeviceButtons     = document.getElement('#boxDevButtons',this.boxWidget);
        this.lstLog             = document.getElement('#logList',this.boxWidget);

        // space minimize/maximize togglers
        this.togspacemax = document.getElement('.wkaToolbarArea a.watRvdMaximize');
        this.togspacemin = document.getElement('.wkaToolbarArea a.watRvdMinimize');
        if (this.togspacemax) { this.togspacemax.addEvent('click', this.spacetoggle.pass('max',this)); this.togspacemax.onclick = function(){return false;}; }
        if (this.togspacemin) { this.togspacemin.addEvent('click', this.spacetoggle.pass('min',this)); this.togspacemin.onclick = function(){return false;}; this.togspacemin.setStyle('display','none'); }

        // load interface (ajax)
        new Request({url:'/RvdInvocation.rix', onComplete: this.loadinterface.bindWithEvent(this)}).send('modality=ajax&exec=load');
    },

    loadinterface: function(request){
        /* store the JSON data response */
        //this.display_config = eval('(' + request + ')');
        this.display_config = JSON.decode(request);
        this.log2list(window.rvd_localization.init1);

        // get timing parameters
        this.blink = this.display_config.general.blink;
        this.keypress = this.display_config.general.keypress;

        // init device skin
        var skin = new Element("img");
        skin.setProperties({'src':this.display_config.general.bitmap,'id':'skin_bmp'});
        skin.setStyles({'position':'absolute','top':this.display_config.general.y, 'left':this.display_config.general.x});
        skin.injectInside(this.boxDeviceSkin);

        // init device buttons
        Object.each(this.display_config.buttons, function(btn,id){
            var cbut1 = new Element("img");
            var cbut2 = new Element("img");
            cbut1.setProperties({'src':btn.bitmap_dn,'id':'btn_bmp_'+id+'_dn'});
            cbut2.setProperties({'src':btn.bitmap_up,'id':'btn_bmp_'+id+'_up'});
            cbut1.setStyles({'position':'absolute','top':btn.y, 'left':btn.x, 'z-index':1 });
            cbut2.setStyles({'position':'absolute','top':btn.y, 'left':btn.x, 'z-index':1 });
            cbut1.injectInside(this.boxDeviceButtons);
            cbut2.injectInside(this.boxDeviceButtons);

            var cfad = new Element("div");
            cfad.setProperties({'id':'btn_fad_'+id});
            cfad.setStyles({'position':'absolute','top':btn.y, 'left':btn.x, 'width':btn.w, 'height':btn.h, 'z-index':2, 'background-color':'#FFF733' });
            cfad.injectInside(this.boxDeviceButtons);

            var cpxl = new Element("img");
            var clnk = new Element("a");
            cpxl.injectInside(clnk);
            cpxl.setProperty('src','/media/img/Others/EmptySmall.gif');
            cpxl.setStyles({'width':btn.w, 'height':btn.h});
            clnk.setProperties({'href':'#','id':'btn_lnk_'+id});
            clnk.setStyles({'position':'absolute','top':btn.y, 'left':btn.x, 'width':btn.w, 'height':btn.h, 'z-index':3 });
            clnk.injectInside(this.boxDeviceButtons);

            clnk.funcode = btn['function'];
            //clnk.fader = new Fx.Style(cfad, 'opacity', {duration:500, wait:false}).set(0);
            clnk.fader = new Fx.Tween(cfad, { property: 'opacity' });
            clnk.fader.start(1, 0);

            clnk.addEvent('mousedown', function() { cbut1.setStyle('display',''); cbut2.setStyle('display','none'); });
            clnk.addEvent('mouseup', function() { cbut1.setStyle('display','none'); cbut2.setStyle('display',''); });

            clnk.addEvent('mousedown', this.mdownbutton.bindWithEvent(this));
            clnk.addEvent('click', this.clickbutton.bindWithEvent(this));
            clnk.onclick = function(){return false;};
        }, this);

        Object.each( this.display_config.display, function(led,id){
            var cled1 = new Element("img");
            var cled2 = new Element("img");
            cled1.setProperties({'src':led.bitmap_off,'id':'led_bmp_'+id+'_off'});
            cled2.setProperties({'src':led.bitmap_on,'id':'led_bmp_'+id+'_on'});
            cled1.setStyles({'position':'absolute','top':led.y, 'left':led.x, 'display':'none' });
            cled2.setStyles({'position':'absolute','top':led.y, 'left':led.x, 'display':'none' });
            cled1.injectInside(this.boxDeviceDisplay);
            cled2.injectInside(this.boxDeviceDisplay);
        }, this);

        // stop "wait-loading" procedure on completion
        this.boxWidget.removeClass('rvdWaitLoading');

        // start polling display update data
        this.polltimer = this.pollstatus.periodical(500, this);

        // stop polling on page unload!
        // window.onbeforeunload = this.pollstop.bind(this);
        // window.onunload = this.pollstop.bind(this);
        window.onbeforeunload = this.pollstop;
        window.onunload = this.pollstop;
    },

    /*
    buildinterface: function(){
    },
    */

    updateinterface: function(request){
        /* store the JSON data response */
        this.display_update = JSON.decode(request);
        if(this.display_update == null) {
            return;
        }

        Object.each( this.display_update.display, function(state,id){
            var led_on = $('led_bmp_'+id+'_on').setStyle('display','');
            var led_off = $('led_bmp_'+id+'_off').setStyle('display','none');
            if(state.view) {
                led_on.setStyle('display','');
                led_off.setStyle('display','none');
                if(state.blink) {
                    if(!led_on.bltimer) {
                        led_on.bltimer = this.blinkled.periodical(this.blink, led_on);
                    }
                } else {
                    led_on.bltimer = $clear(led_on.bltimer);
                    led_on.setStyle('visibility','');
                }
            } else {
                led_on.setStyle('display','none');
                led_off.setStyle('display','');
            }
        }, this);
    },

    blinkled: function(){
        this.setStyle('visibility',(this.getStyle('visibility')=='hidden')?'':'hidden');
    },

    pollstatus: function(){
        // load mask data (ajax)
        new Request({url:'/RvdInvocation.rix', onComplete: this.updateinterface.bindWithEvent(this), timeout: 5000}).send("modality=ajax&exec=poll");
    },

    pollstop: function(mode){
        if(this.polltimer) { this.polltimer = $clear(this.polltimer); }
    },

    mdownbutton: function(event) {
        var event2 = new Event(event);
        var butt = $(event2.target).getFirstParentByTag('a');

        this.mdtime = $time();
        // this.mdtimer = (function(){console.log('5sec past')}).delay(5000);  USE ONLY IF VISUAL FEEDBACK REQUIRED (*)

        // pass event + called function (ajax)
        new Request({url:'/RvdInvocation.rix', onComplete: this.updateinterface.bindWithEvent(this), timeout: 5000})
            .send("modality=ajax&exec=func&code="+butt.funcode+"&event=mdown&timestamp="+this.mdtime);
    },

    clickbutton: function(event) {
        var event2 = new Event(event);
        var butt = $(event2.target).getFirstParentByTag('a');

        // fade effect
        butt.fader.start(0.5,0);

        // get delta time between mousedown -> mouseup&click to understand if is a simple click or a mouse-hold
        var ispress = ($time() - this.mdtime) > this.keypress;

        // clear timer used to higlight button on 5 seconds
        // if (this.mdtimer) { this.mdtimer = $clear(this.mdtimer); }  DISABLED - see above (*)

        // pass event + called function (ajax)
        var postBody = 'modality=ajax&exec=func&code='+butt.funcode+'&event=click&press='+ispress+'&timestamp='+this.mdtime;
        new Request({       url: '/RvdInvocation.rix',
                     onComplete: function(request) {
                                     var cstate = JSON.decode(request);
                                     if(cstate != null) {
                                         cli.className = cstate.state;
                                     } else {
                                         cli.className = 'ack';
                                     }
                                  },
                        timeout: 5000,
                      onTimeout: function() {
                                     cli.className = 'out';
                                 }
                     })
            .send(postBody);

        // log command
        var buttonName = $chk(window.rvd_localization.buttondesc[butt.funcode])
                ? window.rvd_localization.buttondesc[butt.funcode]
                : butt.funcode;
        var cli = this.log2list(
            window.rvd_localization[(ispress)?'mouseaction2':'mouseaction1'] + ' ('+buttonName+')',
            't'+this.mdtime,
            'snt');
    },

    log2list: function(msg,id,cls) {
        cls = cls || 'msg';

        var cdt = new Date();
        var cli = new Element("li", {'id':id,'class': cls});
        var htm = '<p><span class="time">'+ zeroPad(cdt.getHours(),2) +":"+ zeroPad(cdt.getMinutes(),2) +":"+ zeroPad(cdt.getSeconds(),2) +'</span><span class="mess">'+ msg +'</span></p>';
        cli.set('html',htm);
        cli.injectBefore(this.lstLog.getFirst());

        return cli;
    },

    spacetoggle: function(mode) {
        switch(mode){
            case 'max':
                document.getElement('#menuGeneral').setStyle('display','none');
                document.getElement('#workingArea h1.wkaTitle').setStyle('display','none');
                this.togspacemax.setStyle('display','none');
                this.togspacemin.setStyle('display','');
                break;
            case 'min':
                document.getElement('#menuGeneral').setStyle('display','');
                document.getElement('#workingArea h1.wkaTitle').setStyle('display','');
                this.togspacemax.setStyle('display','');
                this.togspacemin.setStyle('display','none');
                break;
        }
    }
});