﻿window.addEvent('domready', function() {
    Element.implement({
        show: function() { return this.setStyle('display', ''); },
        hide: function() { return this.setStyle('display', 'none'); }
    });

    subsidiaryFilter.initialize(global_selectorTypes, global_resourceTypes, global_interfaceAttributeArray, global_deviceAttributeArray, global_interfaceArray, global_uiDictionary, global_nodesDictionary);
});

/* -----------------------------------------------------------------------------|
| F I L T E R   M A N A G E R
\----------------------------------------------------------------------------- */

var subsidiaryFilter = {
    initialize: function(selectorTypes, resourceTypes, interfaceAttributes, deviceAttributes, interfaces, uiDictionary, nodesDictionary) {
        //subsidiaryFilter.previewTree = new Jx.Tree({ parent: 'treeFilterArea' });
        this.cultures = $(document.body).getElements('select.subsidiaryFilterPopupCultureDdl');

        this.localizeNodes = false;
        this.nodesDictionary = nodesDictionary;
        this.uiDictionary = uiDictionary;

        this.editList = $('nodeListSub');
        this.nodeArray = new Array();

        subsidiaryFilter.localizeUI(uiDictionary, nodesDictionary);

        $('checkbox_parameter').addEvent('click', subsidiaryFilter.updateLabelVisibility);

        $('btnPopUpFiltersCloseSub').addEvent('click', subsidiaryFilter.closeModalPopUp);
        $('btnPopUpFiltersSaveSub').addEvent('click', subsidiaryFilter.saveFilters);
        $('btnPopUpFiltersExitSub').addEvent('click', subsidiaryFilter.closeModalPopUp);
        $('btnPopUpFiltersCopyFromDefaultSub').addEvent('click', subsidiaryFilter.copyFromDefault);
        $('btnPopUpFiltersCopyFromDeviceSub').addEvent('click', subsidiaryFilter.copyFromDevice);
    },

    localizeUI: function(uiDictionary, nodesDictionary) {
        $('btn_set_device').set('value', uiDictionary["setvalue"]);
        $('btn_set_interface').set('value', uiDictionary["setvalue"]);

        $('val_id_resourceSub').set('alt', uiDictionary["tooltip_validation_resource_id"]);
        $('val_id_resourceSub').set('title', uiDictionary["tooltip_validation_resource_id"]);

        $('label_id_resourceSub').set('html', nodesDictionary["id"]);
        $('label_name_resourceSub').set('html', nodesDictionary["name"]);
        $('label_label_resourceSub').set('html', nodesDictionary["label"]);
        $('label_type_resourceSub').set('html', nodesDictionary["type"]);
    },

    addOptionsToSelect: function(selectID, options, clearBeforeInsert) {
        var elSel = $(selectID);
        if (clearBeforeInsert)
            elSel.options.length = 0;
        for (var index = 0; index < options.length; index++) {
            var elOptNew = document.createElement('option');
            elOptNew.text = options[index].display;
            elOptNew.value = options[index].id;
            try {
                elSel.add(elOptNew, null);
            } catch(ex) {
                elSel.add(elOptNew);
            }
        }
    },

    getAttributesString: function(xmlNode) {
        var dataString = "";
        for (var index = 0; index < xmlNode.attributes.length; index++) {
            var att = xmlNode.attributes[index];
            if (subsidiaryFilter.nodesDictionary[att.name] != null)
                dataString += subsidiaryFilter.nodesDictionary[att.name] + '="' + att.value + '" ';
            else
                dataString += att.name + '="' + att.value + '" ';
        }
        return dataString;
    },

    setAttribute: function(node, attributeName, value) {
        var attribute = node.getAttributeNode(attributeName);
        if (value == "" && attribute != null) {
            node.removeAttribute(attributeName);
            return;
        }
        if (value == "")
            return;
        if (attribute == null) {
            attribute = subsidiaryFilter.xmlDoc.createAttribute(attributeName);
            attribute.nodeValue = value;
            node.setAttributeNode(attribute);
        } else {
            attribute.nodeValue = value;
        }
    },

    getAttribute: function(node, attributeName) {
        var attribute = node.getAttribute(attributeName);
        if (attribute != null)
            return attribute;
        return '';
    },

    saveNodeSubsidiary: function() {
        var resourceId = $('filter_resource_idSub').get('value');
        if (resourceId != "") {
            var re = new RegExp("^\\s*(\\*|([A-Z\\?]{3}|\\*)([\\d\\?]{5}|\\*)(:([\\d\\?]+|\\*))?)(-(.+|\\*))?\\s*$");
            if (!resourceId.match(re)) {
                $('val_id_resourceSub').show();
                return false;
            }
        }
        $('val_id_resourceSub').hide();
        var node = subsidiaryFilter.nodeArray[1];
        subsidiaryFilter.setAttribute(node, 'filterOnId', resourceId);
        subsidiaryFilter.setAttribute(node, 'filterOnLabel', $('filter_resource_labelSub').get('value'));
        subsidiaryFilter.setAttribute(node, 'filterOnName', $('filter_resource_nameSub').get('value'));

        var type = "";
        var checkBoxes = $('checkboxs_resource_selectorSub').getElements('input');
        checkBoxes.each(function(control) {
            if (control.checked)
                type = type + control.get('value') + ' ';
        });
        subsidiaryFilter.setAttribute(node, 'filterOnType', type);
        subsidiaryFilter.refreshEditList();
        return true;
    },

    loadNodeSelector: function(node) {
        // Load Type
        $('ddl_type_selector').set('value', subsidiaryFilter.getAttribute(node, 'type'));
        // Load Resxs
        var resxNode = node.getElementsByTagName('resourceTypes');
        var checkBoxs = $('checkboxs_resource_selector').getElements('input');
        if (resxNode.length > 0) {
            var values = "";
            if (document.all) {
                values = resxNode[0].text;
            } else {
                values = resxNode[0].textContent;
            }

            var splitValues = values.split(' ');
            if (splitValues.length > 0) {
                checkBoxs.each(function(control) {
                    if (splitValues.contains('all') || splitValues.contains(control.get('value')))
                        control.checked = true;
                    else
                        control.checked = false;
                });
            }
        } else {
            checkBoxs.each(function(control) {
                control.checked = false;
            });
        }
    },

    loadNodeSubsidiary: function(node) {
        $('filter_resource_idSub').set('value', subsidiaryFilter.getAttribute(node, 'filterOnId'));
        $('filter_resource_labelSub').set('value', subsidiaryFilter.getAttribute(node, 'filterOnLabel'));
        $('filter_resource_nameSub').set('value', subsidiaryFilter.getAttribute(node, 'filterOnName'));

        var checkBoxs = $('checkboxs_resource_selectorSub').getElements('input');
        var types = subsidiaryFilter.getAttribute(node, 'filterOnType');
        if (types.length > 0) {
            var splitValues = types.split(' ');
            if (splitValues.length > 0) {
                checkBoxs.each(function(control) {
                    if (splitValues.contains('all') || splitValues.contains(control.get('value')))
                        control.checked = true;
                    else
                        control.checked = false;
                });
            }
        } else {
            checkBoxs.each(function(control) {
                control.checked = false;
            });
        }
    },

    refreshCultureDdl: function() {
        var culture = subsidiaryFilter.xmlDoc.childNodes[0].attributes["culture"].nodeValue;
        subsidiaryFilter.cultures.set('value', culture);
    },

    refreshEditList: function() {
        subsidiaryFilter.nodeArray = new Array();
        subsidiaryFilter.editList.set('html', '');

        subsidiaryFilter.cultures.set("disabled", subsidiaryFilter.readOnly ? "disabled" : "");

        $("filterList").toggleClass("filterList_FullWidth", subsidiaryFilter.readOnly);

        var subsidiaries = subsidiaryFilter.xmlDoc.getElementsByTagName("subsidiaryFilter");
        for (var i = 0; i < subsidiaries.length; i++) {
            /* There should be only 1 */
            var row;
            var nodeId;
            row = new Element('div', { 'class': 'filter_edit_item filter_edit_resource' });
            row.set('html', subsidiaryFilter.nodesDictionary["resource"] + ' ' + subsidiaryFilter.getAttributesString(subsidiaries[i]));
            nodeId = subsidiaryFilter.nodeArray.length + 1;
            subsidiaryFilter.nodeArray[nodeId] = subsidiaries[i];
            row.inject(subsidiaryFilter.editList);
        }
    },

    viewData: function(textAreaId, additional, inputOutput) {
        subsidiaryFilter.readOnly = true;
        subsidiaryFilter.textArea = $(textAreaId);
        subsidiaryFilter.inputOutput = inputOutput;
        subsidiaryFilter.originalText = subsidiaryFilter.textArea.value;
        subsidiaryFilter.hasBeenSaved = false;

        // Set title
        var title = subsidiaryFilter.uiDictionary["titleView"] + " " +
            (inputOutput == "input" ? subsidiaryFilter.uiDictionary["titleSubsidiaryFilterInput"] : subsidiaryFilter.uiDictionary["titleSubsidiaryFilterOutput"]);
        if (additional) title += " - " + additional;
        $('headerFiltersSub').set('html', title);

        $('filter_resource_idSub').set('disabled', 'disabled');
        $('filter_resource_nameSub').set('disabled', 'disabled');
        $('filter_resource_labelSub').set('disabled', 'disabled');
        $$('#checkboxs_resource_selectorSub span input').each(function(control) {
            control.set('disabled', 'disabled');
        });

        $('btnPopUpFiltersCloseSub').setStyle("display", "none");
        $('btnPopUpFiltersSaveSub').setStyle("display", "none");
        $('btnPopUpFiltersExitSub').setStyle("display", "inline-block");
        $('btnPopUpFiltersCopyFromDefaultSub').setStyle("display", "none");
        $('btnPopUpFiltersCopyFromDeviceSub').setStyle("display", "none");

        $$('.notInput').each(function(control) {
            if (inputOutput == "input") control.hide();
            else control.show();
        });
        $$('.notOutput').each(function(control) {
            if (inputOutput == "output") control.hide();
            else control.show();
        });

        subsidiaryFilter.getXMLFilters();
        subsidiaryFilter.refreshEditList();
        subsidiaryFilter.refreshCultureDdl();
        subsidiaryFilter.loadNodeSubsidiary(subsidiaryFilter.nodeArray[1]); // '0' is the invisible root.
        subsidiaryFilter.openModalPopUp();

        subsidiaryFilter.updateLabelVisibility();
    },

    editData: function(textAreaId, onSave, additional, inputOutput, defaultInput, deviceInput) {
        subsidiaryFilter.readOnly = false;
        subsidiaryFilter.textArea = $(textAreaId);
        subsidiaryFilter.originalText = subsidiaryFilter.textArea.value;
        subsidiaryFilter.hasBeenSaved = false;
        subsidiaryFilter.onSave = onSave;

        // Set title
        var title = subsidiaryFilter.uiDictionary["titleEdit"] + " " +
            (inputOutput == "input" ? subsidiaryFilter.uiDictionary["titleSubsidiaryFilterInput"] : subsidiaryFilter.uiDictionary["titleSubsidiaryFilterOutput"]);
        if (additional) title += " - " + additional;
        $('headerFiltersSub').set('html', title);

        $('filter_resource_idSub').set('disabled', '');
        $('filter_resource_nameSub').set('disabled', '');
        $('filter_resource_labelSub').set('disabled', '');
        $$('#checkboxs_resource_selectorSub span input').each(function(control) {
            control.set('disabled', '');
        });

        $('btnPopUpFiltersCloseSub').setStyle("display", "inline-block");
        $('btnPopUpFiltersSaveSub').setStyle("display", "inline-block");
        $('btnPopUpFiltersExitSub').setStyle("display", "none");
        if (defaultInput != null && $(defaultInput).value.trim() != "") {
            subsidiaryFilter.defaultContent = $(defaultInput);
            $('btnPopUpFiltersCopyFromDefaultSub').setStyle("display", "inline-block");
        } else {
            $('btnPopUpFiltersCopyFromDefaultSub').setStyle("display", "none");
        }
        if (deviceInput != null && $(deviceInput).value.trim() != "") {
            subsidiaryFilter.deviceContent = $(deviceInput);
            $('btnPopUpFiltersCopyFromDeviceSub').setStyle("display", "inline-block");
        } else {
            $('btnPopUpFiltersCopyFromDeviceSub').setStyle("display", "none");
        }

        $$('.notInput').each(function(control) {
            if (inputOutput == "input") control.hide();
            else control.show();
        });
        $$('.notOutput').each(function(control) {
            if (inputOutput == "output") control.hide();
            else control.show();
        });

        subsidiaryFilter.getXMLFilters();
        subsidiaryFilter.refreshEditList();
        subsidiaryFilter.refreshCultureDdl();
        subsidiaryFilter.loadNodeSubsidiary(subsidiaryFilter.nodeArray[1]); // '0' is the invisible root.
        subsidiaryFilter.openModalPopUp();

        subsidiaryFilter.updateLabelVisibility();
    },

    updateLabelVisibility: function() {
        var visibility = ($('checkbox_parameter').get('checked')) ? "block" : "none";
        $('labelLine').setStyle('display', visibility);
        $('warningParameters').setStyle('display', visibility);
        //        if (visibility) {
        //            $('editList').setStyle('height', '340px');
        //        } else {
        //            $('editList').setStyle('height', '392px');
        //        }
    },

    copyFromDefault: function() {
        var temporary = subsidiaryFilter.textArea.value;
        subsidiaryFilter.textArea.setFormElementValue(subsidiaryFilter.defaultContent.value);
        subsidiaryFilter.getXMLFilters();
        subsidiaryFilter.refreshEditList();
        subsidiaryFilter.refreshCultureDdl();
        subsidiaryFilter.loadNodeSubsidiary(subsidiaryFilter.nodeArray[1]); // '0' is the invisible root.
        subsidiaryFilter.textArea.setFormElementValue(temporary);
        subsidiaryFilter.updateLabelVisibility();
    },

    copyFromDevice: function() {
        var temporary = subsidiaryFilter.textArea.value;
        subsidiaryFilter.textArea.setFormElementValue(subsidiaryFilter.deviceContent.value);
        subsidiaryFilter.getXMLFilters();
        subsidiaryFilter.refreshEditList();
        subsidiaryFilter.refreshCultureDdl();
        subsidiaryFilter.loadNodeSubsidiary(subsidiaryFilter.nodeArray[1]); // '0' is the invisible root.
        subsidiaryFilter.textArea.setFormElementValue(temporary);
        subsidiaryFilter.updateLabelVisibility();
    },

    saveFilters: function() {
        var ok = subsidiaryFilter.saveNodeSubsidiary();
        if (!ok) return;

        var xml;
        subsidiaryFilter.xmlDoc.childNodes[0].attributes["culture"].nodeValue = subsidiaryFilter.cultures.get('value');
        if (subsidiaryFilter.xmlDoc.xml == null) {
            xml = (new XMLSerializer()).serializeToString(subsidiaryFilter.xmlDoc);
        } else {
            xml = subsidiaryFilter.xmlDoc.xml;
        }
        xml = xml.replace(/[\n\r]/g, '');

        subsidiaryFilter.textArea.setFormElementValue(xml);
        subsidiaryFilter.hasBeenSaved = true;
        subsidiaryFilter.closeModalPopUp();
        if (subsidiaryFilter.onSave && typeof(subsidiaryFilter.onSave) == "function")
            subsidiaryFilter.onSave(subsidiaryFilter.cultures.getSelected()[0].get('text'));
    },

    closeModalPopUp: function() {
        if (!subsidiaryFilter.hasBeenSaved) {
            // Undos editing.
            subsidiaryFilter.textArea.setFormElementValue(subsidiaryFilter.originalText);
        }
        $('modalPopUpContainerSub').setStyle("display", "none");
        return false;
    },

    openModalPopUp: function() {
        $$('.leftCol').each(function(c) { c.hide(); });
        $$('.rightCol').each(function(c) { c.show(); });
        $('val_id_resourceSub').hide();
        $('modalPopUpContainerSub').setStyle("display", "block");
        return false;
    },

    attachAttributesTree: function(displayNode, xmlNode) {
        for (var index = 0; index < xmlNode.attributes.length; index++) {
            var att = xmlNode.attributes[index];
            var item = new Jx.TreeItem({
                image: '/media/img/Others/ActionSheduler/attribute.gif',
                label: subsidiaryFilter.nodesDictionary[att.name] + '=' + att.value
            });
            displayNode.append(item);
        }
    },

    uniqueID: function() {
        var newDate = new Date;
        return newDate.getTime() + '';
    },

    getXMLFilters: function() {
        var txt = subsidiaryFilter.textArea.value;
        if (txt == "") {
            txt = "<subsidiaryFilter culture=\"en-gb\"/>"; // Base filter
            subsidiaryFilter.textArea.setFormElementValue(txt);
        }
        if (window.DOMParser) { // No IE
            parser = new DOMParser();
            this.xmlDoc = parser.parseFromString(txt, "text/xml");
        } else // Internet Explorer
        {
            this.xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
            this.xmlDoc.async = "false";
            this.xmlDoc.loadXML(txt);
        }
    }
};