/*//////////////////////////// DOMREADY ////////////////////////////
_______________________________________________________________________________________________________ */

window.addEvent('domready', function() {
    // check browser support
    chkDomSupport();

    // master page
    if ($('workingArea')) {
        // check correct framesetting
        chkFramesetting();

        // smart menu handler
        if ($('menuGeneral')) { this.mySmartMenu = new smartMenu(); }

        // working area tabs handler
        if (document.getElement('div.wkaSubtabsArea')) { this.myWkaSubtabsMenu = new wkaSubtabsMenu(); }

        // super-grid-network handler
        if (document.getElement('div.wrpSuperGridNetworkTable')) { this.mySuperGridNetworkTable = new superGridNetworkTable(); }

        // enable toolbar prev/next buttons
        if (document.getElement('div.wkaToolbarArea td.goprev a')) {
            var prev = document.getElement('div.wkaToolbarArea td.goprev');
            if(prev != null) prev.style.display = '';
        } else {
           var prev = document.getElement('div.wkaToolbarArea td.goprev');
            if(prev != null) prev.style.display = 'none';
        };

        if (document.getElement('div.wkaToolbarArea td.gonext a')) {
            var next = document.getElement('div.wkaToolbarArea td.gonext');
            if(next != null) next.style.display = '';
        } else {
            var next = document.getElement('div.wkaToolbarArea td.gonext');
            if(next != null) next.style.display = 'none';
        };

        // user profile settings handler
        if (document.getElement('.wkaProfileSettings')) { this.myProfileSettingsHandler = new profileSettingsHandler(); }

        // color-picker handlers
        // if (document.getElements('.inpColorPicker')) { document.getElements('.inpColorPicker').each(function(ccp) { new colPicker(ccp); }, this); }

        // Tooltips
        var myTips = new Tips($$('.tipped'), {
            text: "tip",
            title: "tipTitle",
            showDelay: 500
        });

        myTips.removeEvents('show').addEvent('show', function(tip, el) {
            tip.fade('in');
        });
        myTips.removeEvents('hide').addEvent('hide', function(tip, el) {
            tip.fade('hide');
        });
    }
});

/*---- FUNCTIONS -----*/
function chkDomSupport() {
	// Test minimal browser DOM support
	if(!document.getElementById || !document.appendChild || !document.createElement) {
		top.location.href = "/CourtesyPage.aspx?msg=domError";
	}
}

function chkFramesetting() {
	// test permitted standalone pages
	this.isLogin = (document.getElementById('boxLogin')) ? true : false;
	this.isMessage = (document.getElementById('boxCustomMessage')) ? true : false;
	// TODO: utilizzare un unico id/classe per tutte le pagine di popup, per evitare la proliferazione di test
	this.isPopup = (document.getElementById('pnlWrapperAlarmHistoryPopup')) ? true : false;
	this.isGenericPopup = (document.getElementById('pnlWrapperGenericPopup') ? true : false);
    this.isYearCalendar = (document.getElementById('popupYearCalendar')) ? true : false;

    // avoid frameset nesting of login page
	if ( this.isLogin && top != self) {
		top.location.href = location.href;
	}

	if (this.isGenericPopup) {
	    // A generic popup breaks the frame structure of the page so it may sometimes miss the
	    // following test. We exit, since we do not need to monitor for pupup url in seperate page.
	    return; 
	}

	// check correct frameset nesting [ ( menu & working area ) + status bar ] (except login)
	// (1) number of frames
	// (2) parent-child relationship
	// (3) frames that should exist in the index
	// (4) pages has been correctly loaded in frames (DON'T USE: if page loading of menu/statbar has not completed, this page can't find the body id !)

	var	frmTest = (top.frames.length == 2) && (top == parent) && (top.frames[0].name == "frmOperational" && top.frames[1].name == "frmMonitoring");

	//var isMessageAlternate = (document.getElementById("MessageControl1$boxCustomMessage")) ? true : false;

	//[Guido 21-07-2008] The condition !this.isYearCalendar has been added.
    if (!this.isLogin && !this.isMessage && !this.isPopup && !this.isYearCalendar && !frmTest) // && !isMessageAlternate)
    {
        if (top.location.href.indexOf("frmError") < 0) {
            // avoid courtesy page loop!
            top.location.href = "/CourtesyPage.aspx?msg=frmError";
        }
	}
}

function getFolding() {
	// Get page folding (category/pagegroup) out of current url

	var cUrl = location.href;

	// strip query string
	if(cUrl.indexOf("?") >= 0) { cUrl = cUrl.substring(0,cUrl.indexOf("?")); }

	var cTree = cUrl.split('/');
	var cDir = cTree[cTree.length-2];
	var cFilename = cTree[cTree.length-1].substring(0,cTree[cTree.length-1].lastIndexOf('.'));

	// strip wizard-steps naming (xxxxxxx_01, xxxxxxx_02, ecc.)
	cFilename = cFilename.replace(/_?\d+$/g, '');

	return new Array(cDir,cFilename);
}

function zeroPad(txt,len) {
	var txtzeropad = '' + txt;
	while(txtzeropad.length < len) { txtzeropad = "0" + txtzeropad; }
	return txtzeropad;
}

function launchPopupFull(url) {
	params  = 'width='+screen.width;
	params += ', height='+screen.height;
	params += ', top=0, left=0';
    params += ', fullscreen=yes';

	newwin=window.open(url,'televis_popup_window', params);

	if (window.focus) {newwin.focus(); }

	return false;
}

function escapeHtml(text) {
    return text.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
}

/*//////////////////////////// CLASSES ////////////////////////////
_______________________________________________________________________________________________________ */

var smartMenu = new Class({
    initialize: function() {
        // store behaviour objects
        this.boxTabs = $('mngTabs');
        this.boxLevs = $('mngLevs');
        this.boxTabsDivs = $$('#mngTabs div.tab');
        this.boxTabsAnks = $$('#mngTabs div.tab a');

        this.boxLevsDivs = $$('#mngLevs div.lev');
        this.boxLevsAnks = $$('#mngLevs div.lev a');

        // store frontline (visible) objects
        this.curTab = document.getElement('#mngTabs div.frontline'); 	//this.currtab
        this.curLev = document.getElement('#mngLevs div.frontline'); 	//this.currlev

        // store active (current page) objects
        this.actTab = document.getElement('#mngTabs div.active'); 	//this.acttab
        this.actLnk = document.getElement('#mngLevs div.lev a.active'); //this.actlnk

        // assign the behavior to the tabs
        for (i = 0; i < this.boxTabsAnks.length; i++) {
            this.boxTabsAnks[i].addEvent('click', this.switchlevel.pass(this.boxTabsDivs[i], this));
            this.boxTabsAnks[i].onclick = function() { return false; };
        }

        if (this.boxTabs && this.boxLevs) {	// check HTML vs. expected DOM correspondence
            // handle smart tabs
            this.mySmartMenuTabs = new smartMenuItemGroup(this.boxTabs.id);

            // handle smart levels
            this.mySmartMenuLevs = new Array();
            for (var i = 0; i < this.boxLevsDivs.length; i++) {
                this.mySmartMenuLevs[i] = new smartMenuItemGroup(this.boxLevsDivs[i].id);
            }

            // hide tabs if no child (because of server-side user permission)
            for (var i = 0; i < this.mySmartMenuLevs.length; i++) {
                if (this.mySmartMenuLevs[i].gSpns.length < 1) { this.boxTabsDivs[i].remove(); }
            }

            // intercept window event onResize
            window.addEvent('load', this.resize.bindWithEvent(this));
            window.addEvent('resize', this.resize.bindWithEvent(this));
        }

        // highlight current menu
        this.setactive();
    },

    // Introduced for setting active link in historical table/graph pages.
    // setActiveFromPage is called from page scripts, the matchUrl is a well known url fragment that matches only one link
    setActiveFromPage: function (matchUrl) {
        if ($chk(this.actLnk)) this.actLnk.removeClass('active');

        // set menu "active"
        for (j = 0; j < this.boxLevsAnks.length; j++) {
            if (this.boxLevsAnks[j].href.test(matchUrl, "i")) {
                // set link "active"
                this.actLnk = this.boxLevsAnks[j];
                this.actLnk.addClass('active');

                // stop looping & exit function ;-)
                return;
            }
        }
    },

    resize: function() {
        this.mySmartMenuTabs.sizeup();
        this.mySmartMenuLevs.each(function(msml) { msml.sizeup(); });
    },

    switchlevel: function(tab) {
        // reset current frontline tab/level
        if (this.curTab) { this.curTab.removeClass('frontline'); }
        if (this.curLev) { this.curLev.removeClass('frontline'); }

        // set current tab "frontline"
        this.curTab = $(tab);
        this.curTab.addClass('frontline');

        // set current level "frontline"
        //this.curLev = $(tab.getProperty('rel'));
        this.curRel = this.curTab.getProperty('rel');
        this.curLev = $(this.curRel);
        this.curLev.addClass('frontline');
    },

    setactive: function() {
        // reset current frontline tab/link
        if ($chk(this.actTab)) this.actTab.removeClass('active');
        if ($chk(this.actLnk)) this.actLnk.removeClass('active');

        // get current page url
        var cAct = getFolding();
        var matchUrl = cAct[0] + "/" + cAct[1].split('_')[0];

        // set menu "active"
        for (j = 0; j < this.boxLevsAnks.length; j++) {
            if (this.boxLevsAnks[j].href.test(matchUrl, "i")) {
                // set link "active"
                this.actLnk = this.boxLevsAnks[j];
                this.actLnk.addClass('active');

                // set tab "active"
                this.actTab = $(this.actLnk.getParent().id.replace(/mngLev/g, 'mngTab'));
                // additional getParent to go up catacchio tag
                //this.actTab = $(this.actLnk.getParent().getParent().id.replace(/mngLev/g, 'mngTab'));
                this.actTab.addClass('active');

                // switch level
                this.switchlevel(this.actTab);

                // stop looping & exit function ;-)
                return;
            }
        }
        // fallback (highlight first tab/lev);
        this.switchlevel(this.boxTabsDivs[0]);
    }
});

var smartMenuItemGroup = new Class({
    initialize: function(gid) {
        this.gRoot = $(gid);
        this.gSpns = this.gRoot.getElements('a span');
        // assign title attribute to span tags (to be used later)
        this.gSpns.each(function(spn) { spn.setProperty('title', spn.get('html')); });
        // do sizeup
        this.sizeup();
    },

    // "to be sized"
    tbsiz: function() {
        return (this.gSpns.length > 0 && this.gSpns[this.gSpns.length - 1].getParent().getTop() > this.gRoot.getTop());
    },

    sizeup: function() {
        // reset labels
        this.gSpns.each(function(spn) {
            spn.set('html', spn.getProperty('title'));
        });

        while (this.tbsiz()) {
            var mx = 0;
            for (var i = 0; i < this.gSpns.length; i++) {
                mx = Math.max(mx, this.gSpns[i].innerHTML.length);
            }
            if (mx <= 3) break;

            this.gSpns.each(
				function(spn) {
				    if (mx - spn.innerHTML.length < 4) {
				        spn.innerHTML = spn.getProperty('title').substring(0, mx - 4) + "...";
				    }
				}
			);
        }
    }
});

var wkaSubtabsMenu = new Class({
	initialize: function() {
	    // store behaviour objects
		this.boxSubTabs = document.getElement('div.wkaSubtabsArea');
		this.boxSubTabsDivs = $$('div.wkaSubtabsArea div.tab');
		this.boxSubTabsAnks = $$('div.wkaSubtabsArea div.tab a');
		this.boxSubTabsLock = this.boxSubTabs.getElement('#sbtLock');

		// set frontline tab
		this.setfrontline();

		// make current step modal (NICE TO HAVE)
		/*if($chk(this.boxSubTabs) && $chk(this.boxSubTabsLock) && this.boxSubTabsLock.value=="true" ) {
			// intercept tab change
			//for (i=0; i<this.boxSubTabsAnks.length; i++) {
				//this.boxSubTabsAnks[i].addEvent('click', this.tabchange.pass(this.boxSubTabsLock.title,this.boxSubTabsAnks[i]));
				//this.boxSubTabsAnks[i].onclick = function(){return false;}
			//}

			// TODO:
			// - add window.onbeforeunload handler not immediately (ondomready) but when the network scan has completed
			// - intercept window unbeforeload but not when saving
			obunloadMsg = this.boxSubTabsLock.getProperty('title');
			window.onbeforeunload = function () { return (obunloadMsg); } // IE + FF only
		}*/
	},

	setfrontline: function(){
		// get current page url
		var cAct = getFolding();

		// set tab "active"
		for (j=0; j<this.boxSubTabsAnks.length; j++) {
			if(this.boxSubTabsAnks[j].href.test(cAct[1],"i")) {
				this.boxSubTabsAnks[j].getParent().addClass('frontline');

				// stop looping ;-)
				break;
			}
		}
	},

	tabchange: function(msg){
		if (confirm(msg)){ location = this.href; }
	}
});

var clientDataEntry = new Class({
    /*

	C.R. - Si potrebbe usare l'estensione della classe per separare il data-entry di tipo "base" da quello di tipo "lista"

	Property: extend
    Returns the copy of the Class extended with the passed in properties.

	Arguments:
    properties - the properties to add to the base class in this new Class.

	Example:
    (start code)
    var Animal = new Class({
    initialize: function(age){
    this.age = age;
    }
    });
    var Cat = Animal.append({
    initialize: function(name, age){
    this.parent(age); //will call the previous initialize;
    this.name = name;
    }
    });
    var myCat = new Cat('Micia', 20);
    alert(myCat.name); //alerts 'Micia'
    alert(myCat.age); //alerts 20
    (end)
    */

    initialize: function(handler) {
        // store data entry options [ "single" || "list" + record structure ]
        this.isSingle = (handler == "single");
        this.isList = (handler == "list");

        // store dom objects
        if (this.isList) {
            this.cdeRecordList = document.getElement('div.wkaContentArea table.wkaDataEntry td.wdeRecordList');
            this.cdeRecordListBlock = document.getElement('blockquote', this.cdeRecordList);
            this.cdeRecordListItems = new Hash();
            this.cdeRecordListItemStores = document.getElements('th input[type=hidden]', this.cdeRecordListBlock);
        }
        this.cdeRecordDetail = document.getElement('div.wkaContentArea table.wkaDataEntry td.wdeRecordDetail');
        this.cdeRecordDetailBlocks = document.getElements('blockquote.detail', this.cdeRecordDetail);

        // store user-action (loaded || default)
        this.currUserAction = this.getUserAction();

        // store data input form elements defaults ( <!> use form reset instead )
        // this.iniDefaults();

        // store "list" elements & relationships
        this.iniListing();

        // store and assign behaviour to the toolbar buttons (add/remove/edit/save/cancel)
        this.iniCommands();

        // set appearence depending on server-side generated page/html (is first-run? is post-feedback?)
        this.iniAppearence();
    },

    /*iniDefaults: function() {
		// this.backupRecordDetailDefaults();
    // this.cdeRecordDetail.getElements('input, textarea, select').each(function(el){ console.log('BACKUP RECORD DATA DEFAULTS'); el.showFormElementDefault() });
	},*/

    iniListing: function() {
        if (this.isList) {
            // store record-list data-structure
            this.cdeDataStruct = eval('(' + $('wdeRecordStruct').value + ')');

            // store record-id (loaded || "-1")
            this.currRecordID = this.getRecordID();

            // set list-items, elements and relations
            for (i = 0; i < this.cdeRecordListItemStores.length; i++) {		//  <!> in a list, an "item" is a record "store" container
                // get parent row
                var crow = this.cdeRecordListItemStores[i].getFirstParentByTag('tr');

                // get row storage data
                crow.datastore = eval('(' + this.cdeRecordListItemStores[i].value + ')'); 	// store data for current row

                // add current row to list-items hash
                this.cdeRecordListItems.set(crow.datastore[this.cdeDataStruct.recid], crow);

                // assign relations & behaviors to the records list link
                var clnk = crow.getElement('a');
                clnk.parent = crow;
                clnk.addEvent('click', this.exeRecordSelect.bindWithEvent(this));
                clnk.onclick = function() { return false; };
            }
            // store current selected row ( <!> will be populated and highlighted on iniAppearence)
            this.currSelectedRow = this.cdeRecordListItems.get(this.currRecordID);
        }
    },

    iniCommands: function() {
        // store toolbar buttons
        if (this.isList) {
            this.watAdd = document.getElement('div.wkaToolbarArea td.dosome a.watGenericAdd');
            this.watDelete = document.getElement('div.wkaToolbarArea td.dosome a.watGenericDelete');
            this.watDuplicate = document.getElement('div.wkaToolbarArea td.dosome a.watGenericDuplicate');
            this.watOpenLayoutDesigner = document.getElement('div.wkaToolbarArea td.dosome a.watOpenLayoutDesigner');
        }
        this.watEdit = document.getElement('div.wkaToolbarArea td.dosome a.watGenericEdit');
        this.watSave = document.getElement('div.wkaToolbarArea td.dosome a.watGenericSave');
        this.watCancel = document.getElement('div.wkaToolbarArea td.dosome a.watGenericCancel');
        this.watPreview = document.getElement('div.wkaToolbarArea td.dosome a.watGenericPreview'); 

        // assign the behavior to the toolbar buttons

        //[this.watAdd, this.watDelete, this.watEdit, this.watSave, this.watCancel].each(function(el){
        //if($chk(el)) {
        //	$(el).addEvent('click', this.exeToolbarButton.bindWithEvent(this));
        //	$(el).onclick = function(){return false;}
        //} }.bindWithEvent(this),this);

        if (this.isList) {
            /* [ADD] */
            if (this.watAdd) {
                this.watAdd.addEvent('click', this.exeToolbarButton.bindWithEvent(this));
                this.watAdd.onclick = function() { return false; };
            }

            /* [DELETE] */
            if (this.watDelete) {
                this.watDelete.addEvent('click', this.exeToolbarButton.bindWithEvent(this));
                this.watDelete.onclick = function() { return false; };
                this.watDeleteConfirm = this.watDelete.getProperty('message');
            }

            /* [DUPLICATE] */
            if (this.watDuplicate) {
                this.watDuplicate.addEvent('click', this.exeToolbarButton.bindWithEvent(this));
                this.watDuplicate.onclick = function() { return false; };
            }

            /* [OPEN LAYOUT DESIGNER] */
            if (this.watOpenLayoutDesigner) {
                this.watOpenLayoutDesigner.addEvent('click', this.exeToolbarButton.bindWithEvent(this));
                this.watOpenLayoutDesigner.onclick = function() { return false; };
            }
        }

        /* [EDIT] */
        if (this.watEdit) {
            this.watEdit.addEvent('click', this.exeToolbarButton.bindWithEvent(this));
            this.watEdit.onclick = function() { return false; };
        }

        /* [SAVE] */
        if (this.watSave) {
            this.watSave.addEvent('click', this.exeToolbarButton.bindWithEvent(this));
            this.watSave.onclick = function () { return false; };
        }

        /* [CANCEL] */
        if (this.watCancel) {
            this.watCancel.addEvent('click', this.exeToolbarButton.bindWithEvent(this));
            this.watCancel.onclick = function () { return false; };
        }

        /* [PREVIEW] */
        if (this.watPreview != null) {
            this.watPreview.addEvent('click', this.exeToolbarButton.bindWithEvent(this));
            this.watPreview.onclick = function() { return false; };
        }
    },

    iniAppearence: function() {
        //  ONLY AFTER POSTBACK REPLY
        if (this.currUserAction == 'saving') {
            //  go back to editing mode
            this.setUserAction('editing');

            // set visual appearence
            if (this.currSelectedRow != null) {
                this.currSelectedRow.addClass('selected');
            }

            // handle postback result (when exist)
            if ($('wdeUserActionResult')) { this.hasPostFeedback(); }
        } else {
            if (this.isList) {
                if (this.currSelectedRow != null) {
                    this.setRecordListSelection(this.currSelectedRow);
                    this.setUserAction('reading');
                } else {
                    this.setUserAction('initing');
                }
                this.lockRecordDetailElements();
            } else if (this.isSingle) {
                // DEFAULT BEHAVIOUR ( <!> there's no "add" button or list-links, so start in reading mode to enable the "edit" button!)
                this.setUserAction('reading');
                this.lockRecordDetailElements();
            }
        }
    },

    setToolbarButtonsMode: function(mode, items) {
        switch (mode) {
            case 'show': items.each(function(item) { if (item) { item.style.visibility = 'visible'; } }); break;
            case 'hide': items.each(function(item) { if (item) { item.style.visibility = 'hidden'; } }); break;
            case 'enable': items.each(function(item) { if (item) { item.removeClass('disabled'); } }); break;
            case 'disable': items.each(function(item) { if (item) { item.addClass('disabled'); } }); break;
        }
    },

    setUserAction: function(action) { /* init/read/edit/add + save/delete */

        // store current action value
        this.currUserAction = action || ((this.isList) ? "initing" : "reading");
        if ($('wdeUserAction')) $('wdeUserAction').value = this.currUserAction;

        // set visual appearence
        this.cdeRecordDetailBlocks.each(function(blk) { blk.removeClass('reading').removeClass('editing').removeClass('adding'); }); 	// reset blockquote "mode" classes
        if (this.isList) { this.cdeRecordListBlock.removeClass('disabled'); } 															// enable data list
        this.setToolbarButtonsMode('disable', [this.watAdd, this.watDelete, this.watEdit, this.watDuplicate, this.watOpenLayoutDesigner, this.watSave, this.watCancel]); 					// disable any buttons
        switch (this.currUserAction) {
            case 'initing':
                this.setToolbarButtonsMode('enable', [this.watAdd]); 												// enable add button
                break;
            case 'reading':
                this.cdeRecordDetailBlocks.each(function(blk) { blk.addClass('reading'); }); 					// set blockquote "mode" classes
                this.setToolbarButtonsMode('enable', [this.watAdd, this.watDelete, this.watEdit, this.watDuplicate, this.watOpenLayoutDesigner, this.watPreview]); // enable remove/edit buttons
                break;
            case 'adding':
                this.cdeRecordDetailBlocks.each(function(blk) { blk.addClass('adding'); }); 					// set blockquote "mode" classes
            case 'editing':
                this.cdeRecordDetailBlocks.each(function(blk) { blk.addClass('editing'); }); 					// set blockquote "mode" classes
                if (this.isList) { this.cdeRecordListBlock.addClass('disabled'); } 								// disable data list
                this.setToolbarButtonsMode('enable', [this.watSave, this.watCancel]); 								// enable save/cancel buttons
                this.setToolbarButtonsMode('disable', [this.watPreview]); 								// disable preview button
                break;
            case 'duplicating':
                break;
            case 'saving':
                break;
            case 'deleting':
                break;
        }
    },

    getUserAction: function() { /* init/read/edit/add */
        // return current action value
        return ($('wdeUserAction') ? $('wdeUserAction').value : (this.currUserAction || "initing"));
    },

    setRecordID: function(id) {
        // store current record id
        this.currRecordID = id || "-1"; // [ "-1" = new/null record ]

        // update hidden record-id holder ( $('wdeRecordID') )
        if ($(this.cdeDataStruct.recid)) $(this.cdeDataStruct.recid).value = this.currRecordID;
    },

    getRecordID: function() {
        // return current record id  ( from $('wdeRecordID') or default )
        return ($(this.cdeDataStruct.recid) ? $(this.cdeDataStruct.recid).value : (this.currRecordID || "-1")); // [ "-1" = new/null record ]
    },

    setRecordListSelection: function(row) {
        if (this.currSelectedRow) { this.currSelectedRow.removeClass('selected'); } 	// unset visual appearence
        this.unsetRecordListSelection('erase'); 										// get ready to accept data emptying form controls

        this.currSelectedRow = row; 													// update/store row as reference object
        this.currSelectedRow.addClass('selected'); 									// set visual appearence

        this.populateRecordDetailValues(this.currSelectedRow.datastore); 			// populate data details using json structure

        //this.setRecordID(this.currSelectedRowStore.id);								// set current record id [ora non serve piu' - viene settato direttamente dal "populate" via json]
    },

    unsetRecordListSelection: function(mode) {
        if (this.currSelectedRow) { this.currSelectedRow.removeClass('selected'); } 	// unset visual appearence
        if (this.isList) { this.setRecordID(); } 										// unset current record id (only if list, obviously!)
        this.currSelectedRow = null; 												// unstore the reference object
        this.cdeRecordDetail.resetFormElements(mode); 								// restore defaults or completely erase cleanup data details
    },

    lockRecordDetailElements: function() {
        this.cdeRecordDetail.lockFormElements('lock'); 	// options: [freeze/lock]
    },

    unlockRecordDetailElements: function() {
        this.cdeRecordDetail.lockFormElements('unlock'); // options: [unfreeze/unlock]
    },

    reset_fbackerrors: function() {
        // document.getElements('div.wkaContentArea div.actionfeedback').each(function(spn) { $(spn).effect('opacity', {duration: 1000, 'onComplete': function(){ this.element.remove(); }}).start(0); });
        document.getElements('div.wkaContentArea div.actionfeedback').each(function(spn) { spn.remove(); });
        document.getElements('span.fbackerrors', this.cdeRecordDetail).each(function(spn) { spn.remove(); });
    },

    populateRecordDetailValues: function(rowstore) {
        if (rowstore['decLink'] != null && rowstore['decLink'] != "") {
            $('decLink').getParent().getParent().setStyle('display', '');
        }

        Object.each(this.cdeDataStruct, function(currObject, currObjectName) {
            if ($type(currObject) == 'string' && $(currObject) != null) {
                //				console.log("found single record element as "+currObjectName +" to be stored in "+ currObject);
                $(currObject).setFormElementValue(rowstore[currObject]);
                $(currObject).fireEvent('change');
            } else if ($type(currObject) == 'object') {
                //				console.log("found group record element as "+currObjectName+" with target id = "+ currObjectName + "_" + currObject.subid +" and value "+ currObject.subvalue);
                Object.each(rowstore[currObjectName], function(currSubObject) {
                    // test if target object exist
                    if ($(currObjectName + "_" + currSubObject[currObject.subid])) {
                        $(currObjectName + "_" + currSubObject[currObject.subid]).setFormElementValue(currSubObject[currObject.subvalue]);
                        $(currObjectName + "_" + currSubObject[currObject.subid]).fireEvent('change');
                    }
                }, this);
            }
        }, this);

        // fire custom "onPopulate" event on data detail blocks (inline event assignment on the html page)
        this.cdeRecordDetailBlocks.each(function(blk) { blk.fireEvent('onPopulate'); });
    },

    exeRecordSelect: function(event) {
        // user must "complete or cancel" data entry
        if (['editing', 'adding'].contains(this.currUserAction)) return;

        var event = new Event(event);
        this.setUserAction('reading');
        this.setRecordListSelection(event.target.parent); // ancestor <tr> of clicked link
        this.lockRecordDetailElements();
        this.reset_fbackerrors();
    },

    exeToolbarButton: function(event) {
        var event = new Event(event); // necessary to handle event.target

        /* [skip if button is disabled] */
        if (event.target.hasClass('disabled')) {
            return;
            /* [ADD] */
        } else if (event.target.hasClass('watGenericAdd')) {
            this.unsetRecordListSelection('restore');
            this.setUserAction('adding');
            this.unlockRecordDetailElements();
            this.reset_fbackerrors();
            /* [DELETE] */
        } else if (event.target.hasClass('watGenericDelete')) {
            if (confirm(this.watDeleteConfirm)) {
                this.setUserAction('deleting'); 			// freeze toolbar
                this.exeToolbarButtonDefault(event.target); // perform backend-assigned action
                //this.lockRecordDetailElements();			// DON'T freeze controls (not submitted when disabled, DUDE!)
            }
            /* [EDIT] */
        } else if (event.target.hasClass('watGenericEdit')) {
            this.setUserAction('editing');
            this.unlockRecordDetailElements();
            /* [DUPLICATE] */
        } else if (event.target.hasClass('watGenericDuplicate')) {
            this.setUserAction('duplicating'); 			// freeze toolbar
            this.exeToolbarButtonDefault(event.target);     // perform backend-assigned action
            //this.lockRecordDetailElements();				// DON'T freeze controls (not submitted when disabled, DUDE!)
            /* [OPEN LAYOUT DESIGNER] */
        } else if (event.target.hasClass('watOpenLayoutDesigner')) {
            this.setUserAction('opening');  				// freeze toolbar
            this.exeToolbarButtonDefault(event.target);     // perform backend-assigned action
            //this.lockRecordDetailElements();				// DON'T freeze controls (not submitted when disabled, DUDE!)
            /* [SAVE] */
        } else if (event.target.hasClass('watGenericSave')) {
            this.setUserAction('saving'); 				// freeze toolbar
            this.exeToolbarButtonDefault(event.target);     // perform backend-assigned action
            //this.lockRecordDetailElements();				// DON'T freeze controls (not submitted when disabled, DUDE!)
            /* [CANCEL] */
        } else if (event.target.hasClass('watGenericCancel')) {
            if (this.isList && this.currSelectedRow) {
                switch (this.currUserAction) {
                    case 'editing':
                        this.setRecordListSelection(this.currSelectedRow);
                        this.setUserAction('reading');
                        break;
                    default:
                        this.unsetRecordListSelection('restore');
                        this.setUserAction();
                }
            } else {
                this.unsetRecordListSelection('restore');
                this.setUserAction();
            }
            this.lockRecordDetailElements();
            this.reset_fbackerrors();
        }
    },

    exeToolbarButtonDefault: function(butt) {
        // raw but works!
        window.location = butt.href;
    },

    hasPostFeedback: function() {
        // get postback results
        var cuar = eval('(' + $('wdeUserActionResult').value + ')');

        //
        if ($chk(cuar.result)) {
            switch (cuar.result) {
                case 'error_on_validate':
                    // populate data details with postback-received data
                    if ($chk(cuar.submitted_data)) {
                        this.populateRecordDetailValues(cuar.submitted_data);
                    }
                    // TODO: highlight wrong fields
                    break;
                case 'error_on_save':
                    // populate data details with postback-received data
                    if ($chk(cuar.submitted_data)) {
                        this.populateRecordDetailValues(cuar.submitted_data);
                    }
                    // TODO: highlight wrong fields
                    break;
            }
        }
    },

    // #####  DONT'T REMOVE  #####
    safari2hatesmissingcommas: function() { }
});

var superGridNetworkTable = new Class({
    /* ________ TABLE NESTED STRUCTURE - START______________________________________

	<div id="" class="wrpSuperGridNetworkTable">

		<table id="" class="sgnInterfacesTable">

		  <colgroup class="sgnColGrp">
    <col class="sgnIco" />
    <col class="sgnCmd" span="N"/>
    <col class="sgnData" />
    <col class="sgnCmd" />
    </colgroup>

		  <tr class="hdwInterface" id="ifcXX">
    <th></th>
    <td><input type="checkbox" name="" value="ifcXX" /></td>
    <td>Lorem ipsum</td>
    <td><a href="#" class="sgnFoldingButton">+</a></td>

		  <tr class="hdwInterfaceChild">
    <td></td>
    <td class="sgnSpan" colspan="x">

					<table class="sgnDevicesTable">
    <tr class="hdwDevice" id="ifcXX:devYY">

					  <tr class="hdwDeviceChild">
    <td></td>
    <td class="sgnSpan" colspan="x">

							<table class="sgnResourcesTable">
    <tr class="hdwResource" id="ifcXX:devYY:resZZ">

	___________________________________________________________________________END__ */

    initialize: function() {
        // >>> note: su reti grandi da' problemi di rallentamento - support.microsoft.com/kb/175500

        // store behaviour objects
        this.boxWrapper = document.getElement('div.wrpSuperGridNetworkTable');

        // init user preferences cookies
        this.adduserpreferences();

        // handle filters & visual helpers
        this.addcontrollers();

        // store intruments (ifc,dev,res) and their relationships
        this.addinstruments();

        // handle events.
        this.boxWrapper.addEvent('click', this.interact_bubbleClick.bindWithEvent(this));
        // this.boxWrapper.addEvent('dblclick', this.interact_bubbleDoubleClick.bindWithEvent(this));
        // this.boxWrapper.addEvent('change', this.interact_bubbleChange.bindWithEvent(this));			// onchange doesn't bubble on IE!! so handle it locally (see later)

        // init visual row selection highlightning
        this.redraw_updateSelections();

        // redraw network listing based on cookie-stored or default filter values
        this.redraw_updateListing();

        // false:  if at least one device of interface is selected then interface is selected (classical behaviour)
        // true:   if all devices of interface are selected then the interface is selected (Alarms categories behaviour)
        this.deviceSelectionTriggersInterfaceAutoCheckWhenAllOfItsDevicesAraChecked = false;

        // stop "wait-loading" procedure
        this.boxWrapper.removeClass('sgnWaitLoading');
    },

    addinstruments: function() {
        // init "partial" handlers
        this.rowsInterfaces = this.gethardware_rows('hdwInterface');
        this.rowsDevices = this.gethardware_rows('hdwDevice');
        this.rowsResAnalog = this.gethardware_rows('hdwResAnalog');
        this.rowsResDigital = this.gethardware_rows('hdwResDigital');
        this.rowsResState = this.gethardware_rows('hdwResState');
        this.rowsResAlarm = this.gethardware_rows('hdwResAlarm');

        this.rowsResources = new Array();
        this.rowsResources = this.rowsResources.append(this.rowsResAnalog);
        this.rowsResources = this.rowsResources.append(this.rowsResDigital);
        this.rowsResources = this.rowsResources.append(this.rowsResState);
        this.rowsResources = this.rowsResources.append(this.rowsResAlarm);

        this.rowsAlrSleeping = this.gethardware_rows('alrSleeping');
        this.rowsAlrConfirmed = this.gethardware_rows('alrConfirmed');
        this.rowsAlrActive = this.gethardware_rows('alrActive');

        this.chkSelectors = new Array();
        this.fldButtons = new Array();

        // store rows relationships (selector, foldbutt(?), childrow wrapper, etc. )
        this.sethardware_rowrelations('ifc', this.rowsInterfaces);
        this.sethardware_rowrelations('dev', this.rowsDevices);
        this.sethardware_rowrelations('res', this.rowsResAnalog);
        this.sethardware_rowrelations('res', this.rowsResDigital);
        this.sethardware_rowrelations('res', this.rowsResState);
        this.sethardware_rowrelations('res', this.rowsResAlarm);
    },

    gethardware_rows: function(knd) {
        return this.boxWrapper.getElements('tr.' + knd);
    },

    sethardware_rowrelations: function(kind, rows) {
        var cknd = kind;

        rows.each(function(crw) {
            // store row selector (when exists)
            var crwchk = crw.getElement('input.sgnSelector');
            if (crwchk) {
                crw.selector = crwchk; 					// store a reference to the current row's selector
                crwchk.parent = crw; 					// store a reference to the selector's parent row
                this.chkSelectors.push(crwchk); 		// add selector to grid selectors list
            }

            // store row folding butt (when exists and row is not a resource)
            if (cknd != 'res') {
                var crwfld = crw.getElement('a.sgnFoldingButton');
                if (crwfld) {
                    crw.foldbutt = crwfld; 					// store a reference to the current row's folding button
                    crwfld.parent = crw; 					// store a reference to the folding button's parent row
                    this.fldButtons.push(crwfld); 		// add fold button to grid fold buttons list
                }
            }

            // store row input elements (when exist)
            var crwinps = crw.getElements('input, textarea, select');
            crwinps.each(function(cip) {
                cip.parent = crw; 					// store a reference to the input's parent row
                cip.addEvent('change', 				// handle input change event as row update
					this.onchange_updateRow.pass(cip.parent, this)
				);
            }, this);

            // store "child wrapper" row (when exists and row is not a resource)
            if (cknd != 'res') {
                var crwchild = $(crw.id + "_child");
                if (crwchild) {
                    crw.childrow = crwchild; 			// store a reference to the current row's child wrapper
                    crwchild.parent = crw; 				// store a reference to the wrapper's parent row
                    crw.childlist = []; 					// init current row's list of child
                }
            }

            // store parent row (when exists)
            var crwparent = $(crw.id.substring(0, crw.id.lastIndexOf(':')));
            if (crwparent) {
                crw.parent = crwparent; 				// store a reference to the parent row
                crw.parent.childlist.push(crw); 		// add current row to parent's list of child
            }
        }, this);
    },

    adduserpreferences: function() {
        var cookid = getFolding().join('-') + '_usrFilterPrefs';
        //[GREGOR]
        this.userprefs = new Hash.Cookie(cookid,{duration:365});
    },

    addcontrollers: function() {
        // add listing filters (if they exist)
        if (document.getElement('#sgnFilterShow_Devices')) { this.addcontrol('filter_by_devices'); }
        if (document.getElement('#sgnFilterShow_ResourcesDescription')) { this.addcontrol('filter_by_resources_description'); }
        if (document.getElement('#sgnFilterShow_Resources')) { this.addcontrol('filter_by_resources'); }
        if (document.getElement('#sgnFilterShow_Alarms') && $('sgnFilterShow_chkAlrActive')) { this.addcontrol('filter_by_alarms'); }
        if (document.getElement('#sgnFilterShow_Maintenance')) { this.addcontrol('filter_by_maintenance'); }
        if (document.getElement('#sgnFilterShow_Selected')) { this.addcontrol('filter_by_selected'); }

        // add visual helpers (if they exist)
        if (document.getElement('#sgnVisualShow_Helpers')) { this.addcontrol('visual_helpers'); }
        if (document.getElement('#sgnVisualShow_Suppression')) { this.addcontrol('visual_suppression'); }
        if (this.boxWrapper.hasClass('highlight_selected')) { this.addcontrol('highlight_selections'); }
        if (this.boxWrapper.hasClass('highlight_changed')) { this.addcontrol('highlight_changes'); }

        // add global filter clearer (if exists)
        if (document.getElement('.wkaToolbarArea a.watGridClearFilter')) { document.getElement('.wkaToolbarArea a.watGridClearFilter').addEvent('click', this.toolbar_exeClearFilter.bindWithEvent(this)); }
        if (document.getElement('.imgCommandClearFilter')) {
            document.getElement('.imgCommandClearFilter').addEvent('click', this.toolbar_exeClearFilter.bindWithEvent(this));
        }


        // add global togglers/checkers (if they exist)
        if (document.getElement('.wkaToolbarArea a.watGridExpandAll')) { document.getElement('.wkaToolbarArea a.watGridExpandAll').addEvent('click', this.toolbar_exeExpandAll.bindWithEvent(this)); }
        if (document.getElement('.wkaToolbarArea a.watGridCollapseAll')) { document.getElement('.wkaToolbarArea a.watGridCollapseAll').addEvent('click', this.toolbar_exeCollapseAll.bindWithEvent(this)); }
        if (document.getElement('.wkaToolbarArea a.watSelectall')) { document.getElement('.wkaToolbarArea a.watSelectall').addEvent('click', this.toolbar_exeSelectAll.bindWithEvent(this)); }
        if (document.getElement('.wkaToolbarArea a.watUnselectall')) { document.getElement('.wkaToolbarArea a.watUnselectall').addEvent('click', this.toolbar_exeUnselectAll.bindWithEvent(this)); }
    },

    addcontrol: function(knd) {
        switch (knd) {
            case 'filter_by_devices':
                // handle device description input field
                $('sgnFilterShow_inpDevDescription').addEvent('keyup', this.redraw_delayedListing.pass(1000, this));
                $('sgnFilterShow_inpDevDescription').addEvent('change', this.redraw_delayedListing.pass(500, this));
                // load saved state
                if (this.userprefs.get('sgnFilterShow_inpDevDescription') != null) { $('sgnFilterShow_inpDevDescription').value = this.userprefs.get('sgnFilterShow_inpDevDescription'); }
                // conditional reference to be used later
                this.filter_by_devices = true;
                break;
            case 'filter_by_resources_description':
                // handle resource description input field
                $('sgnFilterShow_inpResDescription').addEvent('keyup', this.redraw_delayedListing.pass(1000, this));
                $('sgnFilterShow_inpResDescription').addEvent('change', this.redraw_delayedListing.pass(500, this));
                // load saved state
                if (this.userprefs.get('sgnFilterShow_inpResDescription') != null) { $('sgnFilterShow_inpResDescription').value = this.userprefs.get('sgnFilterShow_inpResDescription'); }
                // conditional reference to be used later
                this.filter_by_resources_description = true;
                break;
            case 'filter_by_resources':
                // handle resource kind checkboxes
                 $('sgnFilterShow_chkResAnalog').addEvent('click', this.redraw_delayedListing.pass(500, this));
                 $('sgnFilterShow_chkResDigital').addEvent('click', this.redraw_delayedListing.pass(500, this));
                 $('sgnFilterShow_chkResState').addEvent('click', this.redraw_delayedListing.pass(500, this));
                 $('sgnFilterShow_chkResAlarm').addEvent('click', this.redraw_delayedListing.pass(500, this));
                // load saved state
                if (this.userprefs.get('sgnFilterShow_chkResAnalog') != null) { $('sgnFilterShow_chkResAnalog').checked = this.userprefs.get('sgnFilterShow_chkResAnalog'); }
                if (this.userprefs.get('sgnFilterShow_chkResDigital') != null) { $('sgnFilterShow_chkResDigital').checked = this.userprefs.get('sgnFilterShow_chkResDigital'); }
                if (this.userprefs.get('sgnFilterShow_chkResState') != null) { $('sgnFilterShow_chkResState').checked = this.userprefs.get('sgnFilterShow_chkResState'); }
                if (this.userprefs.get('sgnFilterShow_chkResAlarm') != null) { $('sgnFilterShow_chkResAlarm').checked = this.userprefs.get('sgnFilterShow_chkResAlarm'); }
                // conditional reference to be used later
                this.filter_by_resources = true;
                break;
            case 'filter_by_alarms':
                // handle resource kind checkboxes
                 $('sgnFilterShow_chkAlrActive').addEvent('click', this.redraw_delayedListing.pass(500, this));
                 $('sgnFilterShow_chkAlrConfirmed').addEvent('click', this.redraw_delayedListing.pass(500, this));
                 $('sgnFilterShow_chkAlrSleeping').addEvent('click', this.redraw_delayedListing.pass(500, this));
                // load saved state
                if (this.userprefs.get('sgnFilterShow_chkAlrActive') != null) { $('sgnFilterShow_chkAlrActive').checked = this.userprefs.get('sgnFilterShow_chkAlrActive'); }
                if (this.userprefs.get('sgnFilterShow_chkAlrConfirmed') != null) { $('sgnFilterShow_chkAlrConfirmed').checked = this.userprefs.get('sgnFilterShow_chkAlrConfirmed'); }
                if (this.userprefs.get('sgnFilterShow_chkAlrSleeping') != null) { $('sgnFilterShow_chkAlrSleeping').checked = this.userprefs.get('sgnFilterShow_chkAlrSleeping'); }
                // conditional reference to be used later
                this.filter_by_alarms = true;
                break;
            case 'filter_by_maintenance':

                if ($('sgnFilterShow_selMaintenance')) {
                    // handle maintenance selector
                    $('sgnFilterShow_selMaintenance').addEvent('click', this.redraw_delayedListing.pass(500, this));
                    // load saved state
                    if (this.userprefs.get('sgnFilterShow_selMaintenance') != null) { $('sgnFilterShow_selMaintenance').selectedIndex = this.userprefs.get('sgnFilterShow_selMaintenance'); }
                }
                if ($('sgnFilterShow_chkOnlineOnly')) { // adapter in case a checkbox is used instead of a combo
                    // handle maintenance selector
                    $('sgnFilterShow_chkOnlineOnly').addEvent('click', this.redraw_delayedListing.pass(500, this));
                    // load saved state (this is an adapter that load selected value store from combo and fill checkbox state)
                    if (this.userprefs.get('sgnFilterShow_selMaintenance') != null) { $('sgnFilterShow_chkOnlineOnly').checked = (this.userprefs.get('sgnFilterShow_selMaintenance') == 2); }
                }

                // conditional reference to be used later
                this.filter_by_maintenance = true;
                break;
            case 'filter_by_selected':
                // handle filter by selection
                $('sgnFilterShow_radSelected0').addEvent('click', this.redraw_delayedListing.pass(500, this));
                $('sgnFilterShow_radSelected1').addEvent('click', this.redraw_delayedListing.pass(500, this));
                $('sgnFilterShow_radSelected2').addEvent('click', this.redraw_delayedListing.pass(500, this));
                if (this.userprefs.get('sgnFilterShow_radSelected') != null) {
                    var selectedValue = this.userprefs.get('sgnFilterShow_radSelected');
                    switch (selectedValue) {
                        case 0:
                            $('sgnFilterShow_radSelected0').checked = true;
                            break;
                        case 1:
                            $('sgnFilterShow_radSelected1').checked = true;
                            break;
                        case 2:
                            $('sgnFilterShow_radSelected2').checked = true;
                            break;
                    }
                }
                else {
                    // predefined value
                    $('sgnFilterShow_radSelected0').checked = true;
                }
                this.filter_by_selected = true;
                break;
            case 'visual_helpers':
                // handle table-headers & legend togglers
                if ($('sgnVisualShow_chkTabHead')) {
                    $('sgnVisualShow_chkTabHead').addEvent('click', function(event) { this.helper_togTabHead(event.target.checked); } .bindWithEvent(this));
                    // load saved state
                    if (this.userprefs.get('sgnVisualShow_chkTabHead') != null) { $('sgnVisualShow_chkTabHead').checked = this.userprefs.get('sgnVisualShow_chkTabHead'); }
                }
                if ($('sgnVisualShow_chkLegend')) {
                    $('sgnVisualShow_chkLegend').addEvent('click', function(event) { this.helper_togLegend(event.target.checked); } .bindWithEvent(this));
                    if (this.userprefs.get('sgnVisualShow_chkLegend') != null) { $('sgnVisualShow_chkLegend').checked = this.userprefs.get('sgnVisualShow_chkLegend'); }
                }
                // conditional reference to be used later
                this.visual_helpers = true;
                break;
            case 'visual_suppression':
                // conditional reference to be used later
                this.visual_suppression = true;
                break;
            case 'highlight_selections':
                // conditional reference to be used later
                this.highlight_selections = true;
                break;
            case 'highlight_changes':
                // conditional reference to be used later
                this.highlight_changes = true;
                break;
        }
    },

    interact_bubbleClick: function(event) {
        // init moo event handling
        var event = new Event(event);
        var ccobj = $(event.target);

        // check if clicked element requires handling
        //if(ccobj.get('tag')=='input' ccobj.type=='checkbox' && ccobj.hasClass('sgnSelector')) {
        //if(ccobj.get('tag')=='input' && ccobj.hasClass('sgnSelector')) {
        if (ccobj.hasClass('sgnSelector')) {
            //var crow = ccobj.getFirstParentByTag('tr');
            var crow = ccobj.parent;

            if (crow.parent) { this.onselect_updateParent(crow, true); }
            if (crow.childrow) { this.onselect_updateChilds(crow, true); }

            // stop propagation
            event.stopPropagation();

            //} else if (ccobj.get('tag')=='a' && ccobj.hasClass('sgnFoldingButton')) {
        } else if (ccobj.hasClass('sgnFoldingButton')) {
            //var crow = ccobj.getFirstParentByTag('tr');
            var crow = ccobj.parent;

            crow.toggleClass('childwasfolded');
            if (crow.childrow) { crow.childrow.toggleClass('folded'); }

            // stop propagation and prevent default action (on empty anchors)
            event.stop();
        }

        // console.log('interact_bubbleClick on ' + ccobj.get('tag'));
        // console.log('interact_bubbleClick parent is ' + ccobj.getFirstParentByTag('tr').id);
    },

    /*interact_bubbleChange: function(event) {
		// init moo event handling
    var event = new Event(event);
    var ccobj = $(event.target);

		// console.log('interact_bubbleChange on ' + ccobj.get('tag'));
    // console.log('interact_bubbleChange parent is ' + ccobj.parent.id);
	},*/

    helper_togTabHead: function(bol) {
        // toggle grid wrapper class
        this.boxWrapper.conditionalClass('sgnNoHeaders', !bol);

        // store user preferences in a cookie
        this.userprefs.extend({ 'sgnVisualShow_chkTabHead': bol });
    },

    helper_togLegend: function(bol) {
        // toggle legend visibility
        $('sgnVisualShow_wrpLegend').setStyle('display', bol ? 'block' : 'none');

        // store user preferences in a cookie
        this.userprefs.extend({ 'sgnVisualShow_chkLegend': bol });
    },

    helper_togSuppression: function(bol) {
        // toggle table caption visibility
        $('sgnVisualShow_Suppression').setStyle('display', bol ? '' : 'none');
    },

    toolbar_exeExpandAll: function(event) {
        // init moo event handling
        var event = new Event(event);

        // expand recursively
        this.fldButtons.each(function(ctg) { ctg.parent.removeClass('childwasfolded'); if (ctg.parent.childrow) { ctg.parent.childrow.removeClass('folded'); } });
        //if(this.rowsInterfaces) { this.rowsInterfaces.each(function(crw){	crw.removeClass('childwasfolded'); if(crw.childrow) { crw.childrow.removeClass('folded'); } }); }
        //if(this.rowsDevices)    { this.rowsDevices.each(function(crw){		crw.removeClass('childwasfolded'); if(crw.childrow) { crw.childrow.removeClass('folded'); } }); }

        // prevent default action
        event.preventDefault();
    },

    toolbar_exeCollapseAll: function(event) {
        // init moo event handling
        var event = new Event(event);

        // collapse recursively
        this.fldButtons.each(function(ctg) { ctg.parent.addClass('childwasfolded'); if (ctg.parent.childrow) { ctg.parent.childrow.addClass('folded'); } });
        //if(this.rowsInterfaces) { this.rowsInterfaces.each(function(crw){	crw.addClass('childwasfolded'  ); if(crw.childrow) { crw.childrow.addClass('folded'); } }); }
        //if(this.rowsDevices)    { this.rowsDevices.each(function(crw){		crw.addClass('childwasfolded'); if(crw.childrow) { crw.childrow.addClass('folded'); } }); }

        // prevent default action
        event.preventDefault();
    },

    toolbar_exeSelectAll: function(event) {
        // init moo event handling
        var event = new Event(event);

        // select all [warning: selects any row selector, even if hidden]
        // if(this.chkSelectors) { this.chkSelectors.each(function(cck){ if(!cck.disabled) { cck.checked = true; /*cck.fireEvent('change');*/ } });  }

        // select only visible
        if (this.chkSelectors) { this.chkSelectors.each(function(cck) { if (!cck.parent.suppressed && !cck.disabled) { cck.checked = true; /*cck.fireEvent('change');*/ } }); }

        // update row selection highlightning
        this.redraw_updateSelections();

        // prevent default action
        event.preventDefault();
    },

    toolbar_exeUnselectAll: function(event) {
        // init moo event handling
        var event = new Event(event);

        // unselect all
        // if(this.chkSelectors) { this.chkSelectors.each(function(cck){ if(!cck.disabled) { cck.checked = false; /*cck.fireEvent('change');*/ } });  }

        // unselect only visible
        if (this.chkSelectors) { this.chkSelectors.each(function(cck) { if (!cck.parent.suppressed && !cck.disabled) { cck.checked = false; /*cck.fireEvent('change');*/ } }); }

        // update row selection highlightning
        this.redraw_updateSelections();

        // prevent default action
        event.preventDefault();
    },

    toolbar_exeClearFilter: function(event) {
        // init moo event handling
        var event = new Event(event);

        // reset form controls values on filter area
        var wkaFilterAreaElement = document.getElement('.wkaFilterArea');
        if (wkaFilterAreaElement)
            wkaFilterAreaElement.resetFormElements('restore');

        // also when filter controls are on top (pupup)
        var filterContainerElement = document.getElement('.filter-container');
        if (filterContainerElement)
            filterContainerElement.resetFormElements('restore');

        // redraw network listing
        this.redraw_updateListing();

        // clear & re-initialize cookie
        this.userprefs.empty();
        this.adduserpreferences();

        // prevent default action
        event.preventDefault();
    },

    onchange_updateRow: function(row, recursive) {
        if (this.highlight_changes) { $(row).addClass('changed'); }
        if (this.highlight_selections) { $(row).conditionalClass('selected', ($(row).selector && $(row).selector.checked)); }
    },

    onselect_updateParent: function(row, recursive) {
        if (!row.parent) return;

        var gbol = false;
        row.parent.childlist.each(function(csr) {
            if (csr.selector) { gbol = gbol || csr.selector.checked; }
        });

        if (this.deviceSelectionTriggersInterfaceAutoCheckWhenAllOfItsDevicesAraChecked)
        {
            gbol = true;
            row.parent.childlist.each(function (csr) {
                if (csr.selector) { gbol = gbol && csr.selector.checked; }
            });
        }

        if (row.parent.selector && row.parent.selector.checked != gbol) { row.parent.selector.checked = gbol; row.parent.selector.fireEvent('change'); }
        if (recursive) { this.onselect_updateParent(row.parent, true); }
    },

    onselect_updateChilds: function(row, recursive) {
        if (!row.childlist) return;

        row.childlist.each(function(ccr) {
            if (ccr.selector && !ccr.suppressed && !ccr.selector.disabled && ccr.selector.checked != row.selector.checked) {
                ccr.selector.checked = row.selector.checked;
                ccr.selector.fireEvent('change');
            }
            if (recursive) { this.onselect_updateChilds(ccr, true); }
        }, this);
         
        row.fireEvent('onselectcompleted'); // used in alarm categories
    },

    redraw_suppressRow: function(row, recursive) {
        // suppress current row
        row.addClass('suppressed'); row.suppressed = true;

        // suppress row childs
        if (recursive) { this.redraw_suppressRowChilds(row, true); }
    },

    redraw_suppressRowChilds: function(row, recursive) {
        if (!row.childlist || row.childrow.suppressed) return;

        row.childrow.addClass('suppressed'); row.childrow.suppressed = true;
        row.childlist.each(function(ccr) {
            ccr.addClass('suppressed'); ccr.suppressed = true;
            if (recursive) { this.redraw_suppressRowChilds(ccr, true); }
        }, this);
    },

    redraw_checkChildrenSelection: function(row, recursive, selected) {
        if (!row.childlist || row.childrow.suppressed) return;

        var atLeastOne = false;
        row.childlist.each(function(child) {
            if (child.selector) {
                if ((selected && child.selector.checked) || (!selected && !child.selector.checked)) {
                    atLeastOne = true;
                }
            }
        }, this);
        return atLeastOne;
    },

    redraw_checkChildrenVisibility: function(row, recursive, searchVisible) {
        if (!row.childlist || row.childrow.suppressed) return;

        var atLeastOne = false;
        row.childlist.each(function(child) {
            if ((searchVisible && !child.suppressed) || (!searchVisible && child.suppressed)) {
                atLeastOne = true;
            }
        }, this);
        return atLeastOne;
    },

    redraw_updateSelections: function() {
        if (!this.highlight_selections) return;

        // set row selection
        if (this.rowsInterfaces) { this.rowsInterfaces.each(function(crw) { crw.conditionalClass('selected', (crw.selector && crw.selector.checked)); }, this); }
        if (this.rowsDevices) { this.rowsDevices.each(function(crw) { crw.conditionalClass('selected', (crw.selector && crw.selector.checked)); }, this); }
        if (this.rowsResources) { this.rowsResources.each(function(crw) { crw.conditionalClass('selected', (crw.selector && crw.selector.checked)); }, this); }
    },

    redraw_updateListing: function() {
        // reset row suppression
        this.boxWrapper.getElements('tr.suppressed').each(function(crw) { crw.removeClass('suppressed'); crw.suppressed = false; });

        // filter on resources kind [resources]
        if (this.filter_by_resources) {
            var cran = $('sgnFilterShow_chkResAnalog').checked;
            var crdg = $('sgnFilterShow_chkResDigital').checked;
            var crst = $('sgnFilterShow_chkResState').checked;
            var cral = $('sgnFilterShow_chkResAlarm').checked;

            if (this.rowsResAnalog && !cran) { this.rowsResAnalog.each(function(crw) { this.redraw_suppressRow(crw, false); }, this); }
            if (this.rowsResDigital && !crdg) { this.rowsResDigital.each(function(crw) { this.redraw_suppressRow(crw, false); }, this); }
            if (this.rowsResState && !crst) { this.rowsResState.each(function(crw) { this.redraw_suppressRow(crw, false); }, this); }
            if (this.rowsResAlarm && !cral) { this.rowsResAlarm.each(function(crw) { this.redraw_suppressRow(crw, false); }, this); }

            // store user preferences in a cookie
            this.userprefs.extend({ 'sgnFilterShow_chkResAnalog': cran, 'sgnFilterShow_chkResDigital': crdg, 'sgnFilterShow_chkResState': crst, 'sgnFilterShow_chkResAlarm': cral });
        }


        // filter on devices description [devices]+[recursive]
        if (this.filter_by_resources_description) {
            var cdds = $('sgnFilterShow_inpResDescription').get('value').toLowerCase();

            var cdrfString = '1,2';
            var cdrfArray = new Array();

            var cdrfStringArray = cdrfString.split(',');
            cdrfStringArray.each(function (item) {
                var cdrfToAdd = item.toInt() - 1;
                cdrfArray.push(cdrfToAdd);
            });


            if (cdds != '' && this.rowsResources) {
                this.rowsResources.each(function (crw) {

                    var mustBeSuppressed = true;

                    for (var i = 0; i < crw.cells.length; i++) {
                        var cellElement = $(crw.cells[i]);

                        if (cellElement) {
                            var cellElementChild = cellElement.children[0];

                            if (cellElementChild && (cellElementChild.tagName.toLowerCase() == "input")) {
                                if (cellElementChild.value && cellElementChild.value.toLowerCase().test(cdds))
                                    mustBeSuppressed = false;
                            }
                            else if (cellElement.get('text') && cellElement.get('text').toLowerCase().test(cdds)) {
                                mustBeSuppressed = false;
                            }
                        }

                    }

                    if (mustBeSuppressed) {
                        crw.addClass('suppressed'); crw.suppressed = true; 	// suppress current row
                        // this.redraw_suppressRowChilds(crw, true); 	    // suppress row childs not needed for resource
                    }


                }, this);
            }

            // store user preferences in a cookie
            // [ERIK]
            //this.userprefs.extend({ 'sgnFilterShow_inpDevDescription': cdds });
            this.userprefs.extend({ 'sgnFilterShow_inpResDescription': cdds });
        }

        // filter on devices description [devices]+[recursive]
        if (this.filter_by_devices) {
            var cdds = $('sgnFilterShow_inpDevDescription').get('value').toLowerCase();

            var cdrfString = $('sgnFilterShow_refDevDescription').get('value');
            var cdrfArray = new Array();

            var cdrfStringArray = cdrfString.split(',');
            cdrfStringArray.each(function (item) {
                var cdrfToAdd = item.toInt() - 1;
                cdrfArray.push(cdrfToAdd);
            });

            if (cdds != '' && this.rowsDevices) {
                this.rowsDevices.each(function (crw) {

                    var mustBeSuppressed = true;

                    cdrfArray.each(function (cdrf) {

                        var cellElement = $(crw.cells[cdrf]);

                        if (cellElement) {
                            var cellElementChild = $(crw.cells[cdrf]).children[0];

                            if (cellElementChild && (cellElementChild.tagName.toLowerCase() == "input")) {
                                if (cellElementChild.value && cellElementChild.value.toLowerCase().test(cdds))
                                    mustBeSuppressed = false;
                            }
                            else if (cellElement.get('text') && (cellElement.get('text').toLowerCase().test(cdds))) {
                                mustBeSuppressed = false;
                            }
                        }

                    });

                    if (mustBeSuppressed) {
                        crw.addClass('suppressed'); crw.suppressed = true; 	// suppress current row
                        this.redraw_suppressRowChilds(crw, true); 			// suppress row childs
                    }


                }, this);
            }

            // store user preferences in a cookie
            // [ERIK]
            //this.userprefs.extend({ 'sgnFilterShow_inpDevDescription': cdds });
            this.userprefs.extend({ 'sgnFilterShow_inpDevDescription': cdds });
        }

        // alarm status filter [cross-device]+[recursive]
        if (this.filter_by_alarms) {
            var casl = $('sgnFilterShow_chkAlrSleeping').checked;
            var cacf = $('sgnFilterShow_chkAlrConfirmed').checked;
            var caac = $('sgnFilterShow_chkAlrActive').checked;

            if (this.rowsAlrSleeping && !casl) { this.rowsAlrSleeping.each(function(crw) { this.redraw_suppressRow(crw, true); }, this); }
            if (this.rowsAlrConfirmed && !cacf) { this.rowsAlrConfirmed.each(function(crw) { this.redraw_suppressRow(crw, true); }, this); }
            if (this.rowsAlrActive && !caac) { this.rowsAlrActive.each(function(crw) { this.redraw_suppressRow(crw, true); }, this); }

            if (this.rowsDevices) {
                this.rowsDevices.each(function(crw) {
                    if (!crw.suppressed) {
                        // I must check every children to see if one is not suppressed
                        if (!this.redraw_checkChildrenVisibility(crw, true, true)) {
                            // every children is suppressed --> suppress all
                            crw.addClass('suppressed'); crw.suppressed = true;
                            this.redraw_suppressRowChilds(crw, true); 			// suppress row childs
                        }
                    }
                }, this);
            }

            // store user preferences in a cookie
            this.userprefs.extend({ 'sgnFilterShow_chkAlrActive': caac, 'sgnFilterShow_chkAlrConfirmed': cacf, 'sgnFilterShow_chkAlrSleeping': casl });
        }

        // maintenance filter [cross-device]+[recursive(upwards)]
        if (this.filter_by_maintenance) {

            if ($('sgnFilterShow_selMaintenance')) {
                var cmnt = $('sgnFilterShow_selMaintenance').get('value');
                var imnt = $('sgnFilterShow_selMaintenance').selectedIndex;
                var bmnt = ['act', 'dis'].contains(cmnt);
            }
            else {
                // value adapter in case checkbox is displayed
                var chkValue = $('sgnFilterShow_chkOnlineOnly').checked;
                cmnt = (chkValue) ? 'act' : 'all';
                var imnt = (chkValue) ? 2 : 1;
                var bmnt = ['act', 'dis'].contains(cmnt);
            }

            if (bmnt && this.rowsResources) {
                this.rowsResources.each(function(crw) {
                    if (!crw.suppressed && (cmnt == 'act' && crw.hasClass('disabled')) || (cmnt == 'dis' && !crw.hasClass('disabled'))) {
                        crw.addClass('suppressed'); crw.suppressed = true; 	// suppress current row
                    }
                }, this);
            }

            if (bmnt && this.rowsDevices) {
                this.rowsDevices.each(function(crw) {
                    if (!crw.suppressed && ((cmnt == 'act' && crw.hasClass('disabled')) || (cmnt == 'dis' && !crw.hasClass('disabled') && $$(crw.childlist).hasClass('suppressed').indexOf(false) == -1))) {
                        crw.addClass('suppressed'); crw.suppressed = true; 	// suppress current row
                        this.redraw_suppressRowChilds(crw, true); 			// suppress row childs
                    }
                }, this);
            }

            if (bmnt && this.rowsInterfaces) {
                this.rowsInterfaces.each(function(crw) {
                    if (!crw.suppressed && ((cmnt == 'act' && crw.hasClass('disabled')) || (cmnt == 'dis' && !crw.hasClass('disabled') && $$(crw.childlist).hasClass('suppressed').indexOf(false) == -1))) {
                        crw.addClass('suppressed'); crw.suppressed = true; 	// suppress current row
                        this.redraw_suppressRowChilds(crw, true); 			// suppress row childs
                    }
                }, this);
            }

            // store user preferences in a cookie
            this.userprefs.extend({ 'sgnFilterShow_selMaintenance': imnt });
        }

        if (this.filter_by_selected) {
            var selectedValue;
            if ($('sgnFilterShow_radSelected1').checked)
                selectedValue = 1;
            else if ($('sgnFilterShow_radSelected2').checked)
                selectedValue = 2;
            else
                selectedValue = 0;
            if (selectedValue > 0) {
                if (this.rowsResources) {
                    this.rowsResources.each(function(crw) {
                        if (!crw.suppressed && (!crw.selector.checked && selectedValue == 1) || (crw.selector.checked && selectedValue == 2)) {
                            crw.addClass('suppressed'); crw.suppressed = true;
                        }
                    }, this);
                }

                // suppress devices row, and their children (like table header) if the row hasn't visible child
                // note: if selectedValue = 2 (not selected rows) and the device is selected,
                // its visibility depends on the presence of at least one unselected child
                // note for js master: I'm using different indentation because I need to see matching {};
                // you are free to make this code more unreadable ;-)
                if (this.rowsDevices) {
                    this.rowsDevices.each(function(crw) {
                        if (!crw.suppressed) {
                            if (!crw.selector.checked && selectedValue == 1) {
                                // I'm sure there're no selected children --> suppress all
                                crw.addClass('suppressed'); crw.suppressed = true;
                                this.redraw_suppressRowChilds(crw, true); 			// suppress row childs
                            }
                            else if (crw.selector.checked && selectedValue == 2) {
                                // I must check every children to see if one is not suppressed
                                if (!this.redraw_checkChildrenSelection(crw, true, false)) {
                                    // every children is selected --> suppress all
                                    crw.addClass('suppressed'); crw.suppressed = true;
                                    this.redraw_suppressRowChilds(crw, true); 			// suppress row childs
                                }
                            }
                        }
                    }, this);
                }

                if (this.rowsInterfaces) {
                    this.rowsInterfaces.each(function(crw) {
                        if (!crw.suppressed) {
                            if (!crw.selector.checked && selectedValue == 1) {
                                // I'm sure there're no selected children --> suppress all
                                crw.addClass('suppressed'); crw.suppressed = true;
                                this.redraw_suppressRowChilds(crw, true); 			// suppress row childs
                            }
                            else if (crw.selector.checked && selectedValue == 2) {
                                // I must check every children to see if one is not suppressed.
                                // [AA 2010-07-05] Processing interfaces, check also every children (resources) of children (devices)
                                // to see if one is not suppressed
                                if (!this.redraw_checkChildrenSelection(crw, true, false) && !this.redraw_checkChildrenSelection(crw.childlist[0], true, false)) {
                                    // every children is selected --> suppress all
                                    crw.addClass('suppressed'); crw.suppressed = true;
                                    this.redraw_suppressRowChilds(crw, true); 			// suppress row childs
                                }
                            }
                        }
                    }, this);
                }
            }

            // store user preferences in a cookie
            this.userprefs.extend({ 'sgnFilterShow_radSelected': selectedValue });
        }

        // show table caption on row suppression
        if (this.visual_suppression) { this.helper_togSuppression(this.boxWrapper.getElements('tr.suppressed').length > 0); }

        // update visual helpers
        if (this.visual_helpers) {
            if ($('sgnVisualShow_chkTabHead')) { this.helper_togTabHead($('sgnVisualShow_chkTabHead').checked); }
            if ($('sgnVisualShow_chkLegend')) { this.helper_togLegend($('sgnVisualShow_chkLegend').checked); }
        }
    },

    redraw_delayedListing: function(delay) {
        // better use a timeout to handle multiple update sequences
        timedelay = delay || 0;

        // traditional code
        // if($chk(this.redraw_ticket)) { window.clearTimeout(this.redraw_ticket) };
        // this.redraw_ticket = window.setTimeout(function(){ this.redraw_updateListing(); }.bindWithEvent(this), timedelay);

        // mootools code
        if ($chk(this.redraw_ticket)) { $clear(this.redraw_ticket); };
        this.redraw_ticket = this.redraw_updateListing.delay(timedelay, this);
    },

    // #####  DONT'T REMOVE  #####
    safari2hatesmissingcommas: function() { }
});

var profileSettingsHandler = new Class({
    initialize: function() {
        // store behaviour objects
        this.boxProfile = document.getElement('.wkaProfileSettings');
        this.watProfile = document.getElement('.wkaToolbarArea a.watProfile');

        //  assign behaviour to the toggler button
        if (this.watProfile) {
            // use sliding effect [Internet Explorer is buggy! so use the simple display toggling]
            // this.watProfile.addEvent('click', function() { this.fxSlider.toggle(); });
            // this.watProfile.fxSlider = new Fx.Slide(this.boxProfile, {duration: 500, wait: false});
            // this.watProfile.fxSlider.hide();

            // use display toggle
            this.watProfile.addEvent('click', this.toggle.bind(this));
            this.watProfile.onclick = function() { return false; };
        }
    },

    toggle: function() {
        var bol = (this.boxProfile.getStyle('display') == 'block');
        this.boxProfile.setStyle('display', bol ? 'none' : 'block');
    }
});



/*//////////////////////////// POPUPS //////////////////////////// */

var ColorPicker = new Class({
                   Implements: [Options],
                   options: {
                       defaultColor: '#FFFFFF',
                       colorsPerLine: 8,
                       changeOnHover: false,
                       prefix: 'colorpicker',
                       // dmi.unict.it/~cantone/HomePageHTML/Colori.html
                       colors: ['#FFFFFF', '#000000', '#800000', '#008000', '#000080', '#800080', '#808000', '#008080',
                                '#C0C0C0', '#808080', '#FF0000', '#00FF00', '#0000FF', '#FF00FF', '#FFFF00', '#00FFFF', ]
                   },
                   element: null,
                   back: null,
                   box: null,
                   input: null,
                   initialize: function (element, options) {
                       this.setOptions(options);
                       this.element = document.id(element);
                       // Create element
                       this.build();
                   },
                   build: function () {

                       var self = this;

                       // Build back
                       this.back = new Element('div', {
                           id: this.options.prefix + '-colorback'
                       });

                       // Build colorbox
                       this.box = new Element('div', {
                           'class': 'colorpicker-box',
                           id: this.options.prefix + '-colorbox',
                           events: {
                               mouseleave: function () {
                                   if (self.options.changeOnHover === true) {
                                       self.setDefaultColor();
                                   }
                               }
                           }
                       });
                       var colorBoxColors = new Element('ul');

                       // Build color selection
                       Array.each(this.options.colors, function (currentColor, i) {

                           currentColor = currentColor.toUpperCase();

                           var colorUnit = new Element('li', {
                               styles: {
                                   'background-color': currentColor
                               },
                               'class': 'colorpicker-color',
                               title: currentColor,
                               id: self.options.prefix + '-color-' + i,
                               'data-color': currentColor,
                               events: {
                                   click: function () {
                                       if (currentColor == '#FFFFFF')
                                           self.selectColor(''); // an hanck to make the white ('#FFFFFF') saved as '' in the application
                                       else 
                                            self.selectColor(currentColor);
                                   },
                                   mouseover: function () {
                                       if (self.options.changeOnHover === true) {
                                           self.hoverColor(currentColor);
                                       }
                                   }
                               }
                           });

                           if (i % self.options.colorsPerLine === 0) {
                               colorUnit.setStyle('clear', 'both');
                           }

                           colorUnit.inject(colorBoxColors);
                       });

                       // Build color input
                       this.input = new Element('div', {
                           'class': 'colorpicker-input',
                           styles: {
                               'background-color': this.options.defaultColor
                           },
                           'data-color': this.options.defaultColor,
                           'title': this.options.defaultColor,
                           events: {
                               click: function () {
                                   self.element.fireEvent('onClicking'); // Added to hide other opened box
                                   self.positionAndShowBox();
                               }
                           }
                       });

                       // Initialize default color
                       // this.element.set('value', this.options.defaultColor);
                       this.setDefaultColor();

                       // Onblur event
                       $$('body').addEvent('click', function (e) {
                           if (!$(e.target).hasClass('colorpicker-color') && !$(e.target).hasClass('colorpicker-input')) {
                               self.setDefaultColor();
                               self.hide(self.box);
                           }
                       });

                       // Place elements
                       this.input.inject(this.element, 'after');
                       colorBoxColors.inject(this.box);
                       this.box.inject(this.input, 'after');
                       this.back.inject(this.input, 'after');

                       // Hide the colorbox
                       this.hide(this.box);
                       this.hide(this.element);

                       return this;
                   },
                   selectColor: function (color) {
                       this.hide(this.box);
                       this.back.removeClass('colorpicker-back');
                       this.element.set('value', color);
                       this.input.set('data-color', color).set('title', color).setStyle('background-color', color);
                       this.element.fireEvent('onSelectColor');
                   },
                   setDefaultColor: function () {
                       var color = this.element.get('value');
                       this.input.set('data-color', color)
                               .set('title', color)
                               .setStyle('background-color', color);
                       this.element.fireEvent('onSetDefaultColor');
                   },
                   hoverColor: function (color) {
                       this.input.setStyle('background-color', color);
                   },
                   hide: function (element) {
                       element.setStyle('display', 'none');
                   }, 
                   show: function (element) {
                       element.setStyle('display', 'block');
                   },
                   positionAndShowBox: function () {
                       this.box.position({
                           relativeTo: this.input,
                           position: 'bottomLeft',
                           edge: 'upperLeft'
                       });
                       this.show(this.box);
                       this.back.addClass('colorpicker-back');
                   }
}); // ColorPicker github.com/pretorien/mootools-colorpicker (imported 2016/07/20)

/*_______________________________________________________________________________________________________ */

var	gridYearDays = new Class({
		initialize: function(tid) {
			// store dom objects
			this.ctable =	document.getElement('table.doyCalendar');
			this.days = 	this.ctable.getElements('td a');
			this.colths =	this.ctable.getElements('thead th');
			this.rowths =	this.ctable.getElements('tbody th');
			this.brows =	this.ctable.getElements('tbody tr');
			this.sbmt =	this.ctable.getElement('td.submit input');

	        // assign the behavior to the elements
			for (i=0; i<this.days.length; i++) {
				this.days[i].addEvent('click', function(event) {
							event.target.toggleClass('selected');
						}.bindWithEvent(this));
				this.days[i].onclick = function(){return false;};
			}

			for (i=0; i<this.colths.length; i++) {
				this.colths[i].addEvent('click', function(event) {
					for (j=0; j<this.brows.length; j++) { $(this.brows[j].cells[event.target.cellIndex]).getElements('a').toggleClass('selected'); }
				}.bindWithEvent(this));
			}

			for (i=0; i<this.rowths.length; i++) {
				this.rowths[i].addEvent('click', function(event) {
					$(event.target.getParent()).getElements('td a').each( function(ctd){ ctd.toggleClass('selected'); } );
				}.bindWithEvent(this));
			}

			this.sbmt.addEvent('click', function(event) {
				var cdsl = [];
				this.ctable.getElements('td a.selected').each( function(cddy){ cdsl.push(cddy.id.replace(/doy/,'')); } );
				this.daysHolder.value = cdsl.join(',');
				window.close();
			}.bindWithEvent(this));

			// get data from opener page and update table elements
			this.daysHolder = window.opener.document.getElementById('hiddenCalendarDays');
			if($chk(this.daysHolder && this.daysHolder.value.trim() != ""))
			{
			    this.daysHolder.value.split(',').each(function(item,index){ $('doy'+item).addClass('selected'); }, this);
			}
		}
});

/*
	colPickerPopup = see "MooRainbow" later;
*/

var imgPicker = new Class({
    initialize: function(pk) {
		var picker = $(pk);

		picker.addEvent('click', function() {
			// store a reference to the picker element in the main window (to be used by the popup)
			window.imgpickorigin = this;
			// open the popup window
			var cipw = window.open('/Common/ImagePicker.aspx?type='+picker.lobjtargtype, 'imgpicker', 'width=380,height=400');
			cipw.focus();
		});
		picker.onclick = function(){return false;};
    }
});
var imgPickerPopup = new Class({
    initialize: function() {
		// store a reference to the picker element
		var sourcepicker = $(window.opener.imgpickorigin);
		this.cselected = $('libimg'+ sourcepicker.imageindex);

		// select current
		if ($chk(this.cselected)) {
			this.cselected.checked = true;
			this.cselected.getParent().addClass('selected');
		}

		document.getElements('#libimgList input[type=radio]').each(function(cck) {
			var cckwrp = cck.getParent();
			cckwrp.ipp = this;
			cckwrp.chk = cck;

			// add event to the whole cell, not only the radio button
			cckwrp.addEvent('click', function() {
				// uncheck previous
				if($chk(this.ipp.cselected)) {
					this.ipp.cselected.checked = false;
					this.ipp.cselected.getParent().removeClass('selected');
				}

				// highlight current
				this.addClass('selected');

				// check and store reference to the new selected checkbox
				this.chk.checked = true;
				this.ipp.cselected = this.chk;
			});
		},this);

		// assign the behavior to the elements
		$('butCancelImage').addEvent('click',function() { window.close(); });
		$('butSelectImage').addEvent('click',function() {
			var cimgdata = eval('(' + this.cselected.value + ')');

			// store data on original button
			$extend(sourcepicker,cimgdata);
			// ... and fire update event
			sourcepicker.fireEvent('onUpdate');

			// close window, at last
			window.close();
		}.bind(this),this);
	}
});
var paramPicker = new Class({
    initialize: function(pk) {
		// store a reference to the picker element
		var picker = this.picker = $(pk);

		// which device was selected? (this must be set and overridden outside of this class)
		picker.get_devid = function(){};

		// store a reference to this class
		picker.refclass = this;

		picker.addEvent('click', function() {
			// store a reference to the picker element in the main window (to be used by the popup)
			window.parampickorigin = this;
			// open the popup window
			var cppw = window.open('/Common/ParameterPicker.aspx?device='+picker.get_devid(), 'parampicker', 'width=480,height=400');
			cppw.focus();
		});
		picker.onclick = function(){return false;};
    },

    empty_parameters: function() {
		this.picker.resourceparameterobj = [];
    },

    add_parameter: function(paramdata) {
		var cpobj = eval('(' + paramdata + ')');

		this.picker.resourceparameterobj.push({ "__type":"resourceparameter", "id":cpobj.id, "caption":cpobj.caption });
    }
});
var paramPickerPopup = new Class({
    initialize: function() {
		// store reference to the picking trigger element
		var sourcepicker = $(window.opener.parampickorigin);

		// unselect all
		document.getElements('#paramlistList input[type=checkbox]').each(function(cck) { cck.checked = false; },this);

		// select only object resource parameters
		if ($chk(sourcepicker.resourceparameterobj) && sourcepicker.resourceparameterobj.length>0) {
			sourcepicker.resourceparameterobj.each(function(crespar) {
				var crow = $('rowPar'+crespar.id);
				if($chk(crow)) {
					document.getElement('input[type=checkbox]',crow).checked = true;
				}
			});
		}

		// assign the behavior to the elements
		$('butCancelParameters').addEvent('click',function() { window.close(); });
		$('butSelectParameters').addEvent('click',function() {
			// get checked inputs
			var cckparams = document.getElements('#paramlistList input[type=checkbox]').filter(function(cck) {
				return 	cck.checked;
			},this);

			// store the new resource parameters on the picker data container
			/* 	>>> note:	this strange workaround is required because of a strange IE6/IE7 bug, that cannot permit to pass arrays from popup to opener
				>>>	refs:	- http://www.webdeveloper.com/forum/archive/index.php/t-2008.html
							- http://bytes.com/forum/thread88767.html
							- http://www.webdeveloper.com/forum/archive/index.php/t-77475.html
							- "There is problem if Array object is passed between base and popup window. So, instead of passing array object from popup to base window, I passed simple parameters to base window function and let that function handle the array manipultation. And it worked."
			*/
			sourcepicker.refclass.empty_parameters();
			cckparams.each(function(cck) { sourcepicker.refclass.add_parameter(cck.get('value')); });
			// ... and fire update event
			sourcepicker.fireEvent('onUpdate');

			// close window, at last
			window.close();
		}.bind(this),this);
	}
});
var devPicker = new Class({
    initialize: function(pk) {
		// store a reference to the picker element
		var picker = this.picker = $(pk);

		// store a reference to this class
		picker.refclass = this;

		picker.addEvent('click', function() {
			// store a reference to the picker element in the main window (to be used by the popup)
			window.devpickorigin = this;
			// open the popup window
			var cdpw = window.open('/Common/ResourcePicker.aspx?type='+picker.lobjtargtype, 'devpicker', 'width=480,height=400');
			cdpw.focus();
		});
		picker.onclick = function(){return false;};
    },

    empty_devices: function() {
		this.picker.resourceobj = [];
    },

    add_device: function(devid) {
		this.picker.resourceobj.push({ "__type":"resource", "id":devid });
    }
});
var devPickerPopup = new Class({
    initialize: function() {
		// init the super-grid-network handler
		if (document.getElement('div.wrpSuperGridNetworkTable')) { this.mySuperGridNetworkTable = new superGridNetworkTable(); }

		// store reference to the picking trigger element
		var sourcepicker = $(window.opener.devpickorigin);

		// unselect all
		document.getElements('tr.hdwInterfaceChild input.sgnSelector').each(function(cck) { cck.checked = false; },this);

		// select only object resources
		if ($chk(sourcepicker.resourceobj) && sourcepicker.resourceobj.length>0) {
			sourcepicker.resourceobj.each(function(cres) {
				var crow = $(cres.id);
				if($chk(crow)) {
					document.getElement('input.sgnSelector',crow).checked = true;
				}
			});
		}

		// assign the behavior to the elements
		$('butCancelDevices').addEvent('click',function() { window.close(); });
		$('butSelectDevices').addEvent('click',function() {
			// get checked inputs
			var cckdevs = document.getElements('tr.hdwInterfaceChild input.sgnSelector').filter(function(cck) {
				return 	cck.checked;
			},this);

			// store the new resources on the picker data container
			/* 	>>> note:	this strange workaround is required because of a strange IE6/IE7 bug, that cannot permit to pass arrays from popup to opener
				>>>	refs:	- http://www.webdeveloper.com/forum/archive/index.php/t-2008.html
							- http://bytes.com/forum/thread88767.html
							- http://www.webdeveloper.com/forum/archive/index.php/t-77475.html
							- "There is problem if Array object is passed between base and popup window. So, instead of passing array object from popup to base window, I passed simple parameters to base window function and let that function handle the array manipultation. And it worked."
			*/
			sourcepicker.refclass.empty_devices();
			cckdevs.each(function(cck) { sourcepicker.refclass.add_device(cck.getFirstParentByTag('tr').id); });
			// ... and fire update event
			sourcepicker.fireEvent('onUpdate');

			// close window, at last
			window.close();
		}.bind(this),this);
	}
});
/***
 * MooRainbow
 *
 * @version		1.11
 * @license		MIT-style license
 * @author		w00fz - < w00fzIT [at] gmail.com >
 * @infos		http://moorainbow.woolly-sheep.net
 * @copyright	Author
 *
 *
 */

var MooRainbow = new Class({
	options: {
		id: 'mooRainbow',
		prefix: 'moor-',
		imgPath: '/media/img/Others/ColorPicker/',
		startColor: [255, 0, 0],
		wheel: false,
		onComplete: Class.empty,
		onChange: Class.empty
	},

	initialize: function(el, options) {
		this.element = $(el); if (!this.element) return;
		this.setOptions(options);

		this.sliderPos = 0;
		this.pickerPos = {x: 0, y: 0};
		this.backupColor = this.options.startColor;
		this.currentColor = this.options.startColor;
		this.sets = {
			rgb: [],
			hsb: [],
			hex: []
		};
		this.pickerClick = this.sliderClick  = false;
		if (!this.layout) this.doLayout();
		this.OverlayEvents();
		this.sliderEvents();
		this.backupEvent();
		if (this.options.wheel) this.wheelEvents();
		this.element.addEvent('click', function(e) { this.toggle(e); }.bind(this));

		this.layout.overlay.setStyle('background-color', this.options.startColor.rgbToHex());
		this.layout.backup.setStyle('background-color', this.backupColor.rgbToHex());

		this.pickerPos.x = this.snippet('curPos').l + this.snippet('curSize', 'int').w;
		this.pickerPos.y = this.snippet('curPos').t + this.snippet('curSize', 'int').h;

		this.manualSet(this.options.startColor);

		this.pickerPos.x = this.snippet('curPos').l + this.snippet('curSize', 'int').w;
		this.pickerPos.y = this.snippet('curPos').t + this.snippet('curSize', 'int').h;
		this.sliderPos = this.snippet('arrPos') - this.snippet('arrSize', 'int');

		if (window.khtml) this.hide();
	},

	toggle: function() {
		this[this.visible ? 'hide' : 'show']();
	},

	show: function() {
		this.rePosition();
		this.layout.setStyle('display', 'block');
		this.visible = true;
	},

	hide: function() {
		this.layout.setStyles({'display': 'none'});
		this.visible = false;
	},

	manualSet: function(color, type) {
		if (!type || (type != 'hsb' && type != 'hex')) type = 'rgb';
		var rgb, hsb, hex;

		if (type == 'rgb') { rgb = color; hsb = color.rgbToHsb(); hex = color.rgbToHex(); }
		else if (type == 'hsb') { hsb = color; rgb = color.hsbToRgb(); hex = rgb.rgbToHex(); }
		else { hex = color; rgb = color.hexToRgb(true); hsb = rgb.rgbToHsb(); }

		this.setMooRainbow(rgb);
		this.autoSet(hsb);
	},

	autoSet: function(hsb) {
		var curH = this.snippet('curSize', 'int').h;
		var curW = this.snippet('curSize', 'int').w;
		var oveH = this.layout.overlay.height;
		var oveW = this.layout.overlay.width;
		var sliH = this.layout.slider.height;
		var arwH = this.snippet('arrSize', 'int');
		var hue;

		var posx = Math.round(((oveW * hsb[1]) / 100) - curW);
		var posy = Math.round(- ((oveH * hsb[2]) / 100) + oveH - curH);

		var c = Math.round(((sliH * hsb[0]) / 360)); c = (c == 360) ? 0 : c;
		var position = sliH - c + this.snippet('slider') - arwH;
		hue = [this.sets.hsb[0], 100, 100].hsbToRgb().rgbToHex();

		this.layout.cursor.setStyles({'top': posy, 'left': posx});
		this.layout.arrows.setStyle('top', position);
		this.layout.overlay.setStyle('background-color', hue);
		this.sliderPos = this.snippet('arrPos') - arwH;
		this.pickerPos.x = this.snippet('curPos').l + curW;
		this.pickerPos.y = this.snippet('curPos').t + curH;
	},

	setMooRainbow: function(color, type) {
		if (!type || (type != 'hsb' && type != 'hex')) type = 'rgb';
		var rgb, hsb, hex;

		if (type == 'rgb') { rgb = color; hsb = color.rgbToHsb(); hex = color.rgbToHex(); }
		else if (type == 'hsb') { hsb = color; rgb = color.hsbToRgb(); hex = rgb.rgbToHex(); }
		else { hex = color; rgb = color.hexToRgb(); hsb = rgb.rgbToHsb(); }

		this.sets = {
			rgb: rgb,
			hsb: hsb,
			hex: hex
		};

		if (!$chk(this.pickerPos.x))
			this.autoSet(hsb);

		this.RedInput.value = rgb[0];
		this.GreenInput.value = rgb[1];
		this.BlueInput.value = rgb[2];
		this.HueInput.value = hsb[0];
		this.SatuInput.value =  hsb[1];
		this.BrighInput.value = hsb[2];
		this.hexInput.value = hex;

		this.currentColor = rgb;

		this.chooseColor.setStyle('background-color', rgb.rgbToHex());
	},

	parseColors: function(x, y, z) {
		var s = Math.round((x * 100) / this.layout.overlay.width);
		var b = 100 - Math.round((y * 100) / this.layout.overlay.height);
		var h = 360 - Math.round((z * 360) / this.layout.slider.height) + this.snippet('slider') - this.snippet('arrSize', 'int');
		h -= this.snippet('arrSize', 'int');
		h = (h >= 360) ? 0 : (h < 0) ? 0 : h;
		s = (s > 100) ? 100 : (s < 0) ? 0 : s;
		b = (b > 100) ? 100 : (b < 0) ? 0 : b;

		return [h, s, b];
	},

	OverlayEvents: function() {
		var lim, curH, curW, inputs;
		curH = this.snippet('curSize', 'int').h;
		curW = this.snippet('curSize', 'int').w;
		inputs = this.arrRGB.copy().concat(this.arrHSB, this.hexInput);

		document.addEvent('click', function() {
			if(this.visible) this.hide(this.layout);
		}.bind(this));

		inputs.each(function(el) {
			el.addEvent('keydown', this.eventKeydown.bindWithEvent(this, el));
			el.addEvent('keyup', this.eventKeyup.bindWithEvent(this, el));
		}, this);
		[this.element,this.layout].each(function(el) {
			el.addEvents({
				'click': function(e) { new Event(e).stop(); },
				'keyup': function(e) {
					e = new Event(e);
					if(e.key == 'esc' && this.visible) this.hide(this.layout);
				}.bind(this)
			}, this);
		}, this);

		lim = {
			x: [0 - curW, (this.layout.overlay.width - curW)],
			y: [0 - curH, (this.layout.overlay.height - curH)]
		};

		this.layout.drag = new Drag.Base(this.layout.cursor, {
			limit: lim,
			onStart: this.overlayDrag.bind(this),
			onDrag: this.overlayDrag.bind(this),
			snap: 0
		});

		this.layout.overlay2.addEvent('mousedown', function(e){
			e = new Event(e);
			this.layout.cursor.setStyles({
				'top': e.page.y - this.layout.overlay.getTop() - curH,
				'left': e.page.x - this.layout.overlay.getLeft() - curW
			});
			this.layout.drag.start(e);
		}.bind(this));

		this.okButton.addEvent('click', function() {
			if(this.currentColor == this.options.startColor) {
				this.hide();
				this.fireEvent('onComplete', [this.sets, this]);
			}
			else {
				this.backupColor = this.currentColor;
				this.layout.backup.setStyle('background-color', this.backupColor.rgbToHex());
				this.hide();
				this.fireEvent('onComplete', [this.sets, this]);
			}
		}.bind(this));
	},

	overlayDrag: function() {
		var curH = this.snippet('curSize', 'int').h;
		var curW = this.snippet('curSize', 'int').w;
		this.pickerPos.x = this.snippet('curPos').l + curW;
		this.pickerPos.y = this.snippet('curPos').t + curH;

		this.setMooRainbow(this.parseColors(this.pickerPos.x, this.pickerPos.y, this.sliderPos), 'hsb');
		this.fireEvent('onChange', [this.sets, this]);
	},

	sliderEvents: function() {
		var arwH = this.snippet('arrSize', 'int'), lim;

		lim = [0 + this.snippet('slider') - arwH, this.layout.slider.height - arwH + this.snippet('slider')];
		this.layout.sliderDrag = new Drag.Base(this.layout.arrows, {
			limit: {y: lim},
			modifiers: {x: false},
			onStart: this.sliderDrag.bind(this),
			onDrag: this.sliderDrag.bind(this),
			snap: 0
		});

		this.layout.slider.addEvent('mousedown', function(e){
			e = new Event(e);

			this.layout.arrows.setStyle(
				'top', e.page.y - this.layout.slider.getTop() + this.snippet('slider') - arwH
			);
			this.layout.sliderDrag.start(e);
		}.bind(this));
	},

	sliderDrag: function() {
		var arwH = this.snippet('arrSize', 'int'), hue;

		this.sliderPos = this.snippet('arrPos') - arwH;
		this.setMooRainbow(this.parseColors(this.pickerPos.x, this.pickerPos.y, this.sliderPos), 'hsb');
		hue = [this.sets.hsb[0], 100, 100].hsbToRgb().rgbToHex();
		this.layout.overlay.setStyle('background-color', hue);
		this.fireEvent('onChange', [this.sets, this]);
	},

	backupEvent: function() {
		this.layout.backup.addEvent('click', function() {
			this.manualSet(this.backupColor);
			this.fireEvent('onChange', [this.sets, this]);
		}.bind(this));
	},

	wheelEvents: function() {
		var arrColors = this.arrRGB.copy().append(this.arrHSB);

		arrColors.each(function(el) {
			el.addEvents({
				'mousewheel': this.eventKeys.bindWithEvent(this, el),
				'keydown': this.eventKeys.bindWithEvent(this, el)
			});
		}, this);

		[this.layout.arrows, this.layout.slider].each(function(el) {
			el.addEvents({
				'mousewheel': this.eventKeys.bindWithEvent(this, [this.arrHSB[0], 'slider']),
				'keydown': this.eventKeys.bindWithEvent(this, [this.arrHSB[0], 'slider'])
			});
		}, this);
	},

	eventKeys: function(e, el, id) {
		var wheel, type;
		id = (!id) ? el.id : this.arrHSB[0];

		if (e.type == 'keydown') {
			if (e.key == 'up') wheel = 1;
			else if (e.key == 'down') wheel = -1;
			else return;
		} else if (e.type == Element.Events.mousewheel.type) wheel = (e.wheel > 0) ? 1 : -1;

		if (this.arrRGB.test(el)) type = 'rgb';
		else if (this.arrHSB.test(el)) type = 'hsb';
		else type = 'hsb';

		if (type == 'rgb') {
			var rgb = this.sets.rgb, hsb = this.sets.hsb, prefix = this.options.prefix, pass;
			var value = el.value.toInt() + wheel;
			value = (value > 255) ? 255 : (value < 0) ? 0 : value;

			switch(el.className) {
				case prefix + 'rInput': pass = [value, rgb[1], rgb[2]];	break;
				case prefix + 'gInput': pass = [rgb[0], value, rgb[2]];	break;
				case prefix + 'bInput':	pass = [rgb[0], rgb[1], value];	break;
				default : pass = rgb;
			}
			this.manualSet(pass);
			this.fireEvent('onChange', [this.sets, this]);
		} else {
			var rgb = this.sets.rgb, hsb = this.sets.hsb, prefix = this.options.prefix, pass;
			var value = el.value.toInt() + wheel;

			if (el.className.test(/(HueInput)/)) value = (value > 359) ? 0 : (value < 0) ? 0 : value;
			else value = (value > 100) ? 100 : (value < 0) ? 0 : value;

			switch(el.className) {
				case prefix + 'HueInput': pass = [value, hsb[1], hsb[2]]; break;
				case prefix + 'SatuInput': pass = [hsb[0], value, hsb[2]]; break;
				case prefix + 'BrighInput':	pass = [hsb[0], hsb[1], value]; break;
				default : pass = hsb;
			}
			this.manualSet(pass, 'hsb');
			this.fireEvent('onChange', [this.sets, this]);
		}
		e.stop();
	},

	eventKeydown: function(e, el) {
		var n = e.code, k = e.key;

		if 	((!el.className.test(/hexInput/) && !(n >= 48 && n <= 57)) &&
			(k!='backspace' && k!='tab' && k !='delete' && k!='left' && k!='right'))
		e.stop();
	},

	eventKeyup: function(e, el) {
		var n = e.code, k = e.key, pass, prefix, chr = el.value.charAt(0);

		if (!$chk(el.value)) return;
		if (el.className.test(/hexInput/)) {
			if (chr != "#" && el.value.length != 6) return;
			if (chr == '#' && el.value.length != 7) return;
		} else {
			if (!(n >= 48 && n <= 57) && (!['backspace', 'tab', 'delete', 'left', 'right'].test(k)) && el.value.length > 3) return;
		}

		prefix = this.options.prefix;

		if (el.className.test(/(rInput|gInput|bInput)/)) {
			if (el.value  < 0 || el.value > 255) return;
			switch(el.className){
				case prefix + 'rInput': pass = [el.value, this.sets.rgb[1], this.sets.rgb[2]]; break;
				case prefix + 'gInput': pass = [this.sets.rgb[0], el.value, this.sets.rgb[2]]; break;
				case prefix + 'bInput': pass = [this.sets.rgb[0], this.sets.rgb[1], el.value]; break;
				default : pass = this.sets.rgb;
			}
			this.manualSet(pass);
			this.fireEvent('onChange', [this.sets, this]);
		}
		else if (!el.className.test(/hexInput/)) {
			if (el.className.test(/HueInput/) && el.value  < 0 || el.value > 360) return;
			else if (el.className.test(/HueInput/) && el.value == 360) el.value = 0;
			else if (el.className.test(/(SatuInput|BrighInput)/) && el.value  < 0 || el.value > 100) return;
			switch(el.className){
				case prefix + 'HueInput': pass = [el.value, this.sets.hsb[1], this.sets.hsb[2]]; break;
				case prefix + 'SatuInput': pass = [this.sets.hsb[0], el.value, this.sets.hsb[2]]; break;
				case prefix + 'BrighInput': pass = [this.sets.hsb[0], this.sets.hsb[1], el.value]; break;
				default : pass = this.sets.hsb;
			}
			this.manualSet(pass, 'hsb');
			this.fireEvent('onChange', [this.sets, this]);
		} else {
			pass = el.value.hexToRgb(true);
			if (isNaN(pass[0])||isNaN(pass[1])||isNaN(pass[2])) return;

			if ($chk(pass)) {
				this.manualSet(pass);
				this.fireEvent('onChange', [this.sets, this]);
			}
		}
	},

	doLayout: function() {
		var id = this.options.id, prefix = this.options.prefix;
		var idPrefix = id + ' .' + prefix;

		this.layout = new Element('div', {
			'styles': {'display': 'block', 'position': 'absolute'},
			'id': id
		}).inject(document.body);

		var box = new Element('div', {
			'styles':  {'position': 'relative'},
			'class': prefix + 'box'
		}).inject(this.layout);

		var div = new Element('div', {
			'styles': {'position': 'absolute', 'overflow': 'hidden'},
			'class': prefix + 'overlayBox'
		}).inject(box);

		var ar = new Element('div', {
			'styles': {'position': 'absolute', 'zIndex': 1},
			'class': prefix + 'arrows'
		}).inject(box);
		ar.width = ar.getStyle('width').toInt();
		ar.height = ar.getStyle('height').toInt();

		var ov = new Element('img', {
			'styles': {'background-color': '#fff', 'position': 'relative', 'zIndex': 2},
			'src': this.options.imgPath + 'moor_woverlay.png',
			'class': prefix + 'overlay'
		}).inject(div);

		var ov2 = new Element('img', {
			'styles': {'position': 'absolute', 'top': 0, 'left': 0, 'zIndex': 2},
			'src': this.options.imgPath + 'moor_boverlay.png',
			'class': prefix + 'overlay'
		}).inject(div);

		if (window.ie6) {
			div.setStyle('overflow', '');
			var src = ov.src;
			ov.src = this.options.imgPath + 'blank.gif';
			ov.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + src + "', sizingMethod='scale')";
			src = ov2.src;
			ov2.src = this.options.imgPath + 'blank.gif';
			ov2.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + src + "', sizingMethod='scale')";
		}
		ov.width = ov2.width = div.getStyle('width').toInt();
		ov.height = ov2.height = div.getStyle('height').toInt();

		var cr = new Element('div', {
			'styles': {'overflow': 'hidden', 'position': 'absolute', 'zIndex': 2},
			'class': prefix + 'cursor'
		}).inject(div);
		cr.width = cr.getStyle('width').toInt();
		cr.height = cr.getStyle('height').toInt();

		var sl = new Element('img', {
			'styles': {'position': 'absolute', 'z-index': 2},
			'src': this.options.imgPath + 'moor_slider.png',
			'class': prefix + 'slider'
		}).inject(box);
		this.layout.slider = document.getElement('#' + idPrefix + 'slider');
		sl.width = sl.getStyle('width').toInt();
		sl.height = sl.getStyle('height').toInt();

		new Element('div', {
			'styles': {'position': 'absolute'},
			'class': prefix + 'colorBox'
		}).inject(box);

		new Element('div', {
			'styles': {'zIndex': 2, 'position': 'absolute'},
			'class': prefix + 'chooseColor'
		}).inject(box);

		this.layout.backup = new Element('div', {
			'styles': {'zIndex': 2, 'position': 'absolute', 'cursor': 'pointer'},
			'class': prefix + 'currentColor'
		}).inject(box);

		var R = new Element('label').inject(box).setStyle('position', 'absolute');
		var G = R.clone().inject(box).addClass(prefix + 'gLabel').appendText('G: ');
		var B = R.clone().inject(box).addClass(prefix + 'bLabel').appendText('B: ');
		R.appendText('R: ').addClass(prefix + 'rLabel');

		var inputR = new Element('input');
		var inputG = inputR.clone().inject(G).addClass(prefix + 'gInput');
		var inputB = inputR.clone().inject(B).addClass(prefix + 'bInput');
		inputR.inject(R).addClass(prefix + 'rInput');

		var HU = new Element('label').inject(box).setStyle('position', 'absolute');
		var SA = HU.clone().inject(box).addClass(prefix + 'SatuLabel').appendText('S: ');
		var BR = HU.clone().inject(box).addClass(prefix + 'BrighLabel').appendText('B: ');
		HU.appendText('H: ').addClass(prefix + 'HueLabel');

		var inputHU = new Element('input');
		var inputSA = inputHU.clone().inject(SA).addClass(prefix + 'SatuInput');
		var inputBR = inputHU.clone().inject(BR).addClass(prefix + 'BrighInput');
		inputHU.inject(HU).addClass(prefix + 'HueInput');
		SA.appendText(' %'); BR.appendText(' %');
		new Element('span', {'styles': {'position': 'absolute'}, 'class': prefix + 'ballino'}).setHTML(" &deg;").injectAfter(HU);

		var hex = new Element('label').inject(box).setStyle('position', 'absolute').addClass(prefix + 'hexLabel').appendText('#HEX: ').adopt(new Element('input').addClass(prefix + 'hexInput'));

		var ok = new Element('input', {
			'styles': {'position': 'absolute'},
			'type': 'button',
			'value': 'Select',
			'class': prefix + 'okButton'
		}).inject(box);

		this.rePosition();

		var overlays = $$('#' + idPrefix + 'overlay');
		this.layout.overlay = overlays[0];
		this.layout.overlay2 = overlays[1];
		this.layout.cursor = document.getElement('#' + idPrefix + 'cursor');
		this.layout.arrows = document.getElement('#' + idPrefix + 'arrows');
		this.chooseColor = document.getElement('#' + idPrefix + 'chooseColor');
		this.layout.backup = document.getElement('#' + idPrefix + 'currentColor');
		this.RedInput = document.getElement('#' + idPrefix + 'rInput');
		this.GreenInput = document.getElement('#' + idPrefix + 'gInput');
		this.BlueInput = document.getElement('#' + idPrefix + 'bInput');
		this.HueInput = document.getElement('#' + idPrefix + 'HueInput');
		this.SatuInput = document.getElement('#' + idPrefix + 'SatuInput');
		this.BrighInput = document.getElement('#' + idPrefix + 'BrighInput');
		this.hexInput = document.getElement('#' + idPrefix + 'hexInput');

		this.arrRGB = [this.RedInput, this.GreenInput, this.BlueInput];
		this.arrHSB = [this.HueInput, this.SatuInput, this.BrighInput];
		this.okButton = document.getElement('#' + idPrefix + 'okButton');

		if (!window.khtml) this.hide();
	},

	rePosition: function() {
		var coords = this.element.getCoordinates();
		this.layout.setStyles({
			'left': coords.left,
			'top': coords.top + coords.height + 1
		});
	},

	snippet: function(mode, type) {
		var size; type = (type) ? type : 'none';

		switch(mode) {
			case 'arrPos':
				var t = this.layout.arrows.getStyle('top').toInt();
				size = t;
				break;
			case 'arrSize':
				var h = this.layout.arrows.height;
				h = (type == 'int') ? (h/2).toInt() : h;
				size = h;
				break;
			case 'curPos':
				var l = this.layout.cursor.getStyle('left').toInt();
				var t = this.layout.cursor.getStyle('top').toInt();
				size = {'l': l, 't': t};
				break;
			case 'slider':
				var t = this.layout.slider.getStyle('marginTop').toInt();
				size = t;
				break;
			default :
				var h = this.layout.cursor.height;
				var w = this.layout.cursor.width;
				h = (type == 'int') ? (h/2).toInt() : h;
				w = (type == 'int') ? (w/2).toInt() : w;
				size = {w: w, h: h};
		};
		return size;
	}
});

MooRainbow.implement(new Options);
MooRainbow.implement(new Events);

/*//////////////////////////// EXTENSIONS ////////////////////////////
_______________________________________________________________________________________________________ */

Request = Request.implement({
    request: function(){
    if (this.options.timeout) {
        this.timeoutTimer=window.setTimeout(this.callTimeout.bindWithEvent(this), this.options.timeout);
        this.addEvent('onComplete', this.removeTimer);
    }
    this.parent();
    },

    callTimeout: function () {
        this.transport.abort();
        this.onFailure();
        if (this.options.onTimeout) {
            this.options.onTimeout();
        }
    },

    removeTimer: function() {
        window.clearTimeout(this.timeoutTimer);
    }
});

MooRainbow = MooRainbow.implement({
	options: {
		isTransparent:false
	},

	initialize: function(el, options){
		// will call the previous initialize;
		this.parent(el, options);

		// add checkbox
		this.layout.chktrasparent = new Element('input', {
			'properties': { 'type':'checkbox', 'value':'istransparent' },
			'styles': {'zIndex': 2, 'position': 'absolute', 'top':280, 'left':150 },
			'class': this.options.prefix + 'isTransparent'
		}).inject(this.okButton.getParent());

		// handle checking (use "click" because on IE the onChange event is fired only on onBlur)
		this.layout.chktrasparent.addEvent('click', function() {
			this.layout.conditionalClass('noColor',this.layout.chktrasparent.checked);
			this.chooseColor.conditionalClass('isTransparent',this.layout.chktrasparent.checked);
		}.bind(this),this);

		// init checkbox state
		this.layout.chktrasparent.checked = this.options.isTransparent;
		this.layout.chktrasparent.fireEvent('click');
		this.layout.backup.conditionalClass('isTransparent',this.layout.chktrasparent.checked);

		// add label
		new Element('label', {
			'styles': {'zIndex': 2, 'position': 'absolute', 'top':284, 'left':175 },
			'class': this.options.prefix + 'isTransparentLabel'
		}).setText('transparent').inject(this.okButton.getParent());

		// not required, and they also lock the checkbox toggling
		document.removeEvents('click');
		this.layout.removeEvents('click');

		// at last, show colpicking box (was hidden on start)
		this.toggle();
	}
});

Element.implement({
    getParentsByTag: function(selector) {
        return $$(selector).filter(function(el) {
            return (el.hasChild(this));
        }, this).reverse();
    },

    getFirstParentByTag: function(selector) {
        return $(this.getParentsByTag(selector)[0] || false);
    },

    conditionalClass: function(className, condition) {
        condition ? this.addClass(className) : this.removeClass(className);
    },

    setFormElementValue: function(val) {
        switch (this.get('tag')) {
            case 'label':
                this.set('html', val);
                break;
            case 'button':
            case 'textarea':
                this.value = val;
                this.innerHTML = val;
                break;
            case 'select':
                // Try by vaule.
                Array.each(this.options, function(option) {
                    if (option.value == val) { option.selected = true; }
                    if (!this.multiple) return; 	// select can be single (type is "select-one", is the default) or multiple (type is "select-multiple", and is triggered by the "multiple" property) -> we want to select only one option, when select is "single", so we break on first occurrence found
                });
                // Try by text.
                Array.each(this.options, function (option) {
                    if (option.text == val) { option.selected = true; }
                    if (!this.multiple) return; 	// select can be single (type is "select-one", is the default) or multiple (type is "select-multiple", and is triggered by the "multiple" property) -> we want to select only one option, when select is "single", so we break on first occurrence found
                });
                break;
            case 'input':
                if (['hidden', 'text', 'password'].contains(this.type)) {
                    this.value = val;
                } else if (['checkbox', 'radio'].contains(this.type)) {
                    this.checked = ["1", "true", "checked"].contains(val.toString().toLowerCase());
                }
                break;
        }
    },

    showFormElementDefault: function() {
        obj = this;
        switch (obj.type) {
            case "text": console.log(obj, obj.defaultValue); break;
            case "password": console.log(obj, obj.defaultValue); break;
            case "textarea": console.log(obj, obj.defaultValue); break;
            case "select-one": for (var x = 0; x < obj.length; x++) { console.log(obj, obj.options[x], obj.options[x].defaultSelected); } break;
            case "select-multiple": for (var x = 0; x < obj.length; x++) { console.log(obj, obj.options[x], obj.options[x].defaultSelected); } break;
            case "checkbox": console.log(obj, obj.defaultChecked); break;
            case "radio": console.log(obj, obj.defaultChecked); break;
        }
    },

    resetFormElement: function(mode) {
        // restore defaults or completely erase values
        switch (this.get('tag')) {
            case 'select':
                Array.each(this.options, function(option) {
                    option.selected = (option.defaultSelected && mode == 'restore') ? option.defaultSelected : false;
                });
                break;
            case 'input':
                if (['checkbox', 'radio'].contains(this.type) || ['hidden', 'submit', 'button'].contains(this.type)) {
                    this.checked = (this.defaultChecked && mode == 'restore') ? this.defaultChecked : false;
                    break;
                }
            case 'textarea': this.value = (this.defaultValue && mode == 'restore') ? this.defaultValue : '';
        }
        this.fireEvent('change');
        return false;
    },

    resetFormElements: function(mode) {
        this.getElements('input, textarea, select').each(function(el) { el.resetFormElement(mode); }); 	//console.log((mode=='restore')?'RESET FORM ELEMENTS TO DEFAULTS':'CLEANUP/EMPTY FORM ELEMENTS');
    },

    lockFormElement: function(mode) {
        // don't freeze hidden inputs
        if (this.type == 'hidden') {
            return;
        };

        // WARNING: "readOnly" property in JS is case sensitive !!
        switch (mode) {
            case 'lock':
                this.disabled = true;
                break;

            case 'freeze':

                switch (this.get('tag')) {
                    case 'select':
                        this.disabled = true;
                        break;
                    case 'input':
                        if (['checkbox', 'radio'].contains(this.type) || ['submit', 'button'].contains(this.type)) {
                            this.disabled = true;
                            break;
                        }
                    case 'textarea':
                        this.readOnly = true;
                }
                break;

            case 'unfreeze':
            case 'unlock':
                if (this.disabled) this.disabled = false;
                if (this.readOnly) this.readOnly = false;
                break;
        }
        return false;
    },

    lockFormElements: function(mode) {
        this.getElements('input, textarea, select').each(
		    function(el) {
		        // [Daniele] don't change elements with constant state
		        if (!el.className.match('constantState'))
		            el.lockFormElement(mode);
		    });
    },

    /*backupValue: function(){
    switch(this.get('tag')){
    case 'select':
    Array.each(this.options, function(option){
    if (option.selected) option.presetValue = option.selected;
    });
    break;
    case 'input':
    if (['checkbox', 'radio'].contains(this.type) || ['hidden','submit','button'].contains(this.type)) {
    if (this.checked) this.presetValue = this.checked;
    break;
    }
    case 'textarea': if (this.value) this.presetValue = this.value;
    }
    return false;
    },*/

    /*backupFormElements: function(){
    this.getElements('input, textarea, select').each(function(el){ el.backupValue() });
    },*/

    /*resetValue: function(restore){
    switch(this.get('tag')){
    case 'select':
    Array.each(this.options, function(option){
    option.selected = (option.presetValue && restore) ? option.presetValue : false;
    });
    break;
    case 'input':
    if (['checkbox', 'radio'].contains(this.type) || ['hidden','submit','button'].contains(this.type)) {
    this.checked = (this.presetValue && restore) ? this.presetValue : false;
    break;
    }
    case 'textarea': this.value = (this.presetValue && restore) ? this.presetValue : '';
    }
    return false;
    },*/

    /*resetFormElements: function(restore){
    this.getElements('input, textarea, select').each(function(el){ el.resetValue(restore) });
    }*/

    // #####  DONT'T REMOVE  #####
    safari2hatesmissingcommas: function() { }
});