﻿var visualCalendar = visualCalendar || {
};

visualCalendar.Cal = (function () {  // visualCalendar.Helpers BEGIN
    // Private Fields 
    var _loadingHTMLFragment = '<img src="/media/img/Common/Ajax/Progress.gif" alt="" />';

    return {
        getAndRenderTooltip: getAndRenderTooltip,
        getAndRenderDiv: getAndRenderDiv
    };
     
    function render(calendarData) {

        if (!calendarData) return '---';

        var tableEl = new Element('table', {
            'class': 'calendarTable',
        });


        var headerRow = new Element('tr', {

        });

        var dataRow = new Element('tr', {

        });
        
        for (var i = 0; i < calendarData.days.length; i++)
        {
            var day = calendarData.days[i];

            var th = new Element('th', {
                html: day.label
            });

            var td = new Element('td', {
                
            });

            var dayheightpx = 200;

            var intervalContainerDiv = new Element('div', {
                'class': 'calendar-intervals-container'
            });

            intervalContainerDiv.setStyle('height', (dayheightpx) + 'px');
             
            for (var j = 0; j < day.intervals.length; j++)
            { 
                var interval = day.intervals[j];
                var top = dayheightpx * interval.from;
                var bottom = dayheightpx * (1 - interval.to);
                
                var intervalDiv = new Element('div', {
                    'class': 'calendar-interval ' + interval.cssClass
                });

                intervalDiv.setStyle('top', (top) + 'px');
                intervalDiv.setStyle('bottom', (bottom) + 'px');
                 
                intervalDiv.inject(intervalContainerDiv);
            }

            intervalContainerDiv.inject(td);

            th.inject(headerRow); 
            td.inject(dataRow); 
        }

        headerRow.inject(tableEl);
        dataRow.inject(tableEl);

        return tableEl;
    }
     
    function getAndRenderTooltip(alarmCategoryId, tip, debugViewDivId) {

        tip.setText(_loadingHTMLFragment);

        var ajax = new Request({
            url: '/AlarmsTimeframesInvocation.rix',
            timeout: 10000,
            onTimeout: function ()
            {
                var rendered = render(null);
                tip.setText(rendered);
                 
            },
            onComplete: function (response)
            {
                var jsonResponse = JSON.decode(response);
                var rendered = render(jsonResponse);

                if (debugViewDivId) {
                    var containerDiv = $(debugViewDivId);
                    containerDiv.empty();
                    rendered.inject(containerDiv);
                    return;
                }

                tip.setText(rendered);
                tip.toElement().setStyle('background-color', 'white');
                var renderedWidth = rendered.getStyle('width');
                tip.toElement().setStyle('width', 'calc(' + renderedWidth + ' + 10px)');
            }
        });

        ajax.send("modality=ajax&query=categoryId&id=" + alarmCategoryId);
    } 

    function getAndRenderDiv(divId,
        type, continuous,
        fromTimeH, fromTimeM, toTimeH, toTimeM,
        fromDayWeek, toDayWeek, fromDayMonth, toDayMonth)
    {

        var containerDiv = $(divId);
        containerDiv.innerHTML = _loadingHTMLFragment;

        var ajax = new Request({
            url: '/AlarmsTimeframesInvocation.rix',
            timeout: 10000,
            onTimeout: function () {
                var rendered = render(null);
                containerDiv.innerHTML = '';
                rendered.inject(containerDiv);
            },
            onComplete: function (response) {
                var jsonResponse = JSON.decode(response);
                var rendered = render(jsonResponse);
                containerDiv.innerHTML = '';
                rendered.inject(containerDiv);
            }
        });

        ajax.send("modality=ajax&query=timeframe&type=" + type + "&continuous=" + continuous + "&fromTimeH=" + fromTimeH +
            "&fromTimeM=" + fromTimeM + "&toTimeH=" + toTimeH + "&toTimeM=" + toTimeM + 
            "&fromDayWeek=" + fromDayWeek + "&toDayWeek=" + toDayWeek + "&fromDayMonth=" + fromDayMonth + "&toDayMonth=" + toDayMonth);
    }
})(); // visualCalendar.Helpers End